//
//  HomeBaseViewController.m
//  Ykly
//
//  Created by 郭超 on 2019/7/23.
//  Copyright © 2019 YingKeTravel co.,Ltd. All rights reserved.
//

#import "HomeBaseViewController.h"
#import "YNPageViewController.h"
#import "YNPageConfigration.h"
#import "YKHomeHeaderViewS.h"
#import "HomeHotDestinationVC.h"
#import "HomeSelectHotelVC.h"
#import "HomeSelectOptimalVC.h"
#import "YKHomeSearchView.h"
//#import "LineCategoryController.h"
//#import "YKHomeChangeCityController.h"
//#import "LocationInfo.h"
#import "HomeShowSubVCModel.h"
//#import "ScrollToTopBtn.h"
//#import "AlertMsgView.h"
#import "UIViewController+YNPageExtend.h"
//#import "AwButton.h"
//#import "HotelCouponView.h" // 弹框优惠券
//#import "CouponAlertModel.h" // 弹框优惠券model
//#import "CouponGetAlertModel.h" // 领取优惠券model
//#import "LoginViewController.h"

@interface HomeBaseViewController ()
<YNPageViewControllerDataSource,
YNPageViewControllerDelegate,
YKHomeSearchVDelegate,
CLLocationManagerDelegate>

@property (nonatomic, strong) YNPageViewController * vc;

@property (nonatomic, strong) YKHomeHeaderViewS *topViewS;

@property (nonatomic, strong) UIView *navView;

@property (nonatomic, strong) UIImageView *topShadowImgV;

@property (nonatomic, strong) UILabel *cityBtn;

@property (nonatomic, strong) YKHomeSearchView *homeSearchView;

/// 定位管理
@property (strong, nonatomic) CLLocationManager *locationManager;
/// 置顶按钮
//@property (nonatomic, strong) ScrollToTopBtn * toTopBtn;
/// 优惠券按钮
//@property (nonatomic, strong) AwButton * btnCoupon;

/**
 子控制器的状态数组，只要状态为1的
 */
@property (nonatomic, strong) NSMutableArray *subVCStateArray;
/// 优惠券引导弹框view
//@property (nonatomic, strong) HotelCouponView * couponView;
@end

@implementation HomeBaseViewController
- (void)viewWillAppear:(BOOL)animated {
    [super viewWillAppear:animated];
    [self.navigationController setNavigationBarHidden:YES animated:animated];
    // 通知 刷新 badgeNum
    [[NSNotificationCenter defaultCenter] postNotificationName:@"HomeAndMinViewWillAppearNotification" object:nil];
    if (self.topViewS.nearFutureCycleView) {
        [self.topViewS.nearFutureCycleView requestCollectionData];
    }
}

- (void)viewWillDisappear:(BOOL)animated {
    [super viewWillDisappear:animated];
    [self.navigationController setNavigationBarHidden:NO animated:animated];
}
- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.
    self.currentCity = @"北京";
    NSMutableArray *historyArr = [self getSelectHistoryFromLocal];
    if (historyArr.count) {
        NSDictionary *cityDict = historyArr[0];
        NSString *cityName = cityDict[@"city_name"];
        self.currentCity = cityName;
    }
    
    [self setupPageVC];
    [self setTextForCityLabel:self.currentCity];
    self.topViewS.currentCity = self.currentCity; // 和label赋值在一块
    [self creatToTopBtn];
    [self loadLocation];
    [self initCouponButton];
    //导航条
    [self setupNavigationSubViews];
    [self requestEnumVCTitles];
    
    //版本强制更新
//    [self checkUpdate];
    
//    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(loginLogoutRefresh) name:YKLoginSuccessWithNot object:nil];
//    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(loginLogoutRefresh) name:YKLogOutNotification object:nil];
//    /// 下方三个控制器的上拉刷新通知请求所有数据
//    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(headerRefresh) name:homeHeaderViewRefreshData object:nil];
//
//    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(loginHideCouponView) name:YKLoginSuccessWithNot object:nil];
    [self initCouponStatus];
}

/// 下拉刷新
- (void)headerRefresh {
    [self refreshSuperVCData];
}

- (void)loginLogoutRefresh {
    [self refreshSuperVCData];
}

- (void)refreshSuperVCData {
    [self.topViewS headerRefreshSubViewReuqest];
    [self requestEnumVCTitles];
}

- (void)requestEnumVCTitles {
    if (![YkTool isBlankString:self.currentCity]) return;
    
    NSString *url = [NSString stringWithFormat:@"%@v1/home/show-list", BASE_PHP_URL];
    NSDictionary *dict = @{@"position_city" : self.currentCity};
    NSDictionary *paramter = @{@"data" : dict};
    
    [[HttpRequest shareInstance] getWithHeaderDataPOST:url Paramter:paramter CacheKey:nil success:^(NSURLSessionDataTask *task, id responseObject) {
        NSLog(@"json === %@",[YkTool idToJson:responseObject]);
        if ([responseObject[@"flag"] integerValue] == 0) {
            NSDictionary *dataDict = responseObject[@"data"];
            NSArray *listArr = dataDict[@"list"];
            NSMutableArray *tmpSubArr = [NSMutableArray array];
            for (NSDictionary *dict in listArr) {
                HomeShowSubVCModel *stateInfo = [HomeShowSubVCModel mj_objectWithKeyValues:dict];
                if (stateInfo.state) [tmpSubArr addObject:stateInfo];
            }
            self.subVCStateArray = tmpSubArr;
            self.vc.controllersM = [NSMutableArray arrayWithArray:[self getArrayVCs]];
            self.vc.titlesM = [NSMutableArray arrayWithArray:[self getArrayTitles]];
            self.vc.config = [self ynToConfigration:[self getArrayVCs].count];
            [self.vc reloadData];
        }
    } failure:^(NSURLSessionDataTask *task, NSError *error) {
        [self.subVCStateArray removeAllObjects];
        self.vc.controllersM = [NSMutableArray arrayWithArray:[self getArrayVCs]];
        self.vc.titlesM = [NSMutableArray arrayWithArray:[self getArrayTitles]];
        self.vc.config = [self ynToConfigration:self.subVCStateArray.count];
        [self.vc reloadData];
    }];
}

#pragma mark - Coupon优惠券
- (void)initCouponButton {
    
//    [self.view addSubview:self.btnCoupon];
//    [self.btnCoupon mas_makeConstraints:^(MASConstraintMaker *make) {
//        make.top.equalTo(self.view).with.offset(kScreenHeight*0.5-57);
//        make.right.equalTo(self.view);
//        make.width.equalTo(@65);
//        make.height.equalTo(@57);
//    }];
//    [self.view bringSubviewToFront:self.btnCoupon];
}

- (void)clickCoupon {
//    KLog(@"点击优惠券");
    [self initCouponStatus];
}

/// 登录成功隐藏优惠券
- (void)loginHideCouponView {
    
//    if (self.couponView != nil) {
//        [self.couponView hideCouponView];
//    }
    // 获取优惠券
    [self getCouponData];
}

/// 获取领取优惠券
- (void)getCouponData {
//    KLog(@"获取优惠券");
//    NSMutableDictionary * dicM = @{}.mutableCopy;
//    NSDictionary * dic = @{
//    };
//    dicM[@"data"] = dic;
//    NSString * url = [NSString stringWithFormat:@"%@v1/coupon/coupon-code/check-draw-coupon", BASE_PHP_URL];
//    [[HttpRequest shareInstance] getWithHeaderDataPOST:url Paramter:dicM CacheKey:nil success:^(NSURLSessionDataTask *task, id responseObject) {
//
//        KLog(@"res = %@",responseObject);
//        if ([responseObject[@"flag"] intValue] == 0) {
//            CouponGetAlertModel * modelGet = [CouponGetAlertModel modelWithDictionary:responseObject[@"data"]];
//            if ([modelGet.is_show isEqualToString:@"1"]) {
//                /// 弹框领取成功
//                HotelCouponView * couponView = [[HotelCouponView alloc] initWithFrame:KFrame(0, 0, kScreenWidth, kScreenHeight)];
//                self.couponView = couponView;
//                CouponAlertModel * modelAlert = [CouponAlertModel new];
//                modelAlert.image_url = modelGet.image_url;
//                modelAlert.width = modelGet.width;
//                modelAlert.height = modelGet.height;
//                modelAlert.is_show = modelGet.is_show;
//                [couponView couponViewWithCouponModel:modelAlert];
//
//                if (self.isViewLoaded && self.view.window) {
//
//                }
//                self.btnCoupon.hidden = YES;
//            }
//
//            if (modelGet.status == -1) {
//                /// 领取过
//                self.btnCoupon.hidden = YES;
//            }
//
//        } else {
//            [[MBHud shareInstance] showHUDWithText:responseObject[@"msg"] view:self.view];
//        }
//
//    } failure:^(NSURLSessionDataTask *task, NSError *error) {
//    }];
}

/// 获取优惠券弹框状态
- (void)initCouponStatus {
    
//    if ([UserLoginTool getMemberID].length != 0) {
//        /// 1. 已登录 调用领取优惠券接口
//        [self getCouponData];
//        return;
//    }
//    /// 2. 未登录登录调用引导获取优惠券接口 -> 登陆成功 -> 领取优惠券
//    NSMutableDictionary * dicM = @{}.mutableCopy;
//    NSDictionary * dic = @{
//
//    };
//    dicM[@"data"] = dic;
//    NSString * url = [NSString stringWithFormat:@"%@v1/coupon/coupon-code/homepage-view", BASE_PHP_URL];
//    [[HttpRequest shareInstance] getWithHeaderDataPOST:url Paramter:dicM CacheKey:nil success:^(NSURLSessionDataTask *task, id responseObject) {
//
//        if ([responseObject[@"flag"] intValue] == 0) {
//            CouponAlertModel * model = [CouponAlertModel modelWithDictionary:responseObject[@"data"]];
//            if ([model.is_show isEqualToString:@"1"]) {
//                // 弹框
//                if (self.isViewLoaded && self.view.window) {
//                    HotelCouponView * couponView = [[HotelCouponView alloc] initWithFrame:KFrame(0, 0, kScreenWidth, kScreenHeight)];
//                    self.couponView = couponView;
//                    [couponView couponViewWithCouponModel:model];
//                    [couponView setCouponViewShowLogin:^{
//                        LoginViewController *loginVC = [[LoginViewController alloc]init];
//                        UINavigationController* navController = [[UINavigationController alloc] initWithRootViewController:loginVC];
//                        navController.navigationBarHidden=YES;
//                        [self presentViewController:navController animated:YES completion:nil];
//                    }];
//                    [couponView setClickCloseAlertView:^{
//                        self.btnCoupon.hidden = NO;
//                    }];
//                }
//            }
//        } else {
//            [[MBHud shareInstance] showHUDWithText:responseObject[@"msg"] view:self.view];
//        }
//
//    } failure:^(NSURLSessionDataTask *task, NSError *error) {
//
//    }];
}

#pragma mark - 添加滑动到顶部的按钮
- (void)creatToTopBtn {
    
//    self.toTopBtn = [[ScrollToTopBtn alloc] initInView:self.view WithBottomHeight:150 + SafeAreaBottomHeight +64];
//    self.toTopBtn.hidden = YES;
//    self.toTopBtn.historyBtn.hidden = YES;
//    @weakify(self);
//    [[self.toTopBtn rac_signalForControlEvents:UIControlEventTouchUpInside] subscribeNext:^(id x) {
//        @strongify(self);
//        [self.vc scrollToTop:YES];
//    }];
}

- (void)setupNavigationSubViews {
    
    [self.view addSubview:self.topShadowImgV];
    [self.topShadowImgV mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.left.right.mas_equalTo(self.view);
        make.height.mas_equalTo(SafeAreaTopHeight);
    }];
    
    [self.view addSubview:self.navView];
    [self.navView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.left.right.mas_equalTo(self.view);
        make.height.mas_equalTo(SafeAreaTopHeight);
    }];
    
    [self.navView addSubview:self.cityBtn];
    [self.cityBtn mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.mas_equalTo(self.navView.mas_left).offset(12);
        make.bottom.mas_equalTo(self.navView.mas_bottom).offset(-10);
        make.height.mas_equalTo(24);
//        make.width.mas_equalTo(60);
    }];
    
    [self.navView addSubview:self.homeSearchView];
    [self.homeSearchView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.mas_equalTo(self.cityBtn.mas_right).offset(adaptX(6));
        make.right.mas_equalTo(self.navView.mas_right).offset(-15);
        make.height.mas_equalTo(34);
        make.centerY.mas_equalTo(self.cityBtn.mas_centerY);
    }];
}

- (void)setupPageVC {
    
    self.vc = [YNPageViewController pageViewControllerWithControllers:[self getArrayVCs] titles:[self getArrayTitles] config:[self ynToConfigration:0]];
    self.vc.dataSource = self;
    self.vc.delegate = self;
    self.topViewS = [[YKHomeHeaderViewS alloc] initWithFrame:CGRectMake(0, 0, kScreenWidth, adaptX(500))];
    self.topViewS.currentCity = self.currentCity;
    self.vc.headerView = self.topViewS;
    
    __weak typeof(self) weakSelf = self;
    __weak typeof(YNPageViewController *) weakVC = self.vc;
    self.topViewS.headerHeightBlock = ^(CGFloat height) {
        weakSelf.topViewS.frame = CGRectMake(0, 0, kScreenWidth, height);
        NSLog(@"NSStringFromCGRect(weakSelf.topViewS.frame) == %@",NSStringFromCGRect(weakSelf.topViewS.frame));
        weakVC.headerView.frame = CGRectMake(0, 0, kScreenWidth, height);
        weakVC.controllersM = [NSMutableArray arrayWithArray:[weakSelf getArrayVCs]];
        weakVC.titlesM = [NSMutableArray arrayWithArray:[weakSelf getArrayTitles]];
        weakVC.config = [weakSelf ynToConfigration:[weakSelf getArrayVCs].count];
        [weakVC reloadData];
//        dispatch_after(dispatch_time(DISPATCH_TIME_NOW, (int64_t)(0.3 * NSEC_PER_SEC)), dispatch_get_main_queue(), ^{
//            if (weakSelf.topViewS.x != 0 && weakSelf.topViewS.left != 0) {
//                weakSelf.topViewS.frame = CGRectMake(0, 0, kScreenWidth, height);
//            }
//        });
    };
    
    self.topViewS.changeSegmentBlock = ^(NSArray * _Nonnull array) {
        
    };
//    最好加上，直接刷新到底部，不用在初始化的时候算具体初始化高度了
    [self.topViewS refershTopSuperViewHeight];
    
    /// 作为自控制器加入到当前控制器
    [self.vc addSelfToParentViewController:self];
    
}
- (NSArray *)getArrayVCs {
    
    if ([YkTool checkArrayIsValided:self.subVCStateArray]) {

        NSMutableArray *subVCArr = [NSMutableArray array];
        for (HomeShowSubVCModel *model in self.subVCStateArray) {
            switch (model.type) {
                case 1:
                    if (model.state) {
                        HomeHotDestinationVC *vc_1 = [[HomeHotDestinationVC alloc] init];
                        vc_1.currentCity = self.currentCity;
                        [subVCArr addObject:vc_1];
                    }
                    break;
                case 2:
                    if (model.state) {
                        HomeSelectHotelVC *vc_2 = [[HomeSelectHotelVC alloc] init];
                        vc_2.currentCity = self.currentCity;
                        [subVCArr addObject:vc_2];
                    }
                    break;
                case 3:
                    if (model.state) {
                        HomeSelectOptimalVC *vc_3 = [[HomeSelectOptimalVC alloc] init];
                        vc_3.currentCity = self.currentCity;
                        [subVCArr addObject:vc_3];
                    }
                    break;
                default:
                    break;
            }
        }
        return subVCArr;
    }else{
        
        HomeHotDestinationVC *vc_1 = [[HomeHotDestinationVC alloc] init];
        vc_1.currentCity = @"什么都没";
        return @[vc_1];
    }
}

- (NSArray *)getArrayTitles {
    if ([YkTool checkArrayIsValided:self.subVCStateArray]) {
        NSMutableArray *subTitleArr = [NSMutableArray array];
        for (HomeShowSubVCModel *model in self.subVCStateArray) {
            switch (model.type) {
                case 1:
                    if (model.state) [subTitleArr addObject:[NSString stringWithFormat:@"   %@   ",model.name]];
                    break;
                case 2:
                    if (model.state) [subTitleArr addObject:[NSString stringWithFormat:@"   %@   ",model.name]];
                    break;
                case 3:
                    if (model.state) [subTitleArr addObject:[NSString stringWithFormat:@"   %@   ",model.name]];
                    break;
                default:
                    break;
            }
        }
        return subTitleArr;
    }else{
        return @[@""];
    }
}

#pragma mark - 刷新mj的位置
- (void)reloadMjTopToType:(NSInteger)type VC:(UIViewController *)VC
{
    switch (type) {
        case 1:
        {
            HomeHotDestinationVC * destinationVC = (HomeHotDestinationVC *)VC;
            destinationVC.listCV.mj_header.height = SafeAreaTopHeight;
            destinationVC.listCV.mj_header.ignoredScrollViewContentInsetTop = self.topViewS.height + 44;
        }
            break;
        case 2:
        {
            HomeSelectHotelVC * selectHotelVC = (HomeSelectHotelVC *)VC;
            selectHotelVC.listCV.mj_header.height = SafeAreaTopHeight;
            selectHotelVC.listCV.mj_header.ignoredScrollViewContentInsetTop = self.topViewS.height + 44;
        }
            break;
        case 3:
        {
            HomeSelectOptimalVC * selectOptimalVC = (HomeSelectOptimalVC *)VC;
            selectOptimalVC.listCV.mj_header.height = SafeAreaTopHeight;
            selectOptimalVC.listCV.mj_header.ignoredScrollViewContentInsetTop = self.topViewS.height + 44;
        }
            break;
        default:
            break;
    }
}

#pragma mark - YNPageViewControllerDataSource
- (UIScrollView *)pageViewController:(YNPageViewController *)pageViewController pageForIndex:(NSInteger)index {
    __weak typeof(self) weakSelf = self;
    if ([YkTool checkArrayIsValided:self.subVCStateArray]) {
        UIViewController *vc = pageViewController.controllersM[index];

        for (HomeShowSubVCModel *stateInfo in self.subVCStateArray) {
            if (stateInfo.type == 1) {
                HomeHotDestinationVC * destinationVC = (HomeHotDestinationVC *)vc;
                destinationVC.currentCity = self.currentCity;
                destinationVC.statWithDataSuccess = ^{
                    [self reloadMjTopToType:stateInfo.type VC:vc];
                };
                return [destinationVC listCV];
            } else if (stateInfo.type == 2) {
                HomeSelectHotelVC * selectHotelVC = (HomeSelectHotelVC *)vc;
                selectHotelVC.currentCity = self.currentCity;
                selectHotelVC.statWithDataSuccess = ^{
                    [self reloadMjTopToType:stateInfo.type VC:vc];
                };
                return [selectHotelVC listCV];
            } else if (stateInfo.type == 3) {
                HomeSelectOptimalVC * selectOptimalVC = (HomeSelectOptimalVC *)vc;
                selectOptimalVC.currentCity = self.currentCity;
                selectOptimalVC.statWithDataSuccess = ^{
                    [self reloadMjTopToType:stateInfo.type VC:vc];
                };
                return [selectOptimalVC listCV];
            }
        }
        {
            HomeSelectOptimalVC * selectOptimalVC = (HomeSelectOptimalVC *)vc;
            selectOptimalVC.currentCity = self.currentCity;
            selectOptimalVC.statWithDataSuccess = ^{
                [self reloadMjTopToType:3 VC:vc]; // type是后台返的
            };
            return [selectOptimalVC listCV];
        }

    }else{
        UIViewController *vc = pageViewController.controllersM[index];
        HomeHotDestinationVC * destinationVC = (HomeHotDestinationVC *)vc;
        destinationVC.currentCity = self.currentCity;
        [self reloadMjTopToType:1 VC:vc];
        destinationVC.currentCity = @"什么都没";
        return [destinationVC listCV];
    }
}

#pragma mark - YNPageViewControllerDelegate
- (void)pageViewController:(YNPageViewController *)pageViewController
            contentOffsetY:(CGFloat)contentOffset
                  progress:(CGFloat)progress {
//    NSLog(@"--- contentOffset = %f, progress = %f", contentOffset, progress);
    
    if (progress >= 1) {
//        self.toTopBtn.hidden = NO;
    } else {
//        self.toTopBtn.hidden = YES;
    }
    self.navView.backgroundColor = [UIColor colorWithHexString:@"C31F9B"];
    if (progress > 0.01) {
        self.topShadowImgV.hidden = YES;
    } else {
        self.topShadowImgV.hidden = NO;
    }
}

-(void)loadLocation{
    
    if([CLLocationManager locationServicesEnabled] && ([CLLocationManager authorizationStatus] == kCLAuthorizationStatusAuthorizedWhenInUse || [CLLocationManager authorizationStatus] == kCLAuthorizationStatusNotDetermined || [CLLocationManager authorizationStatus] == kCLAuthorizationStatusAuthorizedAlways)) {
        //定位初始化
        _locationManager = [[CLLocationManager alloc] init];
        _locationManager.delegate = self;
        _locationManager.desiredAccuracy = kCLLocationAccuracyBest;
        _locationManager.distanceFilter = 10;
        [_locationManager startUpdatingLocation];//开启定位
    }else {
        //提示用户无法进行定位操作
        UIAlertController * alert = [UIAlertController alertControllerWithTitle:@"定位失败,请检查定位设置后重新定位" message:nil preferredStyle:UIAlertControllerStyleAlert];
        UIAlertAction * action1    = [UIAlertAction actionWithTitle:@"确定" style:UIAlertActionStyleDefault handler:^(UIAlertAction * _Nonnull action) {
            //点击确定 跳转到设置界面
            NSURL *url = [NSURL URLWithString:UIApplicationOpenSettingsURLString];
            if ([[UIApplication sharedApplication] canOpenURL:url]) {
                [[UIApplication sharedApplication] openURL:url options:[NSMutableDictionary dictionary] completionHandler:nil];
            }
            if ([[UIApplication sharedApplication] canOpenURL:url]) {
                [[UIApplication sharedApplication] openURL:url options:@{} completionHandler:^(BOOL success) {
                    NSLog(@"success");
                }];
            }
        }];
        UIAlertAction * action2    = [UIAlertAction actionWithTitle:@"取消" style:UIAlertActionStyleCancel handler:^(UIAlertAction * _Nonnull action) {
        }];
        [alert addAction:action1];
        [alert addAction:action2];
        
        [self presentViewController:alert animated:YES completion:nil];
        
    }
    
    if ([[[UIDevice currentDevice] systemVersion] floatValue] >=8) {
        [_locationManager requestWhenInUseAuthorization];//使用程序其间允许访问位置数据（iOS8定位需要）
    }
}

#pragma mark - 定位代理
- (void)locationManager:(CLLocationManager *)manager didUpdateLocations:(NSArray<CLLocation *> *)locations {
    // 获取当前所在的城市名
    CLGeocoder *geocoder = [[CLGeocoder alloc] init];
    // 当前经纬度
    CLLocation * currentLoc = locations[0];
    
    //根据经纬度反向地理编译出地址信息
    [geocoder reverseGeocodeLocation:currentLoc completionHandler:^(NSArray *array, NSError *error) {
        if (array.count > 0) {
            CLPlacemark *placemark = [array objectAtIndex:0];
            
//            KLog(@"name = %@, thoroughfare = %@, subThoroughfare= %@, locality = %@, subLocality = %@, administrativeArea = %@, subAdministrativeArea = %@", placemark.name, placemark.thoroughfare, placemark.subThoroughfare, placemark.locality, placemark.subLocality, placemark.administrativeArea, placemark.subAdministrativeArea);
            
            NSString * strLocDetail = [NSString stringWithFormat:@"%@%@%@",placemark.locality,placemark.subLocality,placemark.name];
            NSString *currentCity = placemark.locality ? placemark.locality : @"";
            
            [self refreshCurrentCityWith:currentCity];
            
        }
        
    }];
    //系统会一直更新数据，直到选择停止更新，因为我们只需要获得一次经纬度即可，所以获取之后就停止更新
    [manager stopUpdatingLocation];
}

/// 定位失败
- (void)locationManager:(CLLocationManager *)manager
       didFailWithError:(NSError *)error {}

/// 获取本地历史记录
- (NSMutableArray *)getSelectHistoryFromLocal {
    
    NSUserDefaults * userDef = [NSUserDefaults standardUserDefaults];
    NSMutableArray * arrHis = [userDef objectForKey:kHomeSelectedHistory_APPHome];
    NSArray * arr =  [arrHis copy];
    if (arr.count > KMaxSaveHistoryCount) {
        arr = [arr subarrayWithRange:NSMakeRange(0, KMaxSaveHistoryCount)];
        arrHis = [arr mutableCopy];
    }
    
    [userDef setObject:arrHis forKey:kHomeSelectedHistory_APPHome];
    [userDef synchronize];
    return arrHis;
}

/// 存储历史记录到本地
- (void)saveModelWith:(NSString *)cityName {
    //    app首页
    [self saveCity:cityName withKey:kHomeSelectedHistory_APPHome];
    //    跟团游首页
    [self saveCity:cityName withKey:kHomeSelectedHistory_TouristRoute];
    //    自由行首页
//    [self saveCity:cityName withKey:kHomeSelectedHistory_XNAV];
}

- (void)saveCity:(NSString *)cityName withKey:(NSString *)hostoryKey {
    NSUserDefaults * userDef = [NSUserDefaults standardUserDefaults];
    NSMutableArray * arrHistory = [NSMutableArray arrayWithArray:[userDef objectForKey:hostoryKey]];
    if (arrHistory == nil) {
        arrHistory = @[].mutableCopy;
    }
    for (int i = 0; i<arrHistory.count; i++) {
        NSDictionary * dic = arrHistory[i];
        if ([dic[@"city_name"] isEqualToString:cityName]) {
            [arrHistory removeObject:dic];
        }
    }
    
    NSDictionary * saveDict = @{@"city_name":cityName,};
    
    [arrHistory insertObject:saveDict atIndex:0];
    [userDef setObject:arrHistory forKey:hostoryKey];
    [userDef synchronize];
}

- (void)refreshCurrentCityWith:(NSString *)currentCity {
    if (currentCity.length > 1) {
        NSString *shiStr = [currentCity substringFromIndex:currentCity.length - 1];
        if ([shiStr isEqualToString:@"市"]) {
            currentCity = [currentCity substringToIndex:currentCity.length - 1];
        }
    }
    if ([self.currentCity isEqualToString:currentCity])return;
    NSMutableAttributedString *attStr = [[NSMutableAttributedString alloc] initWithString:@"定位到您在 " attributes:@{NSFontAttributeName : MYFONT(15), NSForegroundColorAttributeName : UIColorHex(4C4C4C)}];
    
    NSAttributedString *cityAtt = [[NSAttributedString alloc] initWithString:currentCity attributes:@{NSFontAttributeName : MYFONT(15), NSForegroundColorAttributeName : [UIColor colorWithHexString:PurpleColorHex]}];
    [attStr appendAttributedString:cityAtt];
    NSAttributedString *askAtt = [[NSAttributedString alloc] initWithString:@"\r\n是否切换该城市？" attributes:@{NSFontAttributeName : MYFONT(15), NSForegroundColorAttributeName : UIColorHex(4C4C4C)}];
    [attStr appendAttributedString:askAtt];
    // @"定位到您在 " currentCity @"\r\n是否切换该城市？"
    NSString * strAll = [NSString stringWithFormat:@"%@%@%@",@"定位到您在 ", currentCity, @"\r\n是否切换该城市？"];
    NSMutableParagraphStyle *paragraphStyle = [[NSMutableParagraphStyle alloc] init];
    [paragraphStyle setLineSpacing:10];
    [paragraphStyle setAlignment:NSTextAlignmentCenter];
    [attStr addAttribute:NSParagraphStyleAttributeName value:paragraphStyle range:NSMakeRange(0, [strAll length])];

    NSMutableAttributedString *confirmAtt = [[NSMutableAttributedString alloc] initWithString:@"切换" attributes:@{NSFontAttributeName : MYFONT(15), NSForegroundColorAttributeName : [UIColor colorWithHexString:PurpleColorHex]}];
    
//    AlertMsgView *alert = [[AlertMsgView alloc] initWithAttributeContent:attStr actionArributeTitle:confirmAtt withCallback:^{
//        self.currentCity = currentCity;
//        [self setTextForCityLabel:self.currentCity];
//        self.topViewS.currentCity = self.currentCity;
//        [self saveModelWith:self.currentCity];
//    }];
//    [alert addActionWtithActionTitle:@"取消" actionColor:UIColorHex(5D5D5D) actionFont:MYFONT(15) withCallback:^{}];
//    alert.frame = CGRectMake(0.5 * (kScreenWidth - 270), 0.5 * (kScreenHeight - 150), 270, 150);
//    alert.backgroundColor = [UIColor whiteColor];
//    alert.layer.cornerRadius = 10;
//    alert.layer.masksToBounds = YES;
//    [alert show];
    
}

- (void)setTextForCityLabel:(NSString *)cityName {
    
    [self requestEnumVCTitles];
    
    NSMutableAttributedString *attStr = [[NSMutableAttributedString alloc] initWithString:[NSString stringWithFormat:@"%@ ", cityName] attributes:@{NSFontAttributeName : MYFONT(15), NSForegroundColorAttributeName : UIColorHex(FFFFFF)}];
    NSTextAttachment *textAttachment = [[NSTextAttachment alloc] init];
    textAttachment.image = [UIImage imageNamed:@"Home_CityArrowWhite"];
    textAttachment.bounds = CGRectMake(0, 0, 12, 7);
    NSAttributedString *arrowStr = [NSAttributedString attributedStringWithAttachment:textAttachment];
    [attStr appendAttributedString:arrowStr];
    self.cityBtn.attributedText = attStr;
}

- (YNPageConfigration *)ynToConfigration:(NSInteger)count
{
    NSArray *titleArr = [self getArrayTitles];
    BOOL isEmpty = NO;
    if (titleArr.count == 1) {
        NSString *title = titleArr[0];
        isEmpty = title.length < 2 ? YES : NO;
    } else {
        isEmpty = NO;
    }
    if ((count == 1 && isEmpty) || count == 0) {
        YNPageConfigration * ynConfigration = [YNPageConfigration defaultConfig];
        ynConfigration.pageStyle = YNPageStyleSuspensionTop;
        ynConfigration.headerViewScaleMode = YNPageHeaderViewScaleModeTop;
        ynConfigration.menuHeight = 0;
        ynConfigration.showTabbar = YES;
        ynConfigration.showNavigation = NO;
        return ynConfigration;
    }else{
        YNPageConfigration * ynConfigration = [YNPageConfigration defaultConfig];
        ynConfigration = [YNPageConfigration defaultConfig];
        ynConfigration.pageStyle = YNPageStyleSuspensionTop;
        ynConfigration.headerViewScaleMode = YNPageHeaderViewScaleModeTop;
        ynConfigration.scrollMenu = NO;
        ynConfigration.aligmentModeCenter = YES;
        ynConfigration.showScrollLine = NO;
        ynConfigration.itemLeftAndRightMargin = adaptX(20);
        ynConfigration.suspenOffsetY = SafeAreaTopHeight;
        ynConfigration.itemMargin = (kScreenWidth - adaptX(100) - adaptX(83) * 2 - adaptX(20) * 2)/count-1;
        ynConfigration.menuHeight = 60;
        ynConfigration.showTabbar = YES;
        ynConfigration.showNavigation = NO;
        NSMutableArray *buttonArrayM = @[].mutableCopy;
        for (int i = 0; i < count; i++) {
            UIButton *button = [UIButton buttonWithType:UIButtonTypeCustom];
            [button setBackgroundImage:[UIImage imageNamed:@""] forState:UIControlStateNormal];
            [button setBackgroundImage:[UIImage imageNamed:@"YKHomeViewController_Select_normal"] forState:UIControlStateSelected];
            
            [buttonArrayM addObject:button];
        }
        ynConfigration.buttonArray = buttonArrayM;
        ynConfigration.normalItemColor = UIColorHex(666666);
        ynConfigration.selectedItemColor = [UIColor colorWithHexString:PurpleColorHex];
        ynConfigration.itemFont = kPingFangRegular(15);
        ynConfigration.selectedItemFont = kPingFangRegular(15);
        return ynConfigration;
    }
}

#pragma mark - HomeSearchViewDelegate
- (void)pushSearchController {
//    LineCategoryController * vc = [LineCategoryController new];
//    vc.departure_city = self.currentCity;
//    [self.navigationController pushViewController:vc animated:YES];
}

#pragma mark - YKHomeChangeCityControllerDelegate
- (void)changeCitySaveCityName:(NSString *)cityName {
    [self saveModelWith:cityName];
}

- (void)cityBtnAction:(UITapGestureRecognizer *)sender {
    
//    YKHomeChangeCityController * changeCityVc = [YKHomeChangeCityController new];
//    changeCityVc.delegate = self;
//    changeCityVc.pushVCType = HomeChangeCityVCType_APPHome;
//    changeCityVc.cityName = self.currentCity;
//    [self.navigationController pushViewController:changeCityVc animated:YES];
//    [changeCityVc setClickCityCallback:^(CityListCallbackModel * _Nonnull model) {
//        [self.vc setSelectedPageIndex:0];
//        [self.vc scrollToTop:YES];
//        dispatch_after(dispatch_time(DISPATCH_TIME_NOW, (int64_t)(.5 * NSEC_PER_SEC)), dispatch_get_main_queue(), ^{
//            self.currentCity = model.city_name;
//            self.topViewS.currentCity = model.city_name;
//            [self setTextForCityLabel:self.currentCity];
//            self.topViewS.currentCity = self.currentCity;
//            for (int i = 0; i<self.vc.controllersM.count; i++) {
//                UIViewController *vc = self.vc.controllersM[i];
//                if (i == 0) {
//                    HomeHotDestinationVC * destinationVC = (HomeHotDestinationVC *)vc;
//                    destinationVC.currentCity = self.currentCity;
//                    [destinationVC statWithData:1];
//                }else if (i == 1){
//                    HomeSelectHotelVC * selectHotelVC = (HomeSelectHotelVC *)vc;
//                    selectHotelVC.currentCity = self.currentCity;
//                    [selectHotelVC statWithData:1];
//                }else{
//                    HomeSelectOptimalVC * selectOptimalVC = (HomeSelectOptimalVC *)vc;
//                    selectOptimalVC.currentCity = self.currentCity;
//                    [selectOptimalVC statWithData:1];
//                }
//            }
//        });
//
//    }];
}

#pragma mark - 检查更新
- (void)checkUpdate{
    
    NSDictionary *infoDic = [[NSBundle mainBundle] infoDictionary];
    NSString *currentVersionStr = infoDic[@"CFBundleShortVersionString"];
    NSArray *strArr = [currentVersionStr componentsSeparatedByString:@"."];
    NSString *str = [strArr componentsJoinedByString:@""];
    //本地APP版本号
    int currentVersionNum = [str intValue];
    //服务端需要强制更新的APP版本号
    NSString *uptdateUrlStr = [NSString stringWithFormat:@"%@version/getAppVersion?version_type=3", BASE_URL];
    [[HttpRequest shareInstance] getDataGET:uptdateUrlStr CacheKey:nil success:^(NSURLSessionDataTask *task, id responseObject) {
        if ([responseObject[@"flag"] integerValue] == 0) {
            if ([responseObject[@"data"] isKindOfClass:[NSDictionary class]]) {
                NSDictionary *dict = responseObject[@"data"];
                //version_no值大于本地 则提示更新弹窗
                if (currentVersionNum < [dict[@"version_no"] integerValue]) {
                    //is_update为1或2 且 force_code值大于本地 为强制更新
                    if ([dict[@"is_update"] integerValue] == 1 || [dict[@"is_update"] integerValue] == 2) {
                        if (currentVersionNum < [dict[@"force_code"] integerValue]) {
                            //强制更新
                            UIAlertController *alert = [UIAlertController alertControllerWithTitle:@"更新提示" message:@"请点击确定升级到最新版本" preferredStyle:(UIAlertControllerStyleAlert)];
                            [alert addAction:[UIAlertAction actionWithTitle:@"确定" style:UIAlertActionStyleDefault handler:^(UIAlertAction * _Nonnull action) {
                                [self goUpdatewithExit:YES];
                            }]];
                            [alert addAction:[UIAlertAction actionWithTitle:@"取消" style:UIAlertActionStyleDefault handler:^(UIAlertAction * _Nonnull action) {
                                [self exitApplication];
                            }]];
                            [self presentViewController:alert animated:YES completion:nil];
                        }
                    }else{
                        //不强制更新
                        UIAlertController *alert = [UIAlertController alertControllerWithTitle:@"更新提示" message:@"请点击确定升级到最新版本" preferredStyle:UIAlertControllerStyleAlert];
                        [alert addAction:[UIAlertAction actionWithTitle:@"确定" style:UIAlertActionStyleDefault handler:^(UIAlertAction * _Nonnull action) {
                            [self goUpdatewithExit:NO];
                        }]];
                        [alert addAction:[UIAlertAction actionWithTitle:@"取消" style:UIAlertActionStyleDefault handler:^(UIAlertAction * _Nonnull action) {
                        }]];
                        [self presentViewController:alert animated:YES completion:nil];
                    }
                }
            }
        }
    } failure:^(NSURLSessionDataTask *task, NSError *error) {
    }];
}

//去更新
- (void)goUpdatewithExit:(BOOL)isExit {
    [[UIApplication sharedApplication] openURL:[NSURL URLWithString:@"https://itunes.apple.com/cn/app/id1119093908?mt=8"] options:@{} completionHandler:^(BOOL success) {
        if (isExit) {
            [self exitApplication];
        }
    }];
}

//退出程序
- (void)exitApplication{
     #pragma clang diagnostic push
     #pragma clang diagnostic ignored "-Wundeclared-selector"
     //运行一个不存在的方法,退出界面更加圆滑
//    exit(0);
     [self performSelector:@selector(notExistCall)];
     abort();
     #pragma clang diagnostic pop
}

#pragma mark - 自定义导航栏
- (UIView *)navView {
    if (!_navView) {
        _navView = [[UIView alloc] initWithFrame:CGRectMake(0, 0, kScreenWidth, SafeAreaTopHeight)];
        _navView.backgroundColor = [UIColor colorWithHexString:@"C31F9B"];
    }
    return _navView;
}

- (UILabel *)cityBtn {
    if (!_cityBtn) {
        _cityBtn = [[UILabel alloc] init];
        _cityBtn.backgroundColor = [UIColor clearColor];
        _cityBtn.font = kPingFangMedium(15);
        _cityBtn.textColor = UIColorHex(FFFFFF);

//        [_cityBtn x_GestureWithSelector:@selector(cityBtnAction:) responseTarget:self];
    }
    return _cityBtn;
}

- (YKHomeSearchView *)homeSearchView {
    if (!_homeSearchView) {
        _homeSearchView = [[YKHomeSearchView alloc] init];
        _homeSearchView.delegate = self;
//        self.navigationItem.titleView = homeSearchView;
    }
    return _homeSearchView;
}

- (UIImageView *)topShadowImgV {
    if (!_topShadowImgV) {
        _topShadowImgV = [[UIImageView alloc] init];
        _topShadowImgV.image = [UIImage imageNamed:@"home_top_shadow_img"];
        _topShadowImgV.backgroundColor = [UIColor clearColor];
    }
    return _topShadowImgV;
}

- (NSMutableArray *)subVCStateArray {
    if (!_subVCStateArray) {
        _subVCStateArray = [[NSMutableArray alloc] init];
    }
    return _subVCStateArray;
}

//- (AwButton *)btnCoupon {
//    if (!_btnCoupon) {
//        _btnCoupon = [AwButton buttonWithType:UIButtonTypeSystem];
//        _btnCoupon.hidden = YES;
//        [_btnCoupon setBackgroundImage:kImageNamed(@"home_coupon_icon") forState:UIControlStateNormal];
//        [_btnCoupon addTarget:self action:@selector(clickCoupon) forControlEvents:UIControlEventTouchUpInside];
//    }
//    return _btnCoupon;
//}

@end
