//
//  HomeSelectHotelVC.m
//  Ykly
//
//  Created by 郭超 on 2019/7/22.
//  Copyright © 2019 YingKeTravel co.,Ltd. All rights reserved.
//

#import "HomeSelectHotelVC.h"
#import "HomeSelectHotelCell.h"
//#import "HotelDeatilViewController.h"
#import "MyFlowLayout.h"
@interface HomeSelectHotelVC ()<UICollectionViewDelegate,UICollectionViewDataSource>
/**
 * ListCV
 */
@property (nonatomic, strong) NSMutableArray * listArray;
@property (nonatomic, assign) NSInteger pageInt;

@end


@implementation HomeSelectHotelVC

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.
    
    self.view.backgroundColor = [UIColor whiteColor];
    
    [self.view addSubview:self.listCV];
    [self.listCV mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.left.right.bottom.mas_equalTo(self.view);
        //        make.bottom.mas_equalTo(-SafeAreaBottomHeight);
    }];
    
    //addMj
    [self addMj];
    
    // 加载数据
    [self statWithData:1];
}
- (void)addMj
{
    __weak typeof (self) weakSelf = self;
    
    MJRefreshNormalHeader * header = [MJRefreshNormalHeader headerWithRefreshingBlock:^{
        
        [[NSNotificationCenter defaultCenter] postNotificationName:homeHeaderViewRefreshData object:nil];
        [self statWithData:1];
        
//        dispatch_after(dispatch_time(DISPATCH_TIME_NOW, (int64_t)(5 * NSEC_PER_SEC)), dispatch_get_main_queue(), ^{
//            [weakSelf.listCV.mj_header endRefreshing];
//
//        });
    }];
    header.lastUpdatedTimeLabel.hidden = YES;
    
    self.listCV.mj_header = header ;
    
    
    self.listCV.mj_footer = [MJRefreshBackNormalFooter footerWithRefreshingBlock:^{
        [self statWithData:self.pageInt];
    }];
    
}
- (void)statWithData:(NSInteger)pageInt
{
    self.pageInt = pageInt;
    NSString * url = [NSString stringWithFormat:@"%@v1/home/chosen-hotel",BASE_PHP_URL];
    NSMutableDictionary * paramter = [NSMutableDictionary dictionary];
    NSMutableDictionary * data = [NSMutableDictionary dictionary];
    data[@"position_city"] = self.currentCity;
    data[@"page"] = [NSString stringWithFormat:@"%ld",self.pageInt];
    data[@"page_size"] = @"20";
    paramter[@"data"] = data;
    url = [url stringByAddingPercentEncodingWithAllowedCharacters:[NSCharacterSet URLQueryAllowedCharacterSet]];
    [[HttpRequest shareInstance] getWithHeaderDataPOST:url Paramter:paramter CacheKey:nil success:^(NSURLSessionDataTask *task, id responseObject) {
//        [[MBHud shareInstance] hiddenHUDTitle:@""];
        NSLog(@"首页推荐酒店 === %@",[YkTool idToJson:responseObject]);
        if ([responseObject[@"flag"] integerValue] == 0) {
            NSMutableDictionary * data = responseObject[@"data"];
            NSMutableArray * list = data[@"list"];
            if (pageInt == 1) {
                [self.listArray removeAllObjects];
            }
            for (NSMutableDictionary * dic in list) {
                HomeSelectHotelModel * model = [HomeSelectHotelModel mj_objectWithKeyValues:dic];
                [self.listArray addObject:model];
            }
            if (list.count<20) {
                [self.listCV.mj_footer endRefreshingWithNoMoreData];
            }else{
            }
            
            self.pageInt ++;
            if (self.statWithDataSuccess) {
                self.statWithDataSuccess();
            }
        }else{
//            [[MBHud shareInstance] showHUDWithText:responseObject[@"msg"] view:self.view];
        }
        [self endRefreshing];
        [self.listCV reloadData];
    } failure:^(NSURLSessionDataTask *task, NSError *error) {
        [self endRefreshing];
//        [[MBHud shareInstance] hiddenHUDTitle:@""];
//        [[MBHud shareInstance] showHUDWithText:@"加载失败 请稍后重试" view:self.view];
    }];
    
}

- (void)endRefreshing {
    [self.listCV.mj_header endRefreshing];
    [self.listCV.mj_footer endRefreshing];
}

#pragma mark  设置CollectionView的组数
- (NSInteger)numberOfSectionsInCollectionView:(UICollectionView *)collectionView
{
    return 1;
}
- (NSInteger)collectionView:(UICollectionView *)collectionView numberOfItemsInSection:(NSInteger)section
{
    self.listCV.mj_footer.hidden = self.listArray.count == 0;
    return self.listArray.count;
}
- (UICollectionViewCell *)collectionView:(UICollectionView *)collectionView cellForItemAtIndexPath:(NSIndexPath *)indexPath
{
    static NSString *identify = @"HomeSelectHotelCell";
    HomeSelectHotelCell *cell = [collectionView dequeueReusableCellWithReuseIdentifier:identify forIndexPath:indexPath];
    cell.cellIndex = indexPath.row;
    cell.model = self.listArray[indexPath.row];
    return cell;
}
-(void)collectionView:(UICollectionView *)collectionView didSelectItemAtIndexPath:(NSIndexPath *)indexPath{
//    HomeSelectHotelModel * model = self.listArray[indexPath.row];
//    HotelDeatilViewController *next = [[HotelDeatilViewController alloc] init];
//    //获取今天日期
//    NSDateFormatter *formatter = [[NSDateFormatter alloc] init];
//    formatter.dateFormat = @"yyyy-MM-dd";
//    NSDate *date = [NSDate date];
//    NSString *comeDateStr = [formatter stringFromDate:date];
//    NSLog(@"comeDateStr--%@",comeDateStr);
//    NSString *leaveDateStr = [YkTool foo:comeDateStr afterDay:1];
//    NSLog(@"leaveDateStr--%@",leaveDateStr);
//    next.check_in_date = comeDateStr;
//    next.check_out_date = leaveDateStr;
//    next.hotelID = model.hotel_id;
//    [self.navigationController pushViewController:next animated:YES];
}

- (UICollectionView *)listCV {
    if (!_listCV) {
        MyFlowLayout *listLayout = [[MyFlowLayout alloc] init];
        listLayout.scrollDirection = UICollectionViewScrollDirectionVertical;
        // 最小行间距，默认是0
        listLayout.minimumLineSpacing = adaptX(10);
        // 最小左右间距，默认是10
        listLayout.minimumInteritemSpacing = adaptX(10);
        // 区域内间距，默认是 UIEdgeInsetsMake(0, 0, 0, 0)
        listLayout.sectionInset = UIEdgeInsetsMake(5, 12, 20, 12);
        // 预估高度
        listLayout.estimatedItemSize = CGSizeMake((kScreenWidth - 3 * 12)/2, 300);
        
        _listCV = [[UICollectionView alloc] initWithFrame:CGRectMake(0, 0, 0, 0) collectionViewLayout:listLayout];
        _listCV.backgroundColor = [UIColor whiteColor];
        _listCV.layer.masksToBounds = YES;
        _listCV.delegate = self;
        _listCV.dataSource = self;
        _listCV.showsVerticalScrollIndicator = NO;
        [_listCV registerClass:[HomeSelectHotelCell class] forCellWithReuseIdentifier:@"HomeSelectHotelCell"];
        
    }
    return _listCV;
}

- (NSMutableArray *)listArray
{
    if (!_listArray) {
        _listArray = [NSMutableArray array];
    }return _listArray;
}

@end
