//
//  HomeSelectOptimalVC.m
//  Ykly
//
//  Created by 郭超 on 2019/7/22.
//  Copyright © 2019 YingKeTravel co.,Ltd. All rights reserved.
//

#import "HomeSelectOptimalVC.h"
#import "HomeSelectOptimalCell.h"
//#import "YKOptimalDeatilController.h"
#import "MyFlowLayout.h"
@interface HomeSelectOptimalVC ()<UICollectionViewDelegate,UICollectionViewDataSource>
/**
 * ListCV
 */
@property (nonatomic, strong) NSMutableArray * listArray;
@property (nonatomic, assign) NSInteger pageInt;

@end

@implementation HomeSelectOptimalVC

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.
    
    self.view.backgroundColor = [UIColor whiteColor];
    
    [self.view addSubview:self.listCV];
    [self.listCV mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.left.right.bottom.mas_equalTo(self.view);
        //        make.bottom.mas_equalTo(-SafeAreaBottomHeight);
    }];
    // 加载数据
    [self statWithData:1];
    [self addMj];
}
- (void)addMj
{
    __weak typeof (self) weakSelf = self;
    
    MJRefreshNormalHeader * header = [MJRefreshNormalHeader headerWithRefreshingBlock:^{
        
        [[NSNotificationCenter defaultCenter] postNotificationName:homeHeaderViewRefreshData object:nil];
        [self statWithData:1];
//        dispatch_after(dispatch_time(DISPATCH_TIME_NOW, (int64_t)(5 * NSEC_PER_SEC)), dispatch_get_main_queue(), ^{
//            [weakSelf.listCV.mj_header endRefreshing];
//
//        });
    }];
    header.lastUpdatedTimeLabel.hidden = YES;
    
    self.listCV.mj_header = header ;
    
    self.listCV.mj_footer = [MJRefreshBackNormalFooter footerWithRefreshingBlock:^{
        [self statWithData:self.pageInt];
    }];
    
}
- (void)statWithData:(NSInteger)pageInt
{
    self.pageInt = pageInt;
    NSString * url = [NSString stringWithFormat:@"%@v1/home/mall",BASE_PHP_URL];
    NSMutableDictionary * paramter = [NSMutableDictionary dictionary];
    NSMutableDictionary * data = [NSMutableDictionary dictionary];
    data[@"position_city"] = self.currentCity;
    data[@"page"] = [NSString stringWithFormat:@"%ld",self.pageInt];
    data[@"page_size"] = @"20";
    paramter[@"data"] = data;
    url = [url stringByAddingPercentEncodingWithAllowedCharacters:[NSCharacterSet URLQueryAllowedCharacterSet]];
    [[HttpRequest shareInstance] getWithHeaderDataPOST:url Paramter:paramter CacheKey:nil success:^(NSURLSessionDataTask *task, id responseObject) {
//        [[MBHud shareInstance] hiddenHUDTitle:@""];
        NSLog(@"首页推荐酒店 === %@",[YkTool idToJson:responseObject]);
        if ([responseObject[@"flag"] integerValue] == 0) {
            NSMutableDictionary * data = responseObject[@"data"];
            NSMutableArray * list = data[@"list"];
            if (pageInt == 1) {
                [self.listArray removeAllObjects];
            }
            for (NSMutableDictionary * dic in list) {
                HomeSelectOptimalModel * model = [HomeSelectOptimalModel mj_objectWithKeyValues:dic];
                [self.listArray addObject:model];
            }
            if (list.count<20) {
                [self.listCV.mj_footer endRefreshingWithNoMoreData];
            }else{
                
            }
            
            self.pageInt ++;

            if (self.statWithDataSuccess) {
                self.statWithDataSuccess();
            }
        }else{
//            [[MBHud shareInstance] showHUDWithText:responseObject[@"msg"] view:self.view];
        }
        [self endRefreshing];
        [self.listCV reloadData];
    } failure:^(NSURLSessionDataTask *task, NSError *error) {
//        [[MBHud shareInstance] hiddenHUDTitle:@""];
//        [[MBHud shareInstance] showHUDWithText:@"加载失败 请稍后重试" view:self.view];
        [self endRefreshing];
    }];
    
}

- (void)endRefreshing {
    [self.listCV.mj_header endRefreshing];
    [self.listCV.mj_footer endRefreshing];
}

#pragma mark  设置CollectionView的组数
- (NSInteger)numberOfSectionsInCollectionView:(UICollectionView *)collectionView
{
    return 1;
}
- (NSInteger)collectionView:(UICollectionView *)collectionView numberOfItemsInSection:(NSInteger)section
{
    self.listCV.mj_footer.hidden = self.listArray.count == 0;
    return self.listArray.count;
}
- (UICollectionViewCell *)collectionView:(UICollectionView *)collectionView cellForItemAtIndexPath:(NSIndexPath *)indexPath
{
    static NSString *identify = @"HomeSelectOptimalCell";
    HomeSelectOptimalCell *cell = [collectionView dequeueReusableCellWithReuseIdentifier:identify forIndexPath:indexPath];
    cell.model = self.listArray[indexPath.row];
    return cell;
}
-(void)collectionView:(UICollectionView *)collectionView didSelectItemAtIndexPath:(NSIndexPath *)indexPath{
//    HomeSelectOptimalModel * model = self.listArray[indexPath.row];
//    YKOptimalDeatilController *next = [[YKOptimalDeatilController alloc] init];
//    next.productId = model.product_id;
//    [self.navigationController pushViewController:next animated:YES];

}

- (UICollectionView *)listCV {
    if (!_listCV) {
        MyFlowLayout *listLayout = [[MyFlowLayout alloc] init];
        listLayout.scrollDirection = UICollectionViewScrollDirectionVertical;
        // 最小行间距，默认是0
        listLayout.minimumLineSpacing = adaptX(10);
        // 最小左右间距，默认是10
        listLayout.minimumInteritemSpacing = adaptX(10);
        // 区域内间距，默认是 UIEdgeInsetsMake(0, 0, 0, 0)
        listLayout.sectionInset = UIEdgeInsetsMake(5, 12, 20, 12);
        // 预估高度
        listLayout.estimatedItemSize = CGSizeMake((kScreenWidth - 3 * 12)/2, 300);
        
        _listCV = [[UICollectionView alloc] initWithFrame:CGRectMake(0, 0, 0, 0) collectionViewLayout:listLayout];
        _listCV.backgroundColor = [UIColor whiteColor];
        _listCV.layer.masksToBounds = YES;
        _listCV.delegate = self;
        _listCV.dataSource = self;
        _listCV.showsVerticalScrollIndicator = NO;
        [_listCV registerClass:[HomeSelectOptimalCell class] forCellWithReuseIdentifier:@"HomeSelectOptimalCell"];
        
    }
    return _listCV;
}

- (NSMutableArray *)listArray
{
    if (!_listArray) {
        _listArray = [NSMutableArray array];
    }return _listArray;
}

@end
