//
//  HomeCityNameCell.m
//  Ykly
//
//  Created by 周权威 on 2019/7/22.
//  Copyright © 2019 YingKeTravel co.,Ltd. All rights reserved.
//

#import "HomeCityNameCell.h"
#import "Masonry.h"

#define KWidth_Scale    [UIScreen mainScreen].bounds.size.width/375.0
#define adaptX(num) num * KWidth_Scale

@interface HomeCityNameCell ()

@property (nonatomic, strong) UILabel *cityNameLab;

@property (nonatomic, strong) UIImageView *cityImageV;

@end

@implementation HomeCityNameCell

- (instancetype)initWithFrame:(CGRect)frame {
    
    self = [super initWithFrame:frame];
    if (self) {
        self.backgroundColor = [UIColor whiteColor];
        [self setUpSubViewsWithConstraints];
    }
    return self;
}

- (void)layoutSubviews {
    
    [super layoutSubviews];
//    [YkTool maskLayerView:self byRoundingCorners:UIRectCornerAllCorners maskcornerRadii:CGSizeMake(adaptX(22), adaptX(22))];
    //    [YkTool maskLayerView:self.cityLab byRoundingCorners:UIRectCornerBottomRight maskcornerRadii:CGSizeMake(10, 10)];
}

- (void)setUpSubViewsWithConstraints {
    [self.contentView addSubview:self.cityImageV];
    [self.cityImageV mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.right.top.mas_equalTo(self.contentView);
        make.width.mas_equalTo(adaptX(66));
        make.height.mas_equalTo(adaptX(66));
    }];
    
    [self.contentView addSubview:self.cityNameLab];
    [self.cityNameLab mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerX.mas_equalTo(self.cityImageV.mas_centerX);
        make.centerY.mas_equalTo(self.cityImageV.mas_centerY);
        make.height.mas_equalTo(adaptX(16));
        make.width.mas_lessThanOrEqualTo(adaptX(55));
    }];
    
    [self.contentView mas_updateConstraints:^(MASConstraintMaker *make) {
        make.bottom.mas_equalTo(self.cityImageV.mas_bottom);
    }];
}

- (void)setCityMadel:(HomeCityNameModel *)cityMadel {
    
    _cityMadel = cityMadel;
//    [self.cityImageV sd_setImageWithURL:[NSURL URLWithString:cityMadel.img] placeholderImage:PLACEHOLDER_IMAGE];
    [self.cityImageV setImageWithURL:[NSURL URLWithString:cityMadel.img] placeholder:PLACEHOLDER_IMAGE];
    self.cityNameLab.text = cityMadel.name;
}

- (UILabel *)cityNameLab {
    
    if (!_cityNameLab) {
        _cityNameLab = [[UILabel alloc] init];
        _cityNameLab.textColor = UIColorHex(FFFFFF);
        _cityNameLab.font = kPingFangMedium(15);
        _cityNameLab.textAlignment = NSTextAlignmentCenter;
    }
    return _cityNameLab;
}

- (UIImageView *)cityImageV {
    
    if (!_cityImageV) {
        _cityImageV = [[UIImageView alloc] init];
        _cityImageV.image = PLACEHOLDER_IMAGE;
        _cityImageV.contentMode = UIViewContentModeScaleAspectFill;
    }
    return _cityImageV;
}

@end
