//
//  HomeCityNameCollectionV.m
//  Ykly
//
//  Created by 周权威 on 2019/7/22.
//  Copyright © 2019 YingKeTravel co.,Ltd. All rights reserved.
//

#import "HomeCityNameCollectionV.h"
#import "HomeCityNameCell.h"
//#import "LineListController.h"

static NSString * const kHomeCityNameCellID = @"kHomeCityNameCellID";

@interface HomeCityNameCollectionV ()
<UICollectionViewDataSource,
UICollectionViewDelegate>

@property (nonatomic, strong) UICollectionView *cityCollectionView;

@property (nonatomic, strong) NSMutableArray *cityDataSourceArr;

@end

@implementation HomeCityNameCollectionV

- (instancetype)initWithFrame:(CGRect)frame {
    
    self = [super initWithFrame:frame];
    if (self) {
        self.autoresizesSubviews = YES;
        [self setUpSubViewsWithConstraints];
    }
    return self;
}

- (void)layoutSubviews {
    [super layoutSubviews];
}

- (void)setUpSubViewsWithConstraints {
    
    [self addSubview:self.cityCollectionView];
    [self.cityCollectionView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.left.right.bottom.mas_equalTo(self);
    }];
    
}

- (void)refreshCityNameArray:(NSMutableArray *)array {
    self.cityDataSourceArr = array;
    [self.cityCollectionView reloadData];
    CGFloat height = self.cityDataSourceArr.count ? adaptX(100) : 0;
    
    if ([self.delegate respondsToSelector:@selector(updateCityNameViewHeight:)]) {
        
        [self.delegate updateCityNameViewHeight:height];
    }
}

#pragma mark -----UICollectionViewDelegate && UICollectionViewDateSource
- (NSInteger)collectionView:(UICollectionView *)collectionView numberOfItemsInSection:(NSInteger)section {
    
    return self.cityDataSourceArr.count;
}

- (UICollectionViewCell *)collectionView:(UICollectionView *)collectionView cellForItemAtIndexPath:(NSIndexPath *)indexPath {
    
    HomeCityNameCell *cell = [collectionView dequeueReusableCellWithReuseIdentifier:kHomeCityNameCellID forIndexPath:indexPath];
    cell.cityMadel = self.cityDataSourceArr[indexPath.item];
    return cell;
}

- (void)collectionView:(UICollectionView *)collectionView didSelectItemAtIndexPath:(NSIndexPath *)indexPath {
    
//    HomeCityNameModel *cityModel = self.cityDataSourceArr[indexPath.item];
//    
//    LineListController *lvc = [[LineListController alloc] init];
//    lvc.screenInfo.destination_city = cityModel.name;
//    lvc.screenInfo.departure_city = self.currentCity;
//    [[YkTool viewControllerWithView:self].navigationController pushViewController:lvc animated:YES];
}

- (UICollectionView *)cityCollectionView {
    
    if (!_cityCollectionView) {
        UICollectionViewFlowLayout *layout = [[UICollectionViewFlowLayout alloc] init];
        layout.sectionInset = UIEdgeInsetsMake(10, 10, 10, 10);
        layout.minimumInteritemSpacing = 10.0f;
        layout.minimumLineSpacing = 10.0f;
        layout.itemSize = CGSizeMake(adaptX(66), adaptX(66));
        layout.scrollDirection = UICollectionViewScrollDirectionHorizontal;
        _cityCollectionView = [[UICollectionView alloc] initWithFrame:CGRectZero collectionViewLayout:layout];
        _cityCollectionView.backgroundColor = UIColorHex(FFFFFF);
        _cityCollectionView.layer.cornerRadius = 5;
        _cityCollectionView.delegate = self;
        _cityCollectionView.dataSource = self;
        _cityCollectionView.showsHorizontalScrollIndicator = NO;
        [_cityCollectionView registerClass:[HomeCityNameCell class] forCellWithReuseIdentifier:kHomeCityNameCellID];
        _cityCollectionView.autoresizingMask = UIViewAutoresizingFlexibleRightMargin|UIViewAutoresizingFlexibleLeftMargin|UIViewAutoresizingFlexibleTopMargin|UIViewAutoresizingFlexibleBottomMargin|UIViewAutoresizingFlexibleWidth|UIViewAutoresizingFlexibleHeight;
    }
    return _cityCollectionView;
}

- (NSMutableArray *)cityDataSourceArr {
    if (!_cityDataSourceArr) {
        _cityDataSourceArr = [[NSMutableArray alloc] init];
    }
    return _cityDataSourceArr;
}

@end
