//
//  HomeProductCollectionCell.m
//  Ykly
//
//  Created by 周权威 on 2019/7/22.
//  Copyright © 2019 YingKeTravel co.,Ltd. All rights reserved.
//

#import "HomeProductCollectionCell.h"
#import <YYKit/YYKit.h>

@interface HomeProductCollectionCell ()

@property (strong, nonatomic) UILabel *titleLabel;

@property (strong, nonatomic) YYLabel *subTitleLabel;

@end

@implementation HomeProductCollectionCell

- (instancetype)initWithFrame:(CGRect)frame
{
    self = [super initWithFrame:frame];
    
    if (self) {
        self.backgroundColor = WHITE_COLOR;
        
        self.titleLabel = [[UILabel alloc] init];
        self.titleLabel.font = kPingFangRegular(14);
        self.titleLabel.textColor = UIColorHex(333333);
        [self.contentView addSubview:self.titleLabel];
        [self.titleLabel mas_makeConstraints:^(MASConstraintMaker *make) {
            
            make.centerX.equalTo(self.contentView.mas_centerX);
            make.height.mas_equalTo(adaptX(14));
            make.top.equalTo(self.contentView.mas_top).offset(adaptX(12));
        }];
        
        self.subTitleLabel = [[YYLabel alloc] init];
        self.subTitleLabel.font = kPingFangRegular(11);
        self.subTitleLabel.textColor = UIColorHex(666666);
        self.subTitleLabel.textContainerInset = UIEdgeInsetsMake(2, 5, 2, 5);
        [self addSubview:self.subTitleLabel];
        [self.subTitleLabel mas_makeConstraints:^(MASConstraintMaker *make) {
            
            make.centerX.equalTo(self.contentView.mas_centerX);
            make.top.equalTo(self.titleLabel.mas_bottom).offset(adaptX(5));
            make.height.mas_equalTo(adaptX(16));
        }];
    }
    
    return self;
}

- (void)layoutSubviews {
    [super layoutSubviews];
//    [YkTool maskLayerView:self.subTitleLabel byRoundingCorners:UIRectCornerAllCorners maskcornerRadii:CGSizeMake(8, 8)];
}

- (void)setProductInfo:(HomeProductSInfo *)productInfo {
    
    _productInfo = productInfo;
    _titleLabel.text = productInfo.name;
    _subTitleLabel.text = productInfo.subtitle;
    if (productInfo.stress) {
        _subTitleLabel.textColor = [UIColor whiteColor];
        _subTitleLabel.backgroundColor =  [UIColor colorWithHexString:PurpleColorHex];

    } else {
        _subTitleLabel.textColor = [UIColor colorWithHexString:@"666666"];
        _subTitleLabel.backgroundColor = [UIColor whiteColor];
    }
}

- (void)setIndex:(NSInteger)index {
    
//    //    if (index == 0 || index == 7) {
//    if (index == 7) {
//        _subTitleLabel.textColor = PURPLE_COLOR;
//        _subTitleLabel.layer.borderColor = PURPLE_COLOR.CGColor;
//        _subTitleLabel.layer.borderWidth = 0.5;
//        _subTitleLabel.layer.masksToBounds = YES;
//        _subTitleLabel.layer.cornerRadius = 17/2;
//    }else
//    {
//        _subTitleLabel.textColor = [UIColor colorWithHexString:@"#666666"];
//        _subTitleLabel.layer.borderColor = WHITE_COLOR.CGColor;
//    }
}

@end
