//
//  HomeTitleCollectionCell.m
//  Ykly
//
//  Created by 周权威 on 2019/7/22.
//  Copyright © 2019 YingKeTravel co.,Ltd. All rights reserved.
//

#import "HomeTitleCollectionCell.h"

@interface HomeTitleCollectionCell ()

@property (nonatomic, strong) UIImageView *cityImageV;

@property (nonatomic, strong) UILabel * titleNameLab;

@end

@implementation HomeTitleCollectionCell

- (instancetype)initWithFrame:(CGRect)frame {
    
    self = [super initWithFrame:frame];
    if (self) {
        self.backgroundColor = WHITE_COLOR;
        [self setUpSubViewsWithConstraints];
    }
    return self;
}

- (void)layoutSubviews {
    
    [super layoutSubviews];
    //    [YkTool maskLayerView:self.cityLab byRoundingCorners:UIRectCornerBottomRight maskcornerRadii:CGSizeMake(10, 10)];
}

- (void)setUpSubViewsWithConstraints {
    
    [self.contentView addSubview:self.cityImageV];
    [self.cityImageV mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.right.top.mas_equalTo(self.contentView);
        make.width.mas_equalTo(adaptX(60));
        make.height.mas_equalTo(adaptX(60));
    }];
    
    [self.contentView addSubview:self.titleNameLab];
    [self.titleNameLab mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.mas_equalTo(self.cityImageV.mas_bottom);
        make.left.mas_equalTo(self.cityImageV.mas_left);
        make.right.mas_equalTo(self.cityImageV.mas_right);
        make.height.mas_equalTo(adaptX(16));
    }];
    [self.contentView mas_updateConstraints:^(MASConstraintMaker *make) {
        make.bottom.mas_equalTo(self.titleNameLab.mas_bottom);
    }];
}

- (void)setTitleInfo:(HomeTitleScrollInfo *)titleInfo {
    _titleInfo = titleInfo;
    
    if (titleInfo.icon.length > 10) { // 可能是本地的
//        [self.cityImageV sd_setImageWithURL:[NSURL URLWithString:titleInfo.icon] placeholderImage:PLACEHOLDER_IMAGE];
        [self.cityImageV setImageWithURL:[NSURL URLWithString:titleInfo.icon] placeholder:PLACEHOLDER_IMAGE];
    } else {
        self.cityImageV.image = [UIImage imageNamed:titleInfo.icon];
    }
    
    self.titleNameLab.text = titleInfo.name;
}

- (UIImageView *)cityImageV {
    
    if (!_cityImageV) {
        _cityImageV = [[UIImageView alloc] init];
        _cityImageV.userInteractionEnabled = YES;
        _cityImageV.contentMode = UIViewContentModeScaleAspectFit;
    }
    return _cityImageV;
}

- (UILabel *)titleNameLab {
    
    if (!_titleNameLab) {
        _titleNameLab = [[UILabel alloc] init];
        _titleNameLab.textColor = UIColorHex(333333);
        _titleNameLab.font = kPingFangRegular(15);
        _titleNameLab.textAlignment = NSTextAlignmentCenter;
    }
    return _titleNameLab;
}

@end
