//
//  HomeTitleScrollView.m
//  Ykly
//
//  Created by 周权威 on 2019/7/22.
//  Copyright © 2019 YingKeTravel co.,Ltd. All rights reserved.
//

#import "HomeTitleScrollView.h"
#import "HomeTitleScrollInfo.h"
#import "HomeTitleCollectionCell.h"
//#import "HotelHomeViewController.h"
//#import "AirTicketHomeViewController.h"
//#import "TrainHomeViewController.h"
//#import "YKOptimalHomeController.h"
//#import "TicketHomeController.h"

static NSString * const kHomeTitleCollectionCellID = @"kHomeTitleCollectionCellID";

@interface HomeTitleScrollView ()<UICollectionViewDataSource,
UICollectionViewDelegate>

@property (nonatomic, strong) UICollectionView *titleCollectionView;

@property (nonatomic, strong) NSMutableArray *titleDataArr;

@end

@implementation HomeTitleScrollView

- (instancetype)initWithFrame:(CGRect)frame {
    
    self = [super initWithFrame:frame];
    if (self) {
        self.autoresizesSubviews = YES;
        [self setUpSubViewsWithConstraints];
    }
    return self;
}

- (void)setUpSubViewsWithConstraints {
    
    [self addSubview:self.titleCollectionView];
    [self.titleCollectionView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.left.right.bottom.mas_equalTo(self);
    }];
}

- (void)replacetitleDataArray:(NSMutableArray *)array {
    _titleDataArr = array;
    [self.titleCollectionView reloadData];
}

#pragma mark -----UICollectionViewDelegate && UICollectionViewDateSource
- (NSInteger)collectionView:(UICollectionView *)collectionView numberOfItemsInSection:(NSInteger)section {
    
    return self.titleDataArr.count;
}

/**
 未调用
 */
- (void)refreshTitleScroll {
    [self layoutIfNeeded];
    if ([self.delegate respondsToSelector:@selector(updateTitleScrollViewHeight:)]) {
        
        [self.delegate updateTitleScrollViewHeight:self.titleCollectionView.contentSize.height];
    }
}

- (UICollectionViewCell *)collectionView:(UICollectionView *)collectionView cellForItemAtIndexPath:(NSIndexPath *)indexPath {
    
    HomeTitleCollectionCell *cell = [collectionView dequeueReusableCellWithReuseIdentifier:kHomeTitleCollectionCellID forIndexPath:indexPath];
    cell.titleInfo = self.titleDataArr[indexPath.item];
    return cell;
}

- (void)collectionView:(UICollectionView *)collectionView didSelectItemAtIndexPath:(NSIndexPath *)indexPath {
    
//    HomeTitleScrollInfo *titleInfo = self.titleDataArr[indexPath.item];
//    switch ([titleInfo.type integerValue]) {
//        case 1:
//            {
//                HotelHomeViewController *vc = [[HotelHomeViewController alloc] init];
//                [[YkTool viewControllerWithView:self].navigationController pushViewController:vc animated:YES];
//            }
//            break;
//        case 2:
//        {
//            AirTicketHomeViewController *airVC = [[AirTicketHomeViewController alloc] init];
//            [[YkTool viewControllerWithView:self].navigationController pushViewController:airVC animated:YES];
//        }
//            break;
//        case 3:
//        {
//            TrainHomeViewController *next = [[TrainHomeViewController alloc] init];
//            [[YkTool viewControllerWithView:self].navigationController pushViewController:next animated:YES];
//        }
//            break;
//        case 4:
//        {
//            YKOptimalHomeController *next = [[YKOptimalHomeController alloc]init];
//            [[YkTool viewControllerWithView:self].navigationController pushViewController:next animated:YES];
//        }
//            break;
//        case 5:
//            {
//                TicketHomeController *vc = [[TicketHomeController alloc] init];
//                vc.selectCity = self.currentCity;
//                [[YkTool viewControllerWithView:self].navigationController pushViewController:vc animated:YES];
//            }
//            break;
//            
//        default:
//            break;
//    }
//    
}

- (UICollectionView *)titleCollectionView {
    
    if (!_titleCollectionView) {
        UICollectionViewFlowLayout *layout = [[UICollectionViewFlowLayout alloc] init];
        layout.estimatedItemSize = CGSizeMake(adaptX(60), adaptX(100));
//        layout.minimumLineSpacing = adaptX(12);
        layout.minimumLineSpacing = adaptX(28);
        layout.minimumInteritemSpacing = adaptX(12);
//        layout.sectionInset = UIEdgeInsetsMake(0, adaptX(12), 0, adaptX(12));
        layout.sectionInset = UIEdgeInsetsMake(0, adaptX(24), 0, adaptX(24));
        layout.scrollDirection = UICollectionViewScrollDirectionHorizontal;
        _titleCollectionView = [[UICollectionView alloc] initWithFrame:CGRectZero collectionViewLayout:layout];
        _titleCollectionView.backgroundColor = UIColorHex(FFFFFF);
        _titleCollectionView.layer.cornerRadius = 5;
        _titleCollectionView.delegate = self;
        _titleCollectionView.dataSource = self;
        [_titleCollectionView registerClass:[HomeTitleCollectionCell class] forCellWithReuseIdentifier:kHomeTitleCollectionCellID];
        //        [_hotCollectionView registerClass:[HotActivityThemeHeaderView class] forSupplementaryViewOfKind:UICollectionElementKindSectionHeader withReuseIdentifier:kHotActivityThemeHeaderViewID];
        _titleCollectionView.autoresizingMask = UIViewAutoresizingFlexibleRightMargin|UIViewAutoresizingFlexibleLeftMargin|UIViewAutoresizingFlexibleTopMargin|UIViewAutoresizingFlexibleBottomMargin|UIViewAutoresizingFlexibleWidth|UIViewAutoresizingFlexibleHeight;
    }
    return _titleCollectionView;
}

- (NSMutableArray *)titleDataArr {
    if (!_titleDataArr) {
        _titleDataArr = [[NSMutableArray alloc] init];
        NSArray *titleArray = @[@"酒店", @"机票", @"火车票", @"商城", @"门票"];
        NSArray *imageArray = @[@"home_04",@"home_05",@"home_03",@"home_01",@"home_02"];
        for (int i = 0; i < titleArray.count; i++) {
            HomeTitleScrollInfo *titleInfo = [[HomeTitleScrollInfo alloc] init];
            titleInfo.name = titleArray[i];
            titleInfo.icon = imageArray[i];
            titleInfo.type = [NSString stringWithFormat:@"%d", i + 1];
            [_titleDataArr addObject:titleInfo];
        }
        
    }
    return _titleDataArr;
}

@end
