//
//  HomeViewServiceView.m
//  Ykly
//
//  Created by yk on 2019/7/25.
//  Copyright © 2019 YingKeTravel co.,Ltd. All rights reserved.
//

#import "HomeViewServiceView.h"
//#import "AlertMsgView.h"

#define kBlackColor         [UIColor blackColor]
#define kWhiteColor         [UIColor whiteColor]

@interface HomeViewServiceView ()
/// 顶部图片
@property (nonatomic, strong) UIImageView * iconTop;
/// 底部icon
@property (nonatomic, strong) UIImageView * iconBottom;
/// 顶部标题
@property (nonatomic, strong) UILabel * lblTop;
/// 底部标题
@property (nonatomic, strong) UILabel * lblBottom;
@property (nonatomic, strong) UIView * maskView;
/// maskview上增加control,为何避免给maskview添加了点击事件后的 穿透
@property (nonatomic, strong) UIControl * controlMask;
@end

@implementation HomeViewServiceView

- (instancetype)init {
    if (self == [super init]) {
        [self initUI];
    }
    return self;
}

- (instancetype)initWithFrame:(CGRect)frame {
    if (self == [super initWithFrame:frame]) {
        [self initUI];
    }
    return self;
}

#pragma mark - events
- (void)show {
    UIView * maskView = [[UIView alloc] initWithFrame:CGRectMake(0, 0, kScreenWidth, kScreenHeight)];
    self.maskView = maskView;
    maskView.userInteractionEnabled = YES;
    maskView.backgroundColor = [kBlackColor colorWithAlphaComponent:.25];
    [maskView addSubview:self];
    
    [maskView addSubview:self.controlMask];
    
    UIWindow * window = [UIApplication sharedApplication].keyWindow;
    [window addSubview:maskView];
}

- (void)clickMaskView {
    
    [self removeFromSuperview];
    [self.maskView removeFromSuperview];
    self.maskView = nil;
}

// 在线客服 弹出小能
- (void)clickTopView {
    
    [self clickMaskView];
    
    if (self.clickXNTalkCallback) {
        self.clickXNTalkCallback();
    }
}

// 拨打电话弹框
- (void)callServer {
    
    [self clickMaskView];
    
//    AlertMsgView * alertView = [[AlertMsgView alloc] initWithContent:@"客服电话:400-6169999" contentColor:UIColorHex(#4C4C4C) contentFont:kPingFangRegularNoFit(15) actionTitle:@"呼叫" actionTitleColor:KThemeColor actionFont:kPingFangRegularNoFit(16) withCallback:^{
//        [self callPhone:@"400-6169999"];
//    }];
//    [alertView addActionWtithActionTitle:@"取消" actionColor:UIColorHex(#4C4C4C) actionFont:kPingFangRegularNoFit(16) withCallback:^{
//    }];
//    alertView.backgroundColor = kWhiteColor;
//    alertView.frame = KFrame(0, 0, 270, 128);
//    alertView.layer.cornerRadius = 13;
//    alertView.layer.masksToBounds = YES;
//    [alertView show];
}

- (void)callPhone:(NSString *)phone {
    NSMutableString * str=[[NSMutableString alloc] initWithFormat:@"tel:%@",phone];
    UIApplication *application = [UIApplication sharedApplication];
    NSURL *URL = [NSURL URLWithString:str];
    [application openURL:URL options:@{} completionHandler:^(BOOL success) {
        //OpenSuccess=选择 呼叫 为 1  选择 取消 为0
        NSLog(@"OpenSuccess=%d",success);
    }];
}

#pragma mark - UI
- (void)initUI {
    
    self.backgroundColor = kWhiteColor;
    
    UIView * topView = [UIView new];
    topView.userInteractionEnabled = YES;
    topView.layer.cornerRadius = 10;
    topView.layer.masksToBounds = YES;
    topView.layer.borderColor = [UIColor colorWithHexString:PurpleColorHex].CGColor;
    topView.layer.borderWidth = 1;
    [self addSubview:topView];
    [topView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self).with.offset(12);
        make.right.equalTo(self).with.offset(-12);
        make.height.equalTo(@50);
        make.top.equalTo(self).with.offset(20);
    }];
    
    UIView * bottomView = [UIView new];
    bottomView.userInteractionEnabled = YES;
    bottomView.layer.cornerRadius = 10;
    bottomView.layer.masksToBounds = YES;
    bottomView.layer.borderColor = [UIColor colorWithHexString:PurpleColorHex].CGColor;
    bottomView.layer.borderWidth = 1;
    [self addSubview:bottomView];
    [bottomView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.equalTo(self).with.offset(12);
        make.right.equalTo(self).with.offset(-12);
        make.height.equalTo(@50);
        make.top.equalTo(topView.mas_bottom).with.offset(20);
    }];
    
    [topView addSubview:self.iconTop];
    [self.iconTop mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerY.equalTo(topView.mas_centerY);
        make.left.equalTo(self).with.offset(adaptX(100));
        make.width.equalTo(@26);
        make.height.equalTo(@25);
    }];
    
    [bottomView addSubview:self.iconBottom];
    [self.iconBottom mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerY.equalTo(bottomView.mas_centerY);
        make.left.equalTo(self).with.offset(adaptX(100));
        make.width.equalTo(@25.5);
        make.height.equalTo(@22.5);
    }];
    
    [topView addSubview:self.lblTop];
    [self.lblTop mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerY.equalTo(self.iconTop.mas_centerY);
        make.left.equalTo(self.iconTop.mas_right).with.offset(20);
        make.right.equalTo(topView).with.offset(-15);
    }];
    
    [bottomView addSubview:self.lblBottom];
    [self.lblBottom mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerY.equalTo(self.iconBottom.mas_centerY);
        make.left.equalTo(self.iconBottom.mas_right).with.offset(20);
        make.right.equalTo(bottomView).with.offset(-15);
        
    }];
    
    UIControl * controlTop = [[UIControl alloc] init];
    [controlTop addTarget:self action:@selector(clickTopView) forControlEvents:UIControlEventTouchUpInside];
    [topView addSubview:controlTop];
    [controlTop mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.right.top.bottom.equalTo(topView).with.offset(0);
    }];
    
    UIControl * controlBottom = [[UIControl alloc] init];
    [controlBottom addTarget:self action:@selector(callServer) forControlEvents:UIControlEventTouchUpInside];
    [bottomView addSubview:controlBottom];
    [controlBottom mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.right.bottom.top.equalTo(bottomView).with.offset(0);
    }];
}

#pragma mark - getter

- (UILabel *)lblTop {
    if (!_lblTop) {
        _lblTop = [UILabel new];
        _lblTop.font = kPingFangRegular(15);
        _lblTop.textColor = UIColorHex(#333333);
        _lblTop.text = @"在线客服";
    }
    return _lblTop;
}

- (UILabel *)lblBottom {
    if (!_lblBottom) {
        _lblBottom = [UILabel new];
        _lblBottom.font = kPingFangRegular(15);
        _lblBottom.text = @"客服电话 400-6169999";
        _lblBottom.textColor = UIColorHex(#333333);
    }
    return _lblBottom;
}

- (UIImageView *)iconBottom {
    if (!_iconBottom) {
        _iconBottom = [UIImageView new];
        _iconBottom.image = kImageNamed(@"YKHomeBottomCallService");
    }
    return _iconBottom;
}

- (UIImageView *)iconTop {
    if (!_iconTop) {
        _iconTop = [UIImageView new];
        _iconTop.image =kImageNamed(@"YKHomeBottomServiceOnline");
    }
    return _iconTop;
}

- (UIControl *)controlMask {
    if (!_controlMask) {
        _controlMask = [[UIControl alloc] init];
        [_controlMask addTarget:self action:@selector(clickMaskView) forControlEvents:UIControlEventTouchUpInside];
        _controlMask.frame = CGRectMake(0, 0, kScreenWidth, kScreenHeight-self.height);
    }
    return _controlMask;
}

@end
