//
//  ChosenThemeTableCell.m
//  Ykly
//
//  Created by 周权威 on 2019/7/23.
//  Copyright © 2019 YingKeTravel co.,Ltd. All rights reserved.
//

#import "ChosenThemeTableCell.h"
#import "HomeThemeActivityInfo.h"
//#import "SearchAllViewController.h"

@interface ChosenThemeTableCell ()

@property (nonatomic, strong) NSMutableArray *activityArray;

@property (nonatomic, strong) UILabel *titleLab;

@property (nonatomic, strong) UILabel *descLabel;

@property (nonatomic, strong) UIImageView *activityImgVA;

@property (nonatomic, strong) UIImageView *activityImgVB;

@property (nonatomic, strong) UIImageView *activityImgVC;

@property (nonatomic, strong) UIImageView *activityImgVD;

@property (nonatomic, strong) UIImageView *activityImgVE;

@end

@implementation ChosenThemeTableCell

- (instancetype)initWithStyle:(UITableViewCellStyle)style reuseIdentifier:(NSString *)reuseIdentifier {
    self = [super initWithStyle:style reuseIdentifier:reuseIdentifier];
    if (self) {
        self.selectionStyle = UITableViewCellSelectionStyleNone;
        self.backgroundColor = [UIColor whiteColor];
        [self setUpSubViewsWithConstraints];
    }
    return self;
}

- (void)setUpSubViewsWithConstraints {
    
    [self.contentView addSubview:self.titleLab];
    [self.titleLab mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.mas_equalTo(self.contentView.mas_left).offset(adaptX(12));
        make.top.mas_equalTo(self.contentView.mas_top).offset(adaptX(10));
        make.height.mas_equalTo(adaptX(22));
    }];
    
    [self.contentView addSubview:self.descLabel];
    [self.descLabel mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerY.mas_equalTo(self.titleLab.mas_centerY);
        make.right.mas_equalTo(self.contentView.mas_right).offset(-adaptX(22));
        make.height.mas_equalTo(adaptX(14));
    }];
    UIImageView *arrowImgV = [[UIImageView alloc] init];
    arrowImgV.image = [UIImage imageNamed:@"VisaRightArrow"];
    [self.descLabel addSubview:arrowImgV];
    [arrowImgV mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerY.mas_equalTo(self.descLabel.mas_centerY);
        make.left.mas_equalTo(self.descLabel.mas_right).offset(6);
        make.height.mas_equalTo(adaptX(10));
        make.width.mas_equalTo(adaptX(5));
        
    }];
    
    [self.contentView addSubview:self.activityImgVA];
    [self.activityImgVA mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.mas_equalTo(self.titleLab.mas_bottom).offset(15);
        make.left.mas_equalTo(self.titleLab.mas_left);
        make.height.mas_equalTo(adaptX(100));
        make.width.mas_equalTo(adaptX(222));
        
    }];
    [self.contentView addSubview:self.activityImgVB];
    [self.activityImgVB mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.mas_equalTo(self.activityImgVA.mas_top);
        make.left.mas_equalTo(self.activityImgVA.mas_right).offset(adaptX(5));
        make.height.mas_equalTo(adaptX(100));
        make.width.mas_equalTo(adaptX(124));
        
    }];
    [self.contentView addSubview:self.activityImgVC];
    [self.activityImgVC mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.mas_equalTo(self.activityImgVA.mas_bottom).offset(adaptX(5));
        make.left.mas_equalTo(self.activityImgVA.mas_left);
        make.height.mas_equalTo(adaptX(100));
        make.width.mas_equalTo(adaptX(109));
    }];
    
    [self.contentView addSubview:self.activityImgVD];
    [self.activityImgVD mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.mas_equalTo(self.activityImgVC.mas_top);
        make.left.mas_equalTo(self.activityImgVC.mas_right).offset(adaptX(5));
        make.height.mas_equalTo(adaptX(100));
        make.width.mas_equalTo(adaptX(109));
    }];
    
    [self.contentView addSubview:self.activityImgVE];
    [self.activityImgVE mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.mas_equalTo(self.activityImgVD.mas_top);
        make.left.mas_equalTo(self.activityImgVD.mas_right).offset(adaptX(5));
        make.height.mas_equalTo(adaptX(100));
        make.width.mas_equalTo(adaptX(124));
    }];
//        [self.contentView mas_updateConstraints:^(MASConstraintMaker *make) {
//            make.right.mas_equalTo(self.activityImgVB.mas_right).offset(adaptX(12));
//            make.bottom.mas_equalTo(self.activityImgVC.mas_bottom).offset(adaptX(12));
//        }];
}

- (void)layoutSubviews {
    [super layoutSubviews];
//    [YkTool maskLayerView:self.activityImgVA byRoundingCorners:UIRectCornerTopLeft maskcornerRadii:CGSizeMake(10, 10)];
//    [YkTool maskLayerView:self.activityImgVB byRoundingCorners:UIRectCornerTopRight maskcornerRadii:CGSizeMake(10, 10)];
//    [YkTool maskLayerView:self.activityImgVC byRoundingCorners:UIRectCornerBottomLeft maskcornerRadii:CGSizeMake(10, 10)];
//    [YkTool maskLayerView:self.activityImgVE byRoundingCorners:UIRectCornerBottomRight maskcornerRadii:CGSizeMake(10, 10)];
}

- (void)setThemeArrayWith:(HotActivityThemeModel *)model {
    _activityArray = model.list;
    if (_activityArray.count != 5) return;
    HomeThemeActivityInfo *infoA = _activityArray[0];
    [self.activityImgVA setImageWithURL:[NSURL URLWithString:infoA.img] placeholder:PLACEHOLDER_IMAGE];
    HomeThemeActivityInfo *infoB = _activityArray[1];
    [self.activityImgVB setImageWithURL:[NSURL URLWithString:infoB.img] placeholder:PLACEHOLDER_IMAGE];
    HomeThemeActivityInfo *infoC = _activityArray[2];
    [self.activityImgVC setImageWithURL:[NSURL URLWithString:infoC.img] placeholder:PLACEHOLDER_IMAGE];
    HomeThemeActivityInfo *infoD = _activityArray[3];
    [self.activityImgVD setImageWithURL:[NSURL URLWithString:infoD.img] placeholder:PLACEHOLDER_IMAGE];
    HomeThemeActivityInfo *infoE = _activityArray[4];
    [self.activityImgVE setImageWithURL:[NSURL URLWithString:infoE.img] placeholder:PLACEHOLDER_IMAGE];
    self.titleLab.text = model.name;
    if (model.subtitle.length) {
        self.descLabel.hidden = NO;
        self.descLabel.text = model.subtitle;
    } else {
        self.descLabel.hidden = YES;
    }
}

- (void)activityAction:(UITapGestureRecognizer *)gesture {
    NSInteger tag = gesture.view.tag;
    HomeThemeActivityInfo *info = self.activityArray[tag];
    !self.chosenThemeBlock ? : self.chosenThemeBlock(info);
}

- (void)descLabelAction:(UITapGestureRecognizer *)gesture {
//    SearchAllViewController *next = [[SearchAllViewController alloc] init];
//    [[YkTool viewControllerWithView:self].navigationController pushViewController:next animated:YES];
}

- (UILabel *)titleLab {
    if (!_titleLab) {
        _titleLab = [[UILabel alloc] init];
        _titleLab.font = kPingFangMedium(18);
        _titleLab.textColor = UIColorHex(333333);
    }
    return _titleLab;
}

- (UILabel *)descLabel {
    if (!_descLabel) {
        _descLabel = [[UILabel  alloc] init];
        _descLabel.font = kPingFangRegular(13);
        _descLabel.textColor = UIColorHex(666666);
        _descLabel.hidden = YES;
        _descLabel.textAlignment = NSTextAlignmentRight;
//        [_descLabel x_GestureWithSelector:@selector(descLabelAction:) responseTarget:self];
    }
    return _descLabel;
}

- (UIImageView *)activityImgVA {
    
    if (!_activityImgVA) {
        _activityImgVA = [[UIImageView alloc] init];
        //        _activityImgVA.image = PLACEHOLDER_IMAGE;
        _activityImgVA.contentMode = UIViewContentModeScaleAspectFill;
        _activityImgVA.layer.masksToBounds = YES;
        _activityImgVA.tag = 0;
//        [_activityImgVA x_GestureWithSelector:@selector(activityAction:) responseTarget:self];
    }
    return _activityImgVA;
}

- (UIImageView *)activityImgVB {
    
    if (!_activityImgVB) {
        _activityImgVB = [[UIImageView alloc] init];
        //        _activityImgVB.image = PLACEHOLDER_IMAGE;
        _activityImgVB.contentMode = UIViewContentModeScaleAspectFill;
        _activityImgVB.layer.masksToBounds = YES;
        _activityImgVB.tag = 1;
//        [_activityImgVB x_GestureWithSelector:@selector(activityAction:) responseTarget:self];
    }
    return _activityImgVB;
}

- (UIImageView *)activityImgVC {
    
    if (!_activityImgVC) {
        _activityImgVC = [[UIImageView alloc] init];
        //        _activityImgVC.image = PLACEHOLDER_IMAGE;
        _activityImgVC.contentMode = UIViewContentModeScaleAspectFill;
        _activityImgVC.layer.masksToBounds = YES;
        _activityImgVC.tag = 2;
//        [_activityImgVC x_GestureWithSelector:@selector(activityAction:) responseTarget:self];
    }
    return _activityImgVC;
}

- (UIImageView *)activityImgVD {
    
    if (!_activityImgVD) {
        _activityImgVD = [[UIImageView alloc] init];
        //        _activityImgVD.image = PLACEHOLDER_IMAGE;
        _activityImgVD.contentMode = UIViewContentModeScaleAspectFill;
        _activityImgVD.layer.masksToBounds = YES;
        _activityImgVD.tag = 3;
//        [_activityImgVD x_GestureWithSelector:@selector(activityAction:) responseTarget:self];
    }
    return _activityImgVD;
}

- (UIImageView *)activityImgVE {
    
    if (!_activityImgVE) {
        _activityImgVE = [[UIImageView alloc] init];
        //        _activityImgVE.image = PLACEHOLDER_IMAGE;
        _activityImgVE.contentMode = UIViewContentModeScaleAspectFill;
        _activityImgVE.layer.masksToBounds = YES;
        _activityImgVE.tag = 4;
//        [_activityImgVE x_GestureWithSelector:@selector(activityAction:) responseTarget:self];
    }
    return _activityImgVE;
}

- (NSMutableArray *)activityArray {
    
    if (!_activityArray) {
        _activityArray = [[NSMutableArray alloc] init];
    }
    return _activityArray;
}

@end
