//
//  HotActivityTableCell.m
//  Ykly
//
//  Created by 周权威 on 2019/7/23.
//  Copyright © 2019 YingKeTravel co.,Ltd. All rights reserved.
//

#import "HotActivityTableCell.h"
#import "HomeThemeActivityInfo.h"

@interface HotActivityTableCell ()

@property (nonatomic, strong) NSMutableArray *activityArray;

@property (nonatomic, strong) UILabel *titleLab;

@property (nonatomic, strong) UIImageView *activityImgVA;

@property (nonatomic, strong) UIImageView *activityImgVB;

@property (nonatomic, strong) UIImageView *activityImgVC;

@end

@implementation HotActivityTableCell

- (instancetype)initWithStyle:(UITableViewCellStyle)style reuseIdentifier:(NSString *)reuseIdentifier {
    self = [super initWithStyle:style reuseIdentifier:reuseIdentifier];
    if (self) {
        self.selectionStyle = UITableViewCellSelectionStyleNone;
        self.backgroundColor = [UIColor whiteColor];
        [self setUpSubViewsWithConstraints];
    }
    return self;
}

- (void)setUpSubViewsWithConstraints {
    
    [self.contentView addSubview:self.titleLab];
    [self.titleLab mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.mas_equalTo(self.contentView.mas_left).offset(adaptX(12));
        make.top.mas_equalTo(self.contentView.mas_top).offset(adaptX(10));
        make.height.mas_equalTo(adaptX(22));
    }];
    
    [self.contentView addSubview:self.activityImgVA];
    [self.activityImgVA mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.mas_equalTo(self.titleLab.mas_bottom).offset(15);
        make.left.mas_equalTo(self.titleLab.mas_left);
        make.height.mas_equalTo(adaptX(204));
        make.width.mas_equalTo(adaptX(173));
        
    }];
    [self.contentView addSubview:self.activityImgVB];
    [self.activityImgVB mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.mas_equalTo(self.activityImgVA.mas_top);
        make.left.mas_equalTo(self.activityImgVA.mas_right).offset(adaptX(5));
        make.height.mas_equalTo(adaptX(100));
        make.width.mas_equalTo(adaptX(173));
        
    }];
    [self.contentView addSubview:self.activityImgVC];
    [self.activityImgVC mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.mas_equalTo(self.activityImgVB.mas_bottom).offset(adaptX(5));
        make.left.mas_equalTo(self.activityImgVB.mas_left);
        make.height.mas_equalTo(adaptX(100));
        make.width.mas_equalTo(adaptX(173));
    }];
    //    [self.contentView mas_updateConstraints:^(MASConstraintMaker *make) {
    //        make.right.mas_equalTo(self.activityImgVB.mas_right).offset(adaptX(12));
    //        make.bottom.mas_equalTo(self.activityImgVC.mas_bottom).offset(adaptX(12));
    //    }];
}

- (void)layoutSubviews {
    [super layoutSubviews];
//    [YkTool maskLayerView:self.activityImgVA byRoundingCorners:UIRectCornerTopLeft | UIRectCornerBottomLeft maskcornerRadii:CGSizeMake(10, 10)];
//    [YkTool maskLayerView:self.activityImgVB byRoundingCorners:UIRectCornerTopRight maskcornerRadii:CGSizeMake(10, 10)];
//    [YkTool maskLayerView:self.activityImgVC byRoundingCorners:UIRectCornerBottomRight maskcornerRadii:CGSizeMake(10, 10)];
}

- (void)setActivityArrayWith:(HotActivityThemeModel *)model {
    self.activityArray = model.list;
    if (self.activityArray.count != 3) return;
    HomeThemeActivityInfo *infoA = self.activityArray[0];
    [self.activityImgVA setImageWithURL:[NSURL URLWithString:infoA.img] placeholder:PLACEHOLDER_IMAGE];
    HomeThemeActivityInfo *infoB = self.activityArray[1];
    [self.activityImgVB setImageWithURL:[NSURL URLWithString:infoB.img] placeholder:PLACEHOLDER_IMAGE];
    HomeThemeActivityInfo *infoC = self.activityArray[2];
    [self.activityImgVC setImageWithURL:[NSURL URLWithString:infoC.img] placeholder:PLACEHOLDER_IMAGE];
    self.titleLab.text = model.name;
}

- (void)activityAction:(UITapGestureRecognizer *)gesture {
    NSInteger tag = gesture.view.tag;
    HomeThemeActivityInfo *info = self.activityArray[tag];
    !self.hotActivityBlock ? : self.hotActivityBlock(info);
}

- (UILabel *)titleLab {
    if (!_titleLab) {
        _titleLab = [[UILabel alloc] init];
        _titleLab.font = kPingFangMedium(18);
        _titleLab.textColor = UIColorHex(333333);
    }
    return _titleLab;
}

- (UIImageView *)activityImgVA {
    
    if (!_activityImgVA) {
        _activityImgVA = [[UIImageView alloc] init];
//        _activityImgVA.image = PLACEHOLDER_IMAGE;
        _activityImgVA.contentMode = UIViewContentModeScaleAspectFill;
        _activityImgVA.layer.masksToBounds = YES;
        _activityImgVA.tag = 0;
//        [_activityImgVA x_GestureWithSelector:@selector(activityAction:) responseTarget:self];
    }
    return _activityImgVA;
}

- (UIImageView *)activityImgVB {
    
    if (!_activityImgVB) {
        _activityImgVB = [[UIImageView alloc] init];
//        _activityImgVB.image = PLACEHOLDER_IMAGE;
        _activityImgVB.contentMode = UIViewContentModeScaleAspectFill;
        _activityImgVB.layer.masksToBounds = YES;
        _activityImgVB.tag = 1;
//        [_activityImgVB x_GestureWithSelector:@selector(activityAction:) responseTarget:self];
    }
    return _activityImgVB;
}

- (UIImageView *)activityImgVC {
    
    if (!_activityImgVC) {
        _activityImgVC = [[UIImageView alloc] init];
//        _activityImgVC.image = PLACEHOLDER_IMAGE;
        _activityImgVC.contentMode = UIViewContentModeScaleAspectFill;
        _activityImgVC.layer.masksToBounds = YES;
        _activityImgVC.tag = 2;
//        [_activityImgVC x_GestureWithSelector:@selector(activityAction:) responseTarget:self];
    }
    return _activityImgVC;
}

- (NSMutableArray *)activityArray {
    
    if (!_activityArray) {
        _activityArray = [[NSMutableArray alloc] init];
    }
    return _activityArray;
}


@end
