//
//  HotActivityThemeTableV.m
//  Ykly
//
//  Created by 周权威 on 2019/7/23.
//  Copyright © 2019 YingKeTravel co.,Ltd. All rights reserved.
//

#import "HotActivityThemeTableV.h"
//#import "CommentWebViewController.h"
//#import "LineListController.h"
//#import "ProductDetailViewController.h"
//#import "YKOptimalDeatilController.h"
//#import "LoginViewController.h"
//#import "HotelDeatilViewController.h"
//#import "TicketDetailController.h"
//#import "VisaDetailVC.h"
//#import "YKTourHotelListVC.h"
#import "HotActivityTableCell.h"
#import "ChosenThemeTableCell.h"
#import "HotActivityThemeModel.h"

static NSString * const kHotActivityTableCellID = @"kHotActivityTableCellID";
static NSString * const kChosenThemeTableCellID = @"kChosenThemeTableCellID";

@interface HotActivityThemeTableV ()
<UITableViewDataSource,
UITableViewDelegate>

@property (nonatomic, strong) UITableView *hotCollectionView;

//@property (nonatomic, strong) UICollectionViewFlowLayout *layout;

@property (nonatomic, strong) NSMutableArray *activityThemeArr;

@end

@implementation HotActivityThemeTableV

- (instancetype)initWithFrame:(CGRect)frame {
    
    self = [super initWithFrame:frame];
    if (self) {
        self.autoresizesSubviews = YES;
        self.backgroundColor = [UIColor whiteColor];
        [self setUpSubViewsWithConstraints];
    }
    return self;
}

- (void)setUpSubViewsWithConstraints {
    
    [self addSubview:self.hotCollectionView];
    [self.hotCollectionView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.left.right.bottom.mas_equalTo(self);
    }];
}

- (void)refreshActivityThemeView:(NSMutableArray *)array {
    NSMutableArray *tmpArray = [NSMutableArray array];
    for (NSDictionary *dict in array) {
        HotActivityThemeModel *model = [HotActivityThemeModel mj_objectWithKeyValues:dict];
        [tmpArray addObject:model];
    }
    self.activityThemeArr = tmpArray;
    [self.hotCollectionView reloadData];
    CGFloat height = 0;
    if (self.activityThemeArr.count == 1) {
        height = adaptX(260);
    } else if (self.activityThemeArr.count == 2) {
        height = adaptX(520);
    } else {
        height = 0;
    }
    if ([self.delegate respondsToSelector:@selector(updateActivityThemeVHeight:)]) {
        
        [self.delegate updateActivityThemeVHeight:height];
    }
}

#pragma mark -----UICollectionViewDelegate && UICollectionViewDateSource

- (CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath {
    return adaptX(260);
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
    return self.activityThemeArr.count;
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
    HotActivityTableCell *activityCell = [tableView dequeueReusableCellWithIdentifier:kHotActivityTableCellID];
    ChosenThemeTableCell *themeCell = [tableView dequeueReusableCellWithIdentifier:kChosenThemeTableCellID];
    HotActivityThemeModel *model = self.activityThemeArr[indexPath.row];
    __weak typeof(self) weakSelf = self;
    if ([model.type isEqualToString:@"activity"]) {
        [activityCell setActivityArrayWith:model];
        
        activityCell.hotActivityBlock = ^(HomeThemeActivityInfo * _Nonnull info) {
            [weakSelf pushOtherVCWith:info];
        };
        return activityCell;
    } else if ([model.type isEqualToString:@"topic"]) {
        [themeCell setThemeArrayWith:model];
        
        themeCell.chosenThemeBlock = ^(HomeThemeActivityInfo * _Nonnull info) {
            [weakSelf pushOtherVCWith:info];
        };
        return themeCell;
    }
    return activityCell;
    
}

- (void)pushOtherVCWith:(HomeThemeActivityInfo *)info{

//    if (info.type == 2) {
//        //外链
//        NSString *url = info.url;
//        if (url.length == 0) {
//            return;
//        }
//        CommentWebViewController *next = [[CommentWebViewController alloc] init];
//        next.webUrlStr = info.url;
//        next.navigationItem.title = info.name;
//        [[YkTool viewControllerWithView:self].navigationController pushViewController:next animated:YES];
//
//    }else if (info.type == 1) {
//        //推荐列表
//        LineListController *lvc = [[LineListController alloc] init];
//        
//        NSDictionary *dict = [info.params mj_keyValues].copy;
//        lvc.screenInfo = [LineSearchInfoSubmitModel mj_objectWithKeyValues:dict];
//        
//        if ([YkTool isBlankString:info.params.keyword]) {
//            lvc.screenInfo.keyword = info.params.keyword;
//        } else {
//            lvc.screenInfo.destination_city = info.params.arriveCitys;
//        }
//        lvc.screenInfo.departure_city = self.currentCity;
//        
//        [[YkTool viewControllerWithView:self].navigationController pushViewController:lvc animated:YES];
//    } else if (info.type == 4) {
//        YKTourHotelListVC *hotelListVC = [[YKTourHotelListVC alloc] init];
//        
//        NSDictionary *dict = [info.params mj_keyValues];
//        HotelScreeningConditionsInfo * infoNew = [HotelScreeningConditionsInfo modelWithDictionary:dict];
//        hotelListVC.screenInfoFront = infoNew;
//        
//        [[YkTool viewControllerWithView:self].navigationController pushViewController:hotelListVC animated:YES];
//    } else if (info.type == 3) {
//        //对应产品的详情
//        NSString *productType =@"";
//        switch (info.params.product_type) {
//            case 1:
//            {
//                productType = @"跟团游";
//                //调到产品详情
//                ProductDetailViewController *vc = [[ProductDetailViewController alloc] init];
//                vc.productId = [NSString stringWithFormat:@"%ld", info.params.product_id];
//                vc.orgId = [NSString stringWithFormat:@"%ld", info.params.orgId];
//                [[YkTool viewControllerWithView:self].navigationController pushViewController:vc animated:YES];
//            }
//                break;
//            case 2:
//            {
//                productType = @"邮轮";
//
//                ProductDetailViewController *next = [[ProductDetailViewController alloc] init];
//                next.productId = [NSString stringWithFormat:@"%ld", info.params.product_id];
//                next.orgId = [NSString stringWithFormat:@"%ld", info.params.orgId];
//                next.typeName = @"邮轮";
//                [[YkTool viewControllerWithView:self].navigationController pushViewController:next animated:YES];
//            }
//                break;
//            case 3:
//            {
//                productType = @"商务考察";
//            }
//                break;
//            case 4:
//
//            {
//                productType = @"自由行";
//                ProductDetailViewController *vc = [[ProductDetailViewController alloc] init];
//                vc.productId = [NSString stringWithFormat:@"%ld", info.params.product_id];
//                vc.orgId = [NSString stringWithFormat:@"%ld", info.params.orgId];
//                [[YkTool viewControllerWithView:self].navigationController pushViewController:vc animated:YES];
//            }
//                break;
//            case 5:
//            {
//                productType = @"定制游";
//
//                if ([UserLoginTool getMemberID].length == 0) {
//                    dispatch_async(dispatch_get_main_queue(), ^{
//                        LoginViewController *loginVC = [[LoginViewController alloc]init];
//                        UINavigationController* navController = [[UINavigationController alloc] initWithRootViewController:loginVC];
//                        navController.navigationBarHidden = YES;
//                        [[YkTool viewControllerWithView:self] presentViewController:navController animated:YES completion:nil];
//                    });
//                    return;
//                }
//
//                ProductDetailViewController *vc = [[ProductDetailViewController alloc] init];
//                vc.productId = [NSString stringWithFormat:@"%ld", info.params.product_id];
//                vc.orgId = [NSString stringWithFormat:@"%ld", info.params.orgId];
//                [[YkTool viewControllerWithView:self].navigationController pushViewController:vc animated:YES];
//            }
//                break;
//            case 6:
//
//            {
//                productType = @"周边游";
//                ProductDetailViewController *vc = [[ProductDetailViewController alloc] init];
//                vc.productId = [NSString stringWithFormat:@"%ld", info.params.product_id];
//                vc.orgId = [NSString stringWithFormat:@"%ld", info.params.orgId];
//                [[YkTool viewControllerWithView:self].navigationController pushViewController:vc animated:YES];
//            }
//                break;
//            case 99:
//            {
//                productType = @"目的地商城";
//                YKOptimalDeatilController *next = [[YKOptimalDeatilController alloc] init];
//                next.productId = [NSString stringWithFormat:@"%ld", info.params.product_id];
//                [[YkTool viewControllerWithView:self].navigationController pushViewController:next animated:YES];
//            }
//                break;
//            case 98:
//            {
//                productType = @"酒店";
//                HotelDeatilViewController *next = [[HotelDeatilViewController alloc] init];
//                //获取今天日期
//                NSDateFormatter *formatter = [[NSDateFormatter alloc] init];
//                formatter.dateFormat = @"yyyy-MM-dd";
//                NSDate *date = [NSDate date];
//                NSString *comeDateStr = [formatter stringFromDate:date];
//                NSLog(@"comeDateStr--%@",comeDateStr);
//                NSDate *lvdate = [self foo:date afterDay:1];
//                NSString *leaveDateStr = [formatter stringFromDate:lvdate];
//                NSLog(@"leaveDateStr--%@",leaveDateStr);
//                next.check_in_date = comeDateStr;
//                next.check_out_date = leaveDateStr;
//                next.hotelID = [NSString stringWithFormat:@"%ld", info.params.product_id];
//                [[YkTool viewControllerWithView:self].navigationController pushViewController:next animated:YES];
//            }
//                break;
//            case 97:
//            {
//                productType = @"景区";
//                TicketDetailController *next = [[TicketDetailController alloc] init];
//                next.scenicId = [NSString stringWithFormat:@"%ld", info.params.product_id];
//                [[YkTool viewControllerWithView:self].navigationController pushViewController:next animated:YES];
//            }
//
//                break;
//            case 96:
//            {
//                productType = @"签证";
//                VisaDetailVC *next = [[VisaDetailVC alloc] init];
//                next.visa_Id = info.params.product_id;
//                [[YkTool viewControllerWithView:self].navigationController pushViewController:next animated:YES];
//
//            }
//                break;
//
//            default:
//                break;
//        }
//    }
}

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath {
    
}

- (NSDate *)foo:(NSDate *)date afterDay:(NSInteger)afterDay
{
    NSDateFormatter * dateFormatter = [NSDateFormatter new];
    [dateFormatter setDateFormat: @"yyyy-MM-dd HH:mm:ss"];
    NSString * timeString = [dateFormatter stringFromDate:date];
    NSLog(@"%@",timeString);
    NSDate * newDate =  [date dateByAddingTimeInterval:(60 * 60 * 24 * afterDay)];
    //    [dateFormatter setDateFormat: @"yyyy-MM-dd HH:mm:ss"];
    //    timeString = [dateFormatter stringFromDate:newDate];
    //    NSLog(@"%ld天之后是 %@",afterDay,timeString);
    return newDate;
}

- (UITableView *)hotCollectionView {
    
    if (!_hotCollectionView) {
        _hotCollectionView = [[UITableView alloc] initWithFrame:CGRectZero style:UITableViewStylePlain];
        _hotCollectionView.backgroundColor = UIColorHex(FFFFFF);
        _hotCollectionView.layer.cornerRadius = 5;
        _hotCollectionView.delegate = self;
        _hotCollectionView.dataSource = self;
        _hotCollectionView.estimatedRowHeight = 0;
        _hotCollectionView.estimatedSectionHeaderHeight = 0;
        _hotCollectionView.estimatedSectionFooterHeight = 0;
        _hotCollectionView.scrollEnabled = NO;
        _hotCollectionView.separatorStyle = UITableViewCellSeparatorStyleNone;
        [_hotCollectionView registerClass:[HotActivityTableCell class] forCellReuseIdentifier:kHotActivityTableCellID];
        [_hotCollectionView registerClass:[ChosenThemeTableCell class] forCellReuseIdentifier:kChosenThemeTableCellID];
        _hotCollectionView.autoresizingMask = UIViewAutoresizingFlexibleRightMargin|UIViewAutoresizingFlexibleLeftMargin|UIViewAutoresizingFlexibleTopMargin|UIViewAutoresizingFlexibleBottomMargin|UIViewAutoresizingFlexibleWidth|UIViewAutoresizingFlexibleHeight;
    }
    return _hotCollectionView;
}

- (NSMutableArray *)activityThemeArr {
    if (!_activityThemeArr) {
        _activityThemeArr = [[NSMutableArray alloc] init];
    }
    return _activityThemeArr;
}

@end
