//
//  HomeNearFutureCycleView.m
//  Ykly
//
//  Created by 周权威 on 2019/7/23.
//  Copyright © 2019 YingKeTravel co.,Ltd. All rights reserved.
//

#import "HomeNearFutureCycleView.h"
#import "NearFutureOrderCell.h"
#import "NearFutureOrderInfo.h"
//#import "PlaneOrderDetailController.h"
//#import "AirTicketsOrderDetailVC.h"
//#import "IntlAirTicketsOrderDetailVC.h"
//#import "HotelOrderDetailVC.h"
//#import "TrainRailwayDetailVC.h"

@interface HomeNearFutureCycleView ()<SDCycleScrollViewDelegate>

@property (nonatomic, strong) SDCycleScrollView *nearFutureCycleView;

@property (nonatomic, strong) NSMutableArray *nearFutureArray;

@property (nonatomic, strong) NSMutableArray *imageArray;

@end

@implementation HomeNearFutureCycleView

- (instancetype)initWithFrame:(CGRect)frame {
    
    self = [super initWithFrame:frame];
    if (self) {
        self.autoresizesSubviews = YES;
        [self setUpSubViewsWithConstraints];
        [self requestCollectionData];
    }
    return self;
}

- (void)setUpSubViewsWithConstraints {
    
    [self addSubview:self.nearFutureCycleView];
    [self.nearFutureCycleView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.left.right.bottom.mas_equalTo(self);
    }];
}

- (void)requestCollectionData {
    
    NSString *url = [NSString stringWithFormat:@"%@v1/home/trip-reminder", BASE_PHP_URL];
    
    [[HttpRequest shareInstance] getWithHeaderDataPOST:url Paramter:nil CacheKey:nil success:^(NSURLSessionDataTask *task, id responseObject) {
        NSLog(@"json === %@",[YkTool idToJson:responseObject]);
        
        NSMutableArray *tmpFutureArray = [NSMutableArray array];
        NSMutableArray *tmpImgArr = [NSMutableArray array];
        
        if ([responseObject[@"flag"] integerValue] == 0) {
            NSArray *orderArr = responseObject[@"data"];
            
            for (NSDictionary *dict in orderArr) {
                NearFutureOrderInfo *activityInfo = [NearFutureOrderInfo mj_objectWithKeyValues:dict];
                [tmpFutureArray addObject:activityInfo];
                [tmpImgArr addObject:activityInfo.week];
            }
                        
        } else {}
        self.nearFutureArray = tmpFutureArray;
        self.imageArray = tmpImgArr;
        [self refreshViewAndSuperView];
    } failure:^(NSURLSessionDataTask *task, NSError *error) {
        self.nearFutureArray = [NSMutableArray array];
        self.imageArray = [NSMutableArray array];
        [self refreshViewAndSuperView];
    }];
    
}

- (void)refreshViewAndSuperView {
    
    self.nearFutureCycleView.imageURLStringsGroup = self.imageArray;
    [self.nearFutureCycleView layoutIfNeeded];
    CGFloat height = 0;
    if (self.imageArray.count) {
        height = adaptX(153);
    }
    
    if ([self.delegate respondsToSelector:@selector(updateNearFutureCycleViewHeight:)]) {

        [self.delegate updateNearFutureCycleViewHeight:height];
    }
}

#pragma mark - 跳转机票详情
- (void)orderDetailToflightOrderType:(NSInteger)flight_order_type orderNo:(NSString *)orderNO childNo:(NSString *)childNo
{
//    if (flight_order_type == 1) {
//        AirTicketsOrderDetailVC * vc = [AirTicketsOrderDetailVC new];
//        vc.orderNo = orderNO;
//        vc.childNo = childNo;
//        vc.refershList = ^{
//            [self requestCollectionData];
//        };
//        [[YkTool viewControllerWithView:self].navigationController pushViewController:vc animated:YES];
//    }else{
//        IntlAirTicketsOrderDetailVC * vc = [IntlAirTicketsOrderDetailVC new];
//        vc.orderNo = orderNO;
//        vc.childNo = childNo;
//        vc.refershList = ^{
//            [self requestCollectionData];
//        };
//        [[YkTool viewControllerWithView:self].navigationController pushViewController:vc animated:YES];
//    }
}

#pragma mark - 轮播图 SDCycleScrollViewDelegate
- (void)cycleScrollView:(SDCycleScrollView *)cycleScrollView didSelectItemAtIndex:(NSInteger)index {
    
    NSLog(@"---点击了第%ld张图片", (long)index);
//    NearFutureOrderInfo *orderInfo = self.nearFutureArray[index];
//    switch (orderInfo.order_type) {// 2-机票 3-酒店 5-火车票
//
//        case 2: // 2-机票
//            {
////                PlaneOrderDetailController *vc = [[PlaneOrderDetailController alloc] init];
////                vc.orderId = orderInfo.order_no;
////                [[YkTool viewControllerWithView:self].navigationController pushViewController:vc animated:YES];
//                [self orderDetailToflightOrderType:orderInfo.flight_order_type orderNo:orderInfo.order_no childNo:orderInfo.child_no];
//            }
//            break;
//        case 3: // 3-酒店
//            {
//                HotelOrderDetailVC *vc = [[HotelOrderDetailVC alloc] init];
//                vc.order_id = orderInfo.order_no;
//                [[YkTool viewControllerWithView:self].navigationController pushViewController:vc animated:YES];
//            }
//            break;
//        case 5: // 5-火车票
//            {
//                TrainRailwayDetailVC * vc = [TrainRailwayDetailVC new];
//                vc.order_no = orderInfo.order_no;
//                [[YkTool viewControllerWithView:self].navigationController pushViewController:vc animated:YES];
//            }
//            break;
//
//        default:
//            break;
//    }
    
}

/**
 * 如果要实现自定义cell的轮播图，必须先实现
 * customCollectionViewCellClassForCycleScrollView:
 * 和setupCustomCell:forIndex:代理方法
 */
- (Class)customCollectionViewCellClassForCycleScrollView:(SDCycleScrollView *)view {
    
    if (view != _nearFutureCycleView) {
        return nil;
    }
    return [NearFutureOrderCell class];
}

- (void)setupCustomCell:(UICollectionViewCell *)cell forIndex:(NSInteger)index cycleScrollView:(SDCycleScrollView *)view {
    
    NearFutureOrderCell *myCell = (NearFutureOrderCell *)cell;
    //    可以完全自定义cell setmodel方法中设置图片。
    myCell.orderInfo = self.nearFutureArray[index];
}

- (SDCycleScrollView *)nearFutureCycleView {
    
    if (!_nearFutureCycleView) {
        _nearFutureCycleView = [[SDCycleScrollView alloc] initWithFrame:CGRectMake(0, 0, SCREEN_WIDTH, 135 *KWidth_Scale)];
        _nearFutureCycleView.pageDotImage = [UIImage imageNamed:@"home_near_future_page_normal"];
        _nearFutureCycleView.currentPageDotImage = [UIImage imageNamed:@"home_near_future_page_current"];
        _nearFutureCycleView.placeholderImage = PLACEHOLDER_IMAGE;
        _nearFutureCycleView.bannerImageViewContentMode = UIViewContentModeScaleAspectFill;
//        _nearFutureCycleView.currentPageDotColor = MAIN_COLOR;
        _nearFutureCycleView.delegate = self;
//        _nearFutureCycleView.autoScrollTimeInterval = 5.0f;
        _nearFutureCycleView.autoScroll = NO;
        _nearFutureCycleView.infiniteLoop = NO;
        _nearFutureCycleView.imageURLStringsGroup = self.imageArray;
        _nearFutureCycleView.autoresizingMask = UIViewAutoresizingFlexibleRightMargin|UIViewAutoresizingFlexibleLeftMargin|UIViewAutoresizingFlexibleTopMargin|UIViewAutoresizingFlexibleBottomMargin|UIViewAutoresizingFlexibleWidth|UIViewAutoresizingFlexibleHeight;
    }
    return _nearFutureCycleView;
}

- (NSMutableArray *)nearFutureArray {
    if (!_nearFutureArray) {
        _nearFutureArray = [NSMutableArray array];
    }
    return _nearFutureArray;
}

- (NSMutableArray *)imageArray {
    if (!_imageArray) {
        _imageArray = [NSMutableArray array];
    }
    return _imageArray;
}

@end
