//
//  NearFutureAirTicketCellView.m
//  Ykly
//
//  Created by 周权威 on 2019/7/24.
//  Copyright © 2019 YingKeTravel co.,Ltd. All rights reserved.
//

#import "NearFutureAirTicketCellView.h"
//#import <JhtMarquee/JhtHorizontalMarquee.h>

@interface NearFutureAirTicketCellView ()

/**
 类别图片
 */
@property (nonatomic, strong) UIImageView *noteImageV;

/**
 出发到达城市和日期
 */
@property (nonatomic, strong) UILabel *fromToCityTimeLab;
@property (nonatomic, assign) BOOL isNeedRun;

/**
 航空公司图片
 */
@property (nonatomic, strong) UIImageView *airCompanyImageV;

/**
 航班号型号信息
 */
@property (nonatomic, strong) UILabel *planeNOTypeLab;

@property (nonatomic ,strong) UILabel *fromDateLabel;

@property (nonatomic ,strong) UILabel *arriveDateLabel;

@property (nonatomic ,strong) UILabel *run_timeLabel;

@property (nonatomic, strong) UILabel *run_daysLabel;

@property (nonatomic ,strong) UILabel *fromTimeLabel;

@property (nonatomic ,strong) UILabel *arriveTimeLabel;

@property (nonatomic ,strong) UILabel *fromAirPortLab;

@property (nonatomic ,strong) UILabel *arriveAirPortLab;

@end

@implementation NearFutureAirTicketCellView

- (instancetype)initWithFrame:(CGRect)frame {
    
    self = [super initWithFrame:frame];
    if (self) {
        self.backgroundColor = WHITE_COLOR;
        [self setUpSubViewsWithConstraints];
        self.isNeedRun = NO;
    }
    return self;
}

- (void)layoutSubviews {
    
    [super layoutSubviews];
    [YkTool maskLayerView:self byRoundingCorners:UIRectCornerAllCorners maskcornerRadii:CGSizeMake(10, 10)];
    //    [YkTool maskLayerView:self.cityLab byRoundingCorners:UIRectCornerBottomRight maskcornerRadii:CGSizeMake(10, 10)];
}

- (void)didMoveToSuperview {
    [super didMoveToSuperview];
    if (self.isNeedRun) {
//        [self.fromToCityTimeLab marqueeOfSettingWithState:MarqueeStart_H];
    }
}

- (void)removeFromSuperview {
    [super removeFromSuperview];
//    [self.fromToCityTimeLab marqueeOfSettingWithState:MarqueeShutDown_H];
}

- (void)setUpSubViewsWithConstraints {
    UIImageView *backImgV = [[UIImageView alloc] initWithImage:[UIImage imageNamed:@"home_ticket_bg_air"]];
    [self addSubview:backImgV];
    [backImgV mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.left.right.bottom.mas_equalTo(self);
    }];
    [self addSubview:self.noteImageV];
    [self.noteImageV mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.mas_equalTo(self.mas_left).offset(adaptX(34));
        make.top.mas_equalTo(self.mas_top);
        make.height.mas_equalTo(adaptX(37));
        make.width.mas_equalTo(adaptX(30));
    }];
    
    [self addSubview:self.fromToCityTimeLab];
    [self.fromToCityTimeLab mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.mas_equalTo(self.noteImageV.mas_right).offset(10);
        make.centerY.mas_equalTo(self.noteImageV.mas_centerY);
        make.height.mas_equalTo(adaptX(22));
        make.width.mas_equalTo(adaptX(250));
    }];
    
    [self addSubview:self.airCompanyImageV];
    [self.airCompanyImageV mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.mas_equalTo(self.mas_left).offset(adaptX(20));
        make.top.mas_equalTo(self.noteImageV.mas_bottom).offset(adaptX(12));
        make.height.mas_equalTo(adaptX(18));
        make.width.mas_equalTo(adaptX(18));
    }];
    
    [self addSubview:self.planeNOTypeLab];
    [self.planeNOTypeLab mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.mas_equalTo(self.airCompanyImageV.mas_right).offset(4);
        make.centerY.mas_equalTo(self.airCompanyImageV.mas_centerY);
        make.width.mas_lessThanOrEqualTo(adaptX(290));
        make.height.mas_equalTo(adaptX(16));
    }];
    
    [self addSubview:self.fromDateLabel];
    [self.fromDateLabel mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.mas_equalTo(self.airCompanyImageV.mas_bottom).offset(adaptX(2));
        make.centerX.mas_equalTo(self.mas_centerX).offset(-adaptX(95));
        make.height.mas_equalTo(adaptX(14));
    }];
    
    [self addSubview:self.fromTimeLabel];
    [self.fromTimeLabel mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.mas_equalTo(self.fromDateLabel.mas_bottom).offset(adaptX(4));
        make.centerX.mas_equalTo(self.fromDateLabel.mas_centerX);
        make.height.mas_equalTo(adaptX(26));
    }];
    
    [self addSubview:self.fromAirPortLab];
    [self.fromAirPortLab mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.mas_equalTo(self.fromTimeLabel.mas_bottom).offset(adaptX(4));
        make.centerX.mas_equalTo(self.fromTimeLabel.mas_centerX);
        make.height.mas_equalTo(adaptX(14));
    }];
    
    [self addSubview:self.arriveDateLabel];
    [self.arriveDateLabel mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.mas_equalTo(self.fromDateLabel.mas_top);
        make.centerX.mas_equalTo(self.mas_centerX).offset(adaptX(80));
        make.height.mas_equalTo(adaptX(14));
    }];
    
    
    [self addSubview:self.arriveTimeLabel];
    [self.arriveTimeLabel mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.mas_equalTo(self.arriveDateLabel.mas_bottom).offset(adaptX(4));
        make.centerX.mas_equalTo(self.arriveDateLabel.mas_centerX);
        make.height.mas_equalTo(adaptX(26));
    }];
    
    [self addSubview:self.arriveAirPortLab];
    [self.arriveAirPortLab mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.mas_equalTo(self.arriveTimeLabel.mas_bottom).offset(adaptX(4));
        make.centerX.mas_equalTo(self.arriveTimeLabel.mas_centerX);
        make.height.mas_equalTo(adaptX(14));
//        make.left.mas_greaterThanOrEqualTo(self.mas_centerX);
    }];
    
    UIImageView *imgView = [[UIImageView alloc] init];
    imgView.image = [UIImage imageNamed:@"home_air_ticket_arrow_up"];
    [self addSubview:imgView];
    [imgView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerY.mas_equalTo(self.fromTimeLabel.mas_centerY).offset(adaptX(10));
        make.centerX.mas_equalTo(self.mas_centerX).offset(-adaptX(5));
        make.width.mas_equalTo(adaptX(46));
        make.height.mas_equalTo(adaptX(4));
    }];
    
    [self addSubview:self.run_timeLabel];
    [self.run_timeLabel mas_makeConstraints:^(MASConstraintMaker *make) {
        
        make.centerX.mas_equalTo(imgView.mas_centerX);
        make.bottom.mas_equalTo(imgView.mas_top).offset(-adaptX(5));
        make.height.mas_equalTo(adaptX(14));
    }];
    
    [self addSubview:self.run_daysLabel];
    [self.run_daysLabel mas_makeConstraints:^(MASConstraintMaker *make) {
        make.right.mas_equalTo(self.mas_right).offset(-adaptX(10));
        make.centerY.mas_equalTo(self.arriveTimeLabel.mas_centerY);
        make.height.mas_equalTo(adaptX(16));
    }];
    
}

- (void)setAirticketInfo:(NearFutureOrderInfo *)airticketInfo {
    _airticketInfo = airticketInfo;
    NSString *departArriveStr = [NSString stringWithFormat:@"%@-%@ %@ %@", airticketInfo.depart_city_name, airticketInfo.arrive_city_name, airticketInfo.depart_date_title, airticketInfo.week];
    self.fromToCityTimeLab.text = departArriveStr;
    
    NSString *planeCompanyNO = [NSString stringWithFormat:@"%@%@ %@|机型%@", airticketInfo.airline_company, airticketInfo.flight_no, airticketInfo.meal_flag_name, airticketInfo.craft_type];
    self.planeNOTypeLab.text = planeCompanyNO;
    
    self.fromDateLabel.text = airticketInfo.depart_date;
    self.arriveDateLabel.text = airticketInfo.arrive_date;
    self.fromTimeLabel.text = airticketInfo.depart_time;
    self.arriveTimeLabel.text = airticketInfo.arrive_time;
    self.fromAirPortLab.text = [NSString stringWithFormat:@"%@%@",airticketInfo.depart_airport_name, airticketInfo.depart_airport_terminal];
    self.arriveAirPortLab.text = [NSString stringWithFormat:@"%@%@",airticketInfo.arrive_airport_name, airticketInfo.arrive_airport_terminal];
    self.run_timeLabel.text = airticketInfo.duration;
    if (airticketInfo.days > 0) {
        self.run_daysLabel.text = [NSString stringWithFormat:@"+%ld天", airticketInfo.days];
    }
    NSString *airlineCode = [NSString stringWithFormat:@"https://static.yktour.com.cn/www/assets/%@.png",airticketInfo.airline_code];
    [self.airCompanyImageV setImageWithURL:[NSURL URLWithString:airlineCode] placeholder:[UIImage imageNamed:@"home_plane_icon"]];
    if ([YkTool isBlankString:departArriveStr]) {
        self.isNeedRun = YES;
//        [self.fromToCityTimeLab marqueeOfSettingWithState:MarqueeStart_H];
    } else {
        self.isNeedRun = NO;
    }
}

- (UIImageView *)noteImageV {
    if (!_noteImageV) {
        _noteImageV = [[UIImageView alloc] init];
        _noteImageV.image = [UIImage imageNamed:@"home_air_plane_icon"];
    }
    return _noteImageV;
}

- (UILabel *)fromToCityTimeLab {
    if (!_fromToCityTimeLab) {
        _fromToCityTimeLab = [[UILabel alloc] initWithFrame:CGRectZero];
        _fromToCityTimeLab.size = CGSizeMake(adaptX(250), adaptX(22));
        _fromToCityTimeLab.textColor = UIColorHex(FFFFFF);
        _fromToCityTimeLab.font = kPingFangMedium(15);
        _fromToCityTimeLab.textAlignment = NSTextAlignmentLeft;
    }
    return _fromToCityTimeLab;
}

- (UIImageView *)airCompanyImageV {
    if (!_airCompanyImageV) {
        _airCompanyImageV = [[UIImageView alloc] init];
        _airCompanyImageV.image = [UIImage imageNamed:@"home_plane_icon"];
    }
    return _airCompanyImageV;
}

- (UILabel *)planeNOTypeLab {
    if (!_planeNOTypeLab) {
        _planeNOTypeLab = [[UILabel alloc] init];
        _planeNOTypeLab.textColor = UIColorHex(FFFFFF);
        _planeNOTypeLab.font = kPingFangRegular(14);
    }
    return _planeNOTypeLab;
}

- (UILabel *)fromDateLabel {
    if (!_fromDateLabel) {
        _fromDateLabel = [[UILabel alloc] init];
        _fromDateLabel.textColor = UIColorHex(FFFFFF);
        _fromDateLabel.font = kPingFangRegular(14);
        _fromDateLabel.textAlignment = NSTextAlignmentCenter;
    }
    return _fromDateLabel;
}

- (UILabel *)arriveDateLabel {
    if (!_arriveDateLabel) {
        _arriveDateLabel = [[UILabel alloc] init];
        _arriveDateLabel.textColor = UIColorHex(FFFFFF);
        _arriveDateLabel.font = kPingFangRegular(14);
        _arriveDateLabel.textAlignment = NSTextAlignmentCenter;
    }
    return _arriveDateLabel;
}

- (UILabel *)fromTimeLabel {
    
    if (!_fromTimeLabel) {
        
        _fromTimeLabel = [[UILabel alloc] init];
        _fromTimeLabel.textColor = UIColorHex(FFFFFF);
        _fromTimeLabel.font = kPingFangRegular(26);
        _fromTimeLabel.textAlignment = NSTextAlignmentCenter;
    }
    return _fromTimeLabel;
}

- (UILabel *)arriveTimeLabel {
    
    if (!_arriveTimeLabel) {
        
        _arriveTimeLabel = [[UILabel alloc] init];
        _arriveTimeLabel.textColor = UIColorHex(FFFFFF);
        _arriveTimeLabel.font = kPingFangMedium(26);
        _arriveTimeLabel.textAlignment = NSTextAlignmentCenter;
    }
    return _arriveTimeLabel;
}

- (UILabel *)fromAirPortLab {
    
    if (!_fromAirPortLab) {
        
        _fromAirPortLab = [[UILabel alloc] init];
        _fromAirPortLab.textColor = UIColorHex(FFFFFF);
        _fromAirPortLab.font = kPingFangRegular(14);
        _fromAirPortLab.textAlignment = NSTextAlignmentCenter;
    }
    return _fromAirPortLab;
}

- (UILabel *)arriveAirPortLab {
    
    if (!_arriveAirPortLab) {
        
        _arriveAirPortLab = [[UILabel alloc] init];
        _arriveAirPortLab.textColor = UIColorHex(FFFFFF);
        _arriveAirPortLab.font = kPingFangRegular(14);
        _arriveAirPortLab.textAlignment = NSTextAlignmentCenter;
    }
    return _arriveAirPortLab;
}

- (UILabel *)run_timeLabel {
    
    if (!_run_timeLabel) {
        _run_timeLabel = [[UILabel alloc] init];
        _run_timeLabel.textColor = UIColorHex(FFFFFF);
        _run_timeLabel.font = kPingFangRegular(14);
    }
    return _run_timeLabel;
}

- (UILabel *)run_daysLabel {
    
    if (!_run_daysLabel) {
        _run_daysLabel = [[UILabel alloc] init];
        _run_daysLabel.textColor = UIColorHex(FFF371);
        _run_daysLabel.font = kPingFangRegular(14);
    }
    return _run_daysLabel;
}

@end
