//
//  NearFutureHotelCellView.m
//  Ykly
//
//  Created by 周权威 on 2019/7/24.
//  Copyright © 2019 YingKeTravel co.,Ltd. All rights reserved.
//

#import "NearFutureHotelCellView.h"
//#import <JhtMarquee/JhtHorizontalMarquee.h>
#import "Masonry.h"

@interface NearFutureHotelCellView ()

/**
 类别图片
 */
@property (nonatomic, strong) UIImageView *noteImageV;

/**
 城市和日期
 */
@property (nonatomic, strong) UILabel *fromToCityTimeLab;
@property (nonatomic, assign) BOOL isNeedRun;

@property (nonatomic ,strong) UILabel *hotelNameTelLabel;

@property (nonatomic ,strong) UILabel *addressDetailLabel;

@property (nonatomic ,strong) UILabel *fromToDateBreakfast;

@property (nonatomic ,strong) UILabel *roomTypeLabel;

@end

@implementation NearFutureHotelCellView

- (instancetype)initWithFrame:(CGRect)frame {
    
    self = [super initWithFrame:frame];
    if (self) {
        self.backgroundColor = [UIColor whiteColor];
        [self setUpSubViewsWithConstraints];
        self.isNeedRun = NO;
    }
    return self;
}

- (void)layoutSubviews {
    
    [super layoutSubviews];
//    [YkTool maskLayerView:self byRoundingCorners:UIRectCornerAllCorners maskcornerRadii:CGSizeMake(10, 10)];
    //    [YkTool maskLayerView:self.cityLab byRoundingCorners:UIRectCornerBottomRight maskcornerRadii:CGSizeMake(10, 10)];
}

- (void)didMoveToSuperview {
    [super didMoveToSuperview];
    if (self.isNeedRun) {
//        [self.fromToCityTimeLab marqueeOfSettingWithState:MarqueeStart_H];
    }
}

- (void)removeFromSuperview {
    [super removeFromSuperview];
//    [self.fromToCityTimeLab marqueeOfSettingWithState:MarqueeShutDown_H];
}

- (void)setUpSubViewsWithConstraints {
    UIImageView *backImgV = [[UIImageView alloc] initWithImage:[UIImage imageNamed:@"home_ticket_bg_hotel"]];
    [self addSubview:backImgV];
    [backImgV mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.left.right.bottom.mas_equalTo(self);
    }];
    [self addSubview:self.noteImageV];
    [self.noteImageV mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.mas_equalTo(self.mas_left).offset(adaptX(34));
        make.top.mas_equalTo(self.mas_top);
        make.height.mas_equalTo(adaptX(37));
        make.width.mas_equalTo(adaptX(30));
    }];
    
    [self addSubview:self.fromToCityTimeLab];
    [self.fromToCityTimeLab mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.mas_equalTo(self.noteImageV.mas_right).offset(10);
        make.centerY.mas_equalTo(self.noteImageV.mas_centerY);
        make.height.mas_equalTo(adaptX(22));
        make.width.mas_equalTo(adaptX(250));
    }];
    
    [self addSubview:self.hotelNameTelLabel];
    [self.hotelNameTelLabel mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.mas_equalTo(self.noteImageV.mas_bottom).offset(adaptX(12));
        make.left.mas_equalTo(self.mas_left).offset(adaptX(32));
        make.height.mas_equalTo(adaptX(14));
    }];
    
    [self addSubview:self.addressDetailLabel];
    [self.addressDetailLabel mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.mas_equalTo(self.hotelNameTelLabel.mas_bottom).offset(adaptX(10));
        make.left.mas_equalTo(self.hotelNameTelLabel.mas_left);
        make.height.mas_equalTo(adaptX(14));
    }];
    
    [self addSubview:self.roomTypeLabel];
    [self.roomTypeLabel mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.mas_equalTo(self.addressDetailLabel.mas_bottom).offset(adaptX(10));
        make.left.mas_equalTo(self.hotelNameTelLabel.mas_left);
        make.height.mas_equalTo(adaptX(14));
    }];
    
    [self addSubview:self.fromToDateBreakfast];
    [self.fromToDateBreakfast mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.mas_equalTo(self.roomTypeLabel.mas_bottom).offset(adaptX(10));
        make.centerX.mas_equalTo(self.mas_centerX).offset(adaptX(80));
        make.left.mas_equalTo(self.hotelNameTelLabel.mas_left);
        make.height.mas_equalTo(adaptX(14));
    }];
    
}

- (void)setHotelInfo:(NearFutureOrderInfo *)hotelInfo {
    _hotelInfo = hotelInfo;
    NSString *departArriveStr = [NSString stringWithFormat:@"%@ %@ %@", hotelInfo.city_name, hotelInfo.checkin_date_title, hotelInfo.week];
    self.fromToCityTimeLab.text = departArriveStr;
    
    NSString *hotelNameTelStr = [NSString stringWithFormat:@"%@  %@", hotelInfo.hotel_name, hotelInfo.telephone];
    self.hotelNameTelLabel.text = hotelNameTelStr;
    
    self.addressDetailLabel.text = hotelInfo.address;
    self.roomTypeLabel.text = hotelInfo.package_name;
    
    NSMutableAttributedString *attStr = [[NSMutableAttributedString alloc] initWithString:hotelInfo.checkin_date attributes:@{NSFontAttributeName : kPingFangRegular(13), NSForegroundColorAttributeName : UIColorHex(F4FF7E)}];
    NSString *dateBreakstr = [NSString stringWithFormat:@"至%@共%ld晚%ld间|%@", hotelInfo.checkout_date, hotelInfo.days, hotelInfo.room_num, hotelInfo.foods];
    NSAttributedString *dateBreakAtt = [[NSAttributedString alloc] initWithString:dateBreakstr attributes:@{NSFontAttributeName : kPingFangRegular(13), NSForegroundColorAttributeName : UIColorHex(FFFFFF)}];
    [attStr appendAttributedString:dateBreakAtt];
    self.fromToDateBreakfast.attributedText = attStr;
//    if ([YkTool isBlankString:departArriveStr]) {
//        self.isNeedRun = YES;
////        [self.fromToCityTimeLab marqueeOfSettingWithState:MarqueeStart_H];
//    } else {
//        self.isNeedRun = NO;
//    }
}

- (UIImageView *)noteImageV {
    if (!_noteImageV) {
        _noteImageV = [[UIImageView alloc] init];
        _noteImageV.image = [UIImage imageNamed:@"home_ticket_hotel"];
    }
    return _noteImageV;
}

- (UILabel *)fromToCityTimeLab {
    if (!_fromToCityTimeLab) {
        _fromToCityTimeLab = [[UILabel alloc] init];
        _fromToCityTimeLab.size = CGSizeMake(adaptX(250), adaptX(22));
        _fromToCityTimeLab.textColor = UIColorHex(FFFFFF);
        _fromToCityTimeLab.font = kPingFangMedium(15);
        _fromToCityTimeLab.textAlignment = NSTextAlignmentLeft;
    }
    return _fromToCityTimeLab;
}

- (UILabel *)hotelNameTelLabel {
    if (!_hotelNameTelLabel) {
        _hotelNameTelLabel = [[UILabel alloc] init];
        _hotelNameTelLabel.textColor = UIColorHex(FFFFFF);
        _hotelNameTelLabel.font = kPingFangRegular(13);
        _hotelNameTelLabel.textAlignment = NSTextAlignmentLeft;
    }
    return _hotelNameTelLabel;
}

- (UILabel *)addressDetailLabel {
    
    if (!_addressDetailLabel) {
        
        _addressDetailLabel = [[UILabel alloc] init];
        _addressDetailLabel.textColor = UIColorHex(FFFFFF);
        _addressDetailLabel.font = kPingFangRegular(13);
        _addressDetailLabel.textAlignment = NSTextAlignmentLeft;
    }
    return _addressDetailLabel;
}

- (UILabel *)fromToDateBreakfast {
    if (!_fromToDateBreakfast) {
        _fromToDateBreakfast = [[UILabel alloc] init];
        _fromToDateBreakfast.textColor = UIColorHex(FFFFFF);
        _fromToDateBreakfast.font = kPingFangRegular(13);
        _fromToDateBreakfast.textAlignment = NSTextAlignmentLeft;
    }
    return _fromToDateBreakfast;
}

- (UILabel *)roomTypeLabel {
    
    if (!_roomTypeLabel) {
        
        _roomTypeLabel = [[UILabel alloc] init];
        _roomTypeLabel.textColor = UIColorHex(FFFFFF);
        _roomTypeLabel.font = kPingFangRegular(13);
        _roomTypeLabel.textAlignment = NSTextAlignmentLeft;
    }
    return _roomTypeLabel;
}

@end
