//
//  NearFutureOrderCell.m
//  Ykly
//
//  Created by 周权威 on 2019/7/24.
//  Copyright © 2019 YingKeTravel co.,Ltd. All rights reserved.
//

#import "NearFutureOrderCell.h"
#import "NearFutureAirTicketCellView.h"
#import "NearFutureTrainCellView.h"
#import "NearFutureHotelCellView.h"
#import "Masonry.h"

@interface NearFutureOrderCell ()

@property (nonatomic, strong) NearFutureAirTicketCellView *airTicketView;

@property (nonatomic, strong) NearFutureTrainCellView *trainView;

@property (nonatomic, strong) NearFutureHotelCellView *hotelView;

@end

@implementation NearFutureOrderCell

- (instancetype)initWithFrame:(CGRect)frame {
    
    self = [super initWithFrame:frame];
    if (self) {
        self.backgroundColor = [UIColor whiteColor];
        [self setUpSubViewsWithConstraints];
    }
    return self;
}

- (void)layoutSubviews {
    
    [super layoutSubviews];
//    [YkTool maskLayerView:self byRoundingCorners:UIRectCornerAllCorners maskcornerRadii:CGSizeMake(10, 10)];
    //    [YkTool maskLayerView:self.cityLab byRoundingCorners:UIRectCornerBottomRight maskcornerRadii:CGSizeMake(10, 10)];
}

- (void)setUpSubViewsWithConstraints {
    
    [self.contentView addSubview:self.airTicketView];
    [self.airTicketView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.right.top.bottom.mas_equalTo(self.contentView);
    }];
    
    [self.contentView addSubview:self.trainView];
    [self.trainView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.right.top.bottom.mas_equalTo(self.contentView);
    }];
    
    [self.contentView addSubview:self.hotelView];
    [self.hotelView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.right.top.bottom.mas_equalTo(self.contentView);
    }];
    
}

- (void)setOrderInfo:(NearFutureOrderInfo *)orderInfo {
    _orderInfo = orderInfo;
    self.airTicketView.hidden = YES;
    self.trainView.hidden = YES;
    self.hotelView.hidden = YES;
    switch (orderInfo.order_type) {
        case 2:
            {
                self.airTicketView.hidden = NO;
                self.airTicketView.airticketInfo = self.orderInfo;
            }
            break;
        case 3:
            {
                self.hotelView.hidden = NO;
                self.hotelView.hotelInfo = self.orderInfo;
            }
            break;
        case 5:
            {
                self.trainView.hidden = NO;
                self.trainView.hotelInfo = self.orderInfo;
            }
            break;
            
        default:
            break;
    }
}

- (NearFutureAirTicketCellView *)airTicketView {
    
    if (!_airTicketView) {
        _airTicketView = [[NearFutureAirTicketCellView alloc] init];
        _airTicketView.hidden = YES;
    }
    return _airTicketView;
}

- (NearFutureTrainCellView *)trainView {
    
    if (!_trainView) {
        _trainView = [[NearFutureTrainCellView alloc] init];
        _trainView.hidden = YES;
    }
    return _trainView;
}

- (NearFutureHotelCellView *)hotelView {
    
    if (!_hotelView) {
        _hotelView = [[NearFutureHotelCellView alloc] init];
        _hotelView.hidden = YES;
    }
    return _hotelView;
}

@end
