//
//  NearFutureTrainCellView.m
//  Ykly
//
//  Created by 周权威 on 2019/7/24.
//  Copyright © 2019 YingKeTravel co.,Ltd. All rights reserved.
//

#import "NearFutureTrainCellView.h"
//#import <JhtMarquee/JhtHorizontalMarquee.h>

@interface NearFutureTrainCellView ()

/**
 类别图片
 */
@property (nonatomic, strong) UIImageView *noteImageV;

/**
 出发到达城市和日期
 */
@property (nonatomic, strong) UILabel *fromToCityTimeLab;
@property (nonatomic, assign) BOOL isNeedRun;

/**
 车次
 */
@property (nonatomic ,strong) UILabel *trainNoLabel;

@property (nonatomic ,strong) UILabel *fromDateLabel;

@property (nonatomic ,strong) UILabel *arriveDateLabel;

@property (nonatomic ,strong) UILabel *run_timeLabel;

@property (nonatomic, strong) UILabel *run_daysLabel;

@property (nonatomic ,strong) UILabel *fromTimeLabel;

@property (nonatomic ,strong) UILabel *arriveTimeLabel;

@end

@implementation NearFutureTrainCellView

- (instancetype)initWithFrame:(CGRect)frame {
    
    self = [super initWithFrame:frame];
    if (self) {
        self.backgroundColor = WHITE_COLOR;
        [self setUpSubViewsWithConstraints];
        self.isNeedRun = NO;
    }
    return self;
}

- (void)layoutSubviews {
    
    [super layoutSubviews];
    [YkTool maskLayerView:self byRoundingCorners:UIRectCornerAllCorners maskcornerRadii:CGSizeMake(10, 10)];
    //    [YkTool maskLayerView:self.cityLab byRoundingCorners:UIRectCornerBottomRight maskcornerRadii:CGSizeMake(10, 10)];
}

- (void)didMoveToSuperview {
    [super didMoveToSuperview];
    if (self.isNeedRun) {
//        [self.fromToCityTimeLab marqueeOfSettingWithState:MarqueeStart_H];
    }
}

- (void)removeFromSuperview {
    [super removeFromSuperview];
//    [self.fromToCityTimeLab marqueeOfSettingWithState:MarqueeShutDown_H];
}

- (void)setUpSubViewsWithConstraints {
    UIImageView *backImgV = [[UIImageView alloc] initWithImage:[UIImage imageNamed:@"home_ticket_bg_train"]];
    [self addSubview:backImgV];
    [backImgV mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.left.right.bottom.mas_equalTo(self);
    }];
    [self addSubview:self.noteImageV];
    [self.noteImageV mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.mas_equalTo(self.mas_left).offset(adaptX(34));
        make.top.mas_equalTo(self.mas_top);
        make.height.mas_equalTo(adaptX(37));
        make.width.mas_equalTo(adaptX(30));
    }];
    
    [self addSubview:self.fromToCityTimeLab];
    [self.fromToCityTimeLab mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.mas_equalTo(self.noteImageV.mas_right).offset(10);
        make.centerY.mas_equalTo(self.noteImageV.mas_centerY);
        make.height.mas_equalTo(adaptX(22));
        make.width.mas_equalTo(adaptX(250));
    }];
    
    [self addSubview:self.trainNoLabel];
    [self.trainNoLabel mas_makeConstraints:^(MASConstraintMaker *make) {
        
        make.centerX.mas_equalTo(self.mas_centerX);
        make.top.mas_equalTo(self.noteImageV.mas_bottom).offset(adaptX(20));
        make.height.mas_equalTo(adaptX(18));
    }];
    
    [self addSubview:self.fromDateLabel];
    [self.fromDateLabel mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.mas_equalTo(self.trainNoLabel.mas_bottom);
        make.centerX.mas_equalTo(self.mas_centerX).offset(-adaptX(95));
        make.height.mas_equalTo(adaptX(14));
    }];
    
    [self addSubview:self.fromTimeLabel];
    [self.fromTimeLabel mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.mas_equalTo(self.fromDateLabel.mas_bottom).offset(adaptX(4));
        make.centerX.mas_equalTo(self.fromDateLabel.mas_centerX);
        make.height.mas_equalTo(adaptX(26));
    }];
    
    [self addSubview:self.arriveDateLabel];
    [self.arriveDateLabel mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.mas_equalTo(self.fromDateLabel.mas_top);
        make.centerX.mas_equalTo(self.mas_centerX).offset(adaptX(80));
        make.height.mas_equalTo(adaptX(14));
    }];
    
    
    [self addSubview:self.arriveTimeLabel];
    [self.arriveTimeLabel mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.mas_equalTo(self.arriveDateLabel.mas_bottom).offset(adaptX(4));
        make.centerX.mas_equalTo(self.arriveDateLabel.mas_centerX);
        make.height.mas_equalTo(adaptX(26));
    }];
    
    [self addSubview:self.run_timeLabel];
    [self.run_timeLabel mas_makeConstraints:^(MASConstraintMaker *make) {
        
        make.centerX.mas_equalTo(self.trainNoLabel.mas_centerX);
        make.top.mas_equalTo(self.trainNoLabel.mas_bottom).offset(adaptX(10));
        make.height.mas_equalTo(adaptX(14));
    }];
    
    UIImageView *imgView = [[UIImageView alloc] init];
    imgView.image = [UIImage imageNamed:@"home_air_ticket_arrow_up"];
    [self addSubview:imgView];
    [imgView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.mas_equalTo(self.run_timeLabel.mas_bottom).offset(adaptX(5));
        make.centerX.mas_equalTo(self.run_timeLabel.mas_centerX);
        make.width.mas_equalTo(adaptX(46));
        make.height.mas_equalTo(adaptX(4));
    }];
    
    [self addSubview:self.run_daysLabel];
    [self.run_daysLabel mas_makeConstraints:^(MASConstraintMaker *make) {
        make.right.mas_equalTo(self.mas_right).offset(-adaptX(10));
        make.centerY.mas_equalTo(self.arriveTimeLabel.mas_centerY);
        make.height.mas_equalTo(adaptX(16));
    }];
    
}

- (void)setHotelInfo:(NearFutureOrderInfo *)hotelInfo {
    _hotelInfo = hotelInfo;
    NSString *departArriveStr = [NSString stringWithFormat:@"%@-%@ %@ %@", hotelInfo.from_station_name, hotelInfo.to_station_name, hotelInfo.start_date_title, hotelInfo.week];
    self.fromToCityTimeLab.text = departArriveStr;
    self.trainNoLabel.text = hotelInfo.checi;
    self.fromDateLabel.text = hotelInfo.start_date;
    self.arriveDateLabel.text = hotelInfo.arrive_date;
    self.fromTimeLabel.text = hotelInfo.start_time;
    self.arriveTimeLabel.text = hotelInfo.arrive_time;
    self.run_timeLabel.text = hotelInfo.run_time;
    if (hotelInfo.days > 0) {
        self.run_daysLabel.text = [NSString stringWithFormat:@"+%ld天", hotelInfo.days];
    }
    if ([YkTool isBlankString:departArriveStr]) {
        self.isNeedRun = YES;
//        [self.fromToCityTimeLab marqueeOfSettingWithState:MarqueeStart_H];
    } else {
        self.isNeedRun = NO;
    }
}

- (UIImageView *)noteImageV {
    if (!_noteImageV) {
        _noteImageV = [[UIImageView alloc] init];
        _noteImageV.image = [UIImage imageNamed:@"home_ticket_train"];
    }
    return _noteImageV;
}

- (UILabel *)fromToCityTimeLab {
    if (!_fromToCityTimeLab) {
        _fromToCityTimeLab = [[UILabel alloc] initWithFrame:CGRectZero];
        _fromToCityTimeLab.size = CGSizeMake(adaptX(250), adaptX(22));
        _fromToCityTimeLab.textColor = UIColorHex(FFFFFF);
        _fromToCityTimeLab.font = kPingFangMedium(15);
        _fromToCityTimeLab.textAlignment = NSTextAlignmentLeft;
    }
    return _fromToCityTimeLab;
}

- (UILabel *)fromDateLabel {
    if (!_fromDateLabel) {
        _fromDateLabel = [[UILabel alloc] init];
        _fromDateLabel.textColor = UIColorHex(FFFFFF);
        _fromDateLabel.font = kPingFangRegular(14);
        _fromDateLabel.textAlignment = NSTextAlignmentCenter;
    }
    return _fromDateLabel;
}

- (UILabel *)arriveDateLabel {
    if (!_arriveDateLabel) {
        _arriveDateLabel = [[UILabel alloc] init];
        _arriveDateLabel.textColor = UIColorHex(FFFFFF);
        _arriveDateLabel.font = kPingFangRegular(14);
        _arriveDateLabel.textAlignment = NSTextAlignmentCenter;
    }
    return _arriveDateLabel;
}

- (UILabel *)fromTimeLabel {
    
    if (!_fromTimeLabel) {
        
        _fromTimeLabel = [[UILabel alloc] init];
        _fromTimeLabel.textColor = UIColorHex(FFFFFF);
        _fromTimeLabel.font = kPingFangRegular(26);
        _fromTimeLabel.textAlignment = NSTextAlignmentCenter;
    }
    return _fromTimeLabel;
}

- (UILabel *)arriveTimeLabel {
    
    if (!_arriveTimeLabel) {
        
        _arriveTimeLabel = [[UILabel alloc] init];
        _arriveTimeLabel.textColor = UIColorHex(FFFFFF);
        _arriveTimeLabel.font = kPingFangMedium(26);
        _arriveTimeLabel.textAlignment = NSTextAlignmentCenter;
    }
    return _arriveTimeLabel;
}

- (UILabel *)run_timeLabel {
    
    if (!_run_timeLabel) {
        _run_timeLabel = [[UILabel alloc] init];
        _run_timeLabel.textColor = UIColorHex(FFFFFF);
        _run_timeLabel.font = kPingFangRegular(14);
    }
    return _run_timeLabel;
}

- (UILabel *)run_daysLabel {
    
    if (!_run_daysLabel) {
        _run_daysLabel = [[UILabel alloc] init];
        _run_daysLabel.textColor = UIColorHex(FFF371);
        _run_daysLabel.font = kPingFangRegular(14);
    }
    return _run_daysLabel;
}

- (UILabel *)trainNoLabel {
    
    if (!_trainNoLabel) {
        _trainNoLabel = [[UILabel alloc] init];
        _trainNoLabel.textColor = UIColorHex(F4FF7E);
        _trainNoLabel.font = kPingFangMedium(17);
    }
    return _trainNoLabel;
}

@end
