//
//  HttpRequest.m
//  Ykly
//
//  Created by sun on 16/7/25.
//  Copyright © 2016年 YingkeTravel co.,Ltd. All rights reserved.
//

#import "HttpRequest.h"
#import "AppDelegate.h"
#import "UserLoginTool.h"

@implementation HttpRequest
+(HttpRequest *)shareInstance {
    
    static HttpRequest *mHttpRequest;
    static dispatch_once_t once;
    dispatch_once(&once, ^ {
        mHttpRequest = [[HttpRequest alloc] init];
    });
    return mHttpRequest;
}

#pragma mark -- AFN加载
//AFN POST
- (nullable NSURLSessionDataTask *)POST:(NSString *)URLString parameters:(nullable id)parameters CacheKey:(NSString *)CacheKey timeoutInterval:(NSTimeInterval)timeoutInterval
                                success:(nullable void (^)(NSURLSessionDataTask *task, id _Nullable responseObject))success
                                failure:(nullable void (^)(NSURLSessionDataTask * _Nullable task, NSError *error))failure{
    AFHTTPSessionManager *manager = [AFHTTPSessionManager manager];
    // 设置请求格式
    manager.requestSerializer = [AFJSONRequestSerializer serializer];
    // 设置返回格式
    manager.responseSerializer = [AFJSONResponseSerializer serializer];
    //设置超时时间
    manager.requestSerializer.timeoutInterval = timeoutInterval;
    //设置缓存策略
    manager.requestSerializer.cachePolicy = NSURLRequestUseProtocolCachePolicy|NSURLRequestReloadIgnoringLocalCacheData;
    //设置解析
    manager.responseSerializer.acceptableContentTypes = [NSSet setWithObjects:@"text/json", @"text/plain", @"text/html",@"charset=utf-8",@"application/json",@"text/javascript", nil];

    if (CacheKey != nil) {
        NSString *readString = [NSString stringWithFormat:@"%@",CacheKey];
        //将NSString 对象存储到 NSUserDefaults 中
        NSUserDefaults *user = [NSUserDefaults standardUserDefaults];
        NSDictionary *responseObjectDict = [user objectForKey:readString];
        //回掉缓存
        if (responseObjectDict != nil) {
            success(nil, responseObjectDict);
        }
        //写缓存
        success = ^(NSURLSessionDataTask *task, id responseObject) {
            if ([responseObject isKindOfClass:[NSDictionary class]]){
                NSLog(@"AFN数据获取成功-加缓存----------------->%@",URLString);
                success(task,responseObject);
            }else{
                
            }
        };
    }else{
        success = ^(NSURLSessionDataTask *task, id responseObject) {
            if ([responseObject isKindOfClass:[NSDictionary class]]){
                NSLog(@"AFN数据获取成功-无缓存----------------->%@",URLString);
    
                success(task,responseObject);
            }else{
                
//                [[MBHud shareInstance] showHUDWithText:@"后台数据格式错误" view:nil];
            }
        };
    }
    failure = ^(NSURLSessionDataTask *task, NSError *error){
        NSLog(@"AFN数据获取失败----------------------->%@",URLString);
        failure(task,error);
    };
    
    return [manager POST:URLString parameters:parameters progress:nil success:success failure:failure];
}

//带请求头的post 方法
- (nullable NSURLSessionDataTask *)headerPOST:(NSString *)URLString parameters:(nullable id)parameters CacheKey:(NSString *)CacheKey timeoutInterval:(NSTimeInterval)timeoutInterval
                                success:(nullable void (^)(NSURLSessionDataTask *task, id _Nullable responseObject))success
                                failure:(nullable void (^)(NSURLSessionDataTask * _Nullable task, NSError *error))failure{
    
    
    
   
    AFHTTPSessionManager *manager = [AFHTTPSessionManager manager];
    // 设置请求格式
    manager.requestSerializer = [AFJSONRequestSerializer serializer];
    // 设置返回格式
    manager.responseSerializer = [AFJSONResponseSerializer serializer];
    //设置超时时间
    manager.requestSerializer.timeoutInterval = timeoutInterval;
    //设置缓存策略
    manager.requestSerializer.cachePolicy = NSURLRequestUseProtocolCachePolicy|NSURLRequestReloadIgnoringLocalCacheData;
    //设置解析
    manager.responseSerializer.acceptableContentTypes = [NSSet setWithObjects:@"text/json", @"text/plain", @"text/html",@"charset=utf-8",@"application/json",@"text/javascript", nil];
    
    //请求头
    NSString *token = [UserLoginTool getToken];
//    KLog(@"token == %@",token);
    [manager.requestSerializer setValue:token forHTTPHeaderField:@"token"];
    NSString * version = [[[NSBundle mainBundle] infoDictionary] objectForKey:@"CFBundleShortVersionString"];
    [manager.requestSerializer setValue:version forHTTPHeaderField:@"version"];
    
    // seqnum, 唯一序列号,格式 产品ID+UID(未登录写0)+UNIX时间戳+6位随机数
    NSString * uid = @"0";
    if ([YkTool isBlankString:[UserLoginTool getMemberID]]) {
        uid = [UserLoginTool getMemberID];
    }
    NSString * timeStr = [YkTool getNowTimeTimestamp3];
    int a = arc4random() % 999999;
    NSString * suijishu = [NSString stringWithFormat:@"%06d", a];
    NSString * seqnum = [NSString stringWithFormat:@"YKLYIOS%@%@%@",uid,timeStr,suijishu];
    [manager.requestSerializer setValue:seqnum forHTTPHeaderField:@"seqnum"];

    if (CacheKey != nil) {
        NSString *readString = [NSString stringWithFormat:@"%@",CacheKey];
        //将NSString 对象存储到 NSUserDefaults 中
        NSUserDefaults *user = [NSUserDefaults standardUserDefaults];
        NSDictionary *responseObjectDict = [user objectForKey:readString];
        //回掉缓存
        if (responseObjectDict != nil) {
            success(nil, responseObjectDict);
        }
        //写缓存
        success = ^(NSURLSessionDataTask *task, id responseObject) {
            if ([responseObject isKindOfClass:[NSDictionary class]]){
                NSLog(@"AFN数据获取成功-加缓存----------------->%@",URLString);
                success(task,responseObject);
            }else{
                
            }
        };
    }else{
        success = ^(NSURLSessionDataTask *task, id responseObject) {
            if ([responseObject isKindOfClass:[NSDictionary class]]){
                NSLog(@"AFN数据获取成功-无缓存----------------->%@",URLString);
                success(task,responseObject);
            }else{
                
//                [[MBHud shareInstance] showHUDWithText:@"后台数据格式错误" view:nil];
            }
        };
    }
    failure = ^(NSURLSessionDataTask *task, NSError *error){
        NSLog(@"AFN数据获取失败----------------------->%@",URLString);
        failure(task,error);
    };
    
    return [manager POST:URLString parameters:parameters progress:nil success:success failure:failure];
}

//AFN GET
- (nullable NSURLSessionDataTask *)GET:(NSString *)URLString
                            parameters:(id)parameters
                              CacheKey:(NSString *)CacheKey
                       timeoutInterval:(NSTimeInterval)timeoutInterval
                               success:(nullable void (^)(NSURLSessionDataTask *task, id _Nullable responseObject))success
                               failure:(nullable void (^)(NSURLSessionDataTask * _Nullable task, NSError *error))failure{
    AFHTTPSessionManager *manager = [AFHTTPSessionManager manager];
    // 设置请求格式
    manager.requestSerializer = [AFHTTPRequestSerializer serializer];
    // 设置返回格式
    manager.responseSerializer = [AFHTTPResponseSerializer serializer];
    //设置超时时间
    manager.requestSerializer.timeoutInterval = 15.0f;
    //设置缓存策略
    manager.requestSerializer.cachePolicy = NSURLRequestUseProtocolCachePolicy|NSURLRequestReloadIgnoringLocalCacheData;
    //设置解析
    manager.responseSerializer.acceptableContentTypes = [NSSet setWithObjects:@"text/json", @"text/plain", @"text/html",@"charset=utf-8",@"application/json",@"text/javascript", nil];
    
    if (CacheKey != nil) {
        NSString *readString = [NSString stringWithFormat:@"%@",CacheKey];
        //将NSString 对象存储到 NSUserDefaults 中
        NSUserDefaults *user = [NSUserDefaults standardUserDefaults];
        NSDictionary *responseObjectDict = [user objectForKey:readString];
        //回掉缓存
        if (responseObjectDict != nil) {
            success(nil, responseObjectDict);
        }
        //写缓存
        success = ^(NSURLSessionDataTask *task, id responseObject) {
            //有缓存解析
            id  data = [NSJSONSerialization JSONObjectWithData:responseObject options:NSJSONReadingMutableContainers error:nil];
            if ([data isKindOfClass:[NSDictionary class]]){
                NSLog(@"AFN数据获取成功-加缓存----------------->%@",URLString);
                success(task,responseObject);
            }else{
                
            }
        };
    }else{
        success = ^(NSURLSessionDataTask *task, id responseObject) {
            //无缓存解析
            id  data = [NSJSONSerialization JSONObjectWithData:responseObject options:NSJSONReadingMutableContainers error:nil];
            if ([data isKindOfClass:[NSDictionary class]]){
                NSLog(@"AFN数据获取成功-无缓存----------------->%@",URLString);
                success(task,data);
            }else{
                
//                [[MBHud shareInstance] showHUDWithText:@"后台数据格式错误" view:nil];
            }
        };
    }
    failure = ^(NSURLSessionDataTask *task, NSError *error){
        NSLog(@"AFN数据获取失败----------------------->%@",URLString);
        failure(task,error);
    };
    return [manager GET:URLString parameters:parameters progress:nil  success:success failure:failure];
}

//get带请求头的方法
- (nullable NSURLSessionDataTask *)headerGET:(NSString *)URLString
                            parameters:(id)parameters
                              CacheKey:(NSString *)CacheKey
                       timeoutInterval:(NSTimeInterval)timeoutInterval
                               success:(nullable void (^)(NSURLSessionDataTask *task, id _Nullable responseObject))success
                               failure:(nullable void (^)(NSURLSessionDataTask * _Nullable task, NSError *error))failure{
    AFHTTPSessionManager *manager = [AFHTTPSessionManager manager];
    // 设置请求格式
    manager.requestSerializer = [AFHTTPRequestSerializer serializer];
    // 设置返回格式
    manager.responseSerializer = [AFHTTPResponseSerializer serializer];
    //设置超时时间
    manager.requestSerializer.timeoutInterval = 20.0f;
    //设置缓存策略
    manager.requestSerializer.cachePolicy = NSURLRequestUseProtocolCachePolicy|NSURLRequestReloadIgnoringLocalCacheData;
    //设置解析
    manager.responseSerializer.acceptableContentTypes = [NSSet setWithObjects:@"text/json", @"text/plain", @"text/html",@"charset=utf-8",@"application/json",@"text/javascript", nil];
    //请求头
    NSString *token = [UserLoginTool getToken];
    [manager.requestSerializer setValue:token forHTTPHeaderField:@"token"];
    NSString * version = [[[NSBundle mainBundle] infoDictionary] objectForKey:@"CFBundleShortVersionString"];
    [manager.requestSerializer setValue:version forHTTPHeaderField:@"version"];
    // seqnum, 唯一序列号,格式 产品ID+UID(未登录写0)+UNIX时间戳+6位随机数
    NSString * uid = @"0";
    if ([YkTool isBlankString:[UserLoginTool getMemberID]]) {
        uid = [UserLoginTool getMemberID];
    }
    NSString * timeStr = [YkTool getNowTimeTimestamp3];
    int a = arc4random() % 100000;
    NSString * suijishu = [NSString stringWithFormat:@"%06d", a];
    NSString * seqnum = [NSString stringWithFormat:@"YKLYIOS%@%@%@",uid,timeStr,suijishu];
    [manager.requestSerializer setValue:seqnum forHTTPHeaderField:@"seqnum"];

    if (CacheKey != nil) {
        NSString *readString = [NSString stringWithFormat:@"%@",CacheKey];
        //将NSString 对象存储到 NSUserDefaults 中
        NSUserDefaults *user = [NSUserDefaults standardUserDefaults];
        NSDictionary *responseObjectDict = [user objectForKey:readString];
        //回掉缓存
        if (responseObjectDict != nil) {
            success(nil, responseObjectDict);
        }
        //写缓存
        success = ^(NSURLSessionDataTask *task, id responseObject) {
            //有缓存解析
            id  data = [NSJSONSerialization JSONObjectWithData:responseObject options:NSJSONReadingMutableContainers error:nil];
            if ([data isKindOfClass:[NSDictionary class]]){
                NSLog(@"AFN数据获取成功-加缓存----------------->%@",URLString);
                success(task,responseObject);
            }else{

            }
        };
    }else{
        success = ^(NSURLSessionDataTask *task, id responseObject) {
            //无缓存解析
            id  data = [NSJSONSerialization JSONObjectWithData:responseObject options:NSJSONReadingMutableContainers error:nil];
            if ([data isKindOfClass:[NSDictionary class]]){
                NSLog(@"AFN数据获取成功-无缓存----------------->%@",URLString);
                success(task,data);
            }else{
                
//                [[MBHud shareInstance] showHUDWithText:@"后台数据格式错误" view:nil];
            }
        };
    }
    failure = ^(NSURLSessionDataTask *task, NSError *error){
        NSLog(@"AFN数据获取失败----------------------->%@",URLString);
        failure(task,error);
    };
    return [manager GET:URLString parameters:parameters progress:nil  success:success failure:failure];
}


//post请求的总方法
-(NSURLSessionDataTask *)getDataPOST:(NSString *)URLString Paramter:(id)paramter
                            CacheKey:(NSString *)CacheKey
                             success:(void (^)(NSURLSessionDataTask *task, id responseObject))success
                             failure:(void (^)(NSURLSessionDataTask *task, NSError *error))failure{

    return [self POST:URLString parameters:paramter CacheKey:nil timeoutInterval:30.0f success:success failure:failure];
}

//需要请求头的post方法
-(NSURLSessionDataTask *)getWithHeaderDataPOST:(NSString *)URLString Paramter:(id)paramter
                                      CacheKey:(NSString *)CacheKey
                                       success:(void (^)(NSURLSessionDataTask *task, id responseObject))success
                                       failure:(void (^)(NSURLSessionDataTask *task, NSError *error))failure{

    return [self headerPOST:URLString parameters:paramter CacheKey:nil timeoutInterval:90.0f success:success failure:failure];
}

//get请求的总方法
-(NSURLSessionDataTask *)getDataGET:(NSString *)URLString
                           CacheKey:(NSString *)CacheKey
                            success:(void (^)(NSURLSessionDataTask *task, id responseObject))success
                            failure:(void (^)(NSURLSessionDataTask *task, NSError *error))failure{

    return [self GET:URLString parameters:nil CacheKey:nil timeoutInterval:10.0f success:success failure:failure];
}


//需要请求头的get方法
-(NSURLSessionDataTask *)getWithHeaderDataGET:(NSString *)URLString
                                     CacheKey:(NSString *)CacheKey
                                      success:(void (^)(NSURLSessionDataTask *task, id responseObject))success
                                      failure:(void (^)(NSURLSessionDataTask *task, NSError *error))failure{

    return [self headerGET:URLString parameters:nil CacheKey:nil timeoutInterval:10.0 success:success failure:failure];
}

@end
