//
//  YkTool.h
//  Ykly
//
//  Created by zhaoyanqing on 16/6/6.
//  Copyright © 2016年 yonyou. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <CoreText/CoreText.h>
#import <ImageIO/ImageIO.h>

/*
 *   ¥ 金钱符号
 */

typedef void(^faild)();
typedef void(^success)(UIImage *image,UIView *view);

@interface YkTool : NSObject

//费用明细的背景遮罩图
@property(nonatomic,strong)UIView *priceDetailBackView;
@property (nonatomic, copy) NSString *expensesTitleStr;
@property (nonatomic, copy) NSString *expensesScribStr;

+ (YkTool *)defultYKTool;

// 贝塞尔画圆角
+ (void)maskLayerView:(UIView *)maskView byRoundingCorners:(UIRectCorner)corners maskcornerRadii:(CGSize)size;

+ (NSAttributedString *)setAttributeStrWithStr:(NSString *)str fontSize:(NSInteger)fontSize color:(UIColor *)color specialFontSize:(NSInteger)specialFontSize specialColor:(UIColor *)specialColor range:(NSRange)range;

+ (NSAttributedString *)setAttributeStrWithStr:(NSString *)str specialFontSize:(NSInteger)specialFontSize specialColor:(UIColor *)specialColor range:(NSRange)range;

-(void)updataWindowsWithString:(NSString *)string succes:(success)success;

- (NSString *)changeToNSstringWith:(id)dict;

//邮箱验证 MODIFIED BY HELENSONG
+ (BOOL)tf_isValidateEmail:(NSString *)email;

//手机号码的验证
+ (BOOL)validateMobile:(NSString *)mobileNum;

//身份证号码的验证
+(BOOL)validateIdentifyCard:(NSString *)identityCard;

//护照的验证
//+ (BOOL)passportNum:(NSString *)value;

//验证是否包含中文字符
+ (BOOL)IsChinese:(NSString *)str;
+ (BOOL)validateIdentifyName:(NSString *)string;

//个人中心验证用户名昵称
+ (BOOL)validateUserNickName:(NSString *)string;

//个人中心验证用户名中文名字
+ (BOOL)validateUserCNName:(NSString *)string;

//个人中心验证用户名英文名字
+ (BOOL)validateUserENName:(NSString *)string;

// 匹配发票纳税人识别码 数字和字母组合 匹配数字和字母组合
+ (BOOL)checkTaxCode:(NSString *) taxCode;

// 验证验证码是否是数字
+ (BOOL)inputShouldNumber:(NSString *)inputString;
// 计算字符串宽度高
+ (CGSize)getStringWidthWithString:(NSString *)string WithFont:(CGFloat)font;

//计算label字体的宽高
- (CGRect)getTotalHeightWithString:(NSString *)string withFontSize:(NSInteger)fontSize;

//计算label字体的宽高
+ (CGRect)getTotalHeightWithString:(NSString *)string WithWidth:(NSInteger)width WithFont:(NSInteger)font;

//设置自定义字体
+ (UIFont*)customFontWithPath:(NSString*)path size:(CGFloat)size;

//返回多少行
+(CGFloat)getLineNum:(NSString*)str  font:(UIFont*)font labelWidth:(CGFloat)width;

//异步下载网络图片 判断是否url是否有效
-(void)downloadImageWithUrl:(NSString *)imageDownloadURLStr success:(success)success faild:(faild)faild;

//修剪图片
- ( UIImage *)imageWithImageSimple:( UIImage *)image scaledToSize:( CGSize )newSize;

//从图片中取出指定大小
- (UIImage *)imageFromImage:(UIImage *)image inRect:(CGRect)rect;

//从图片中取出旋转后的图片
- (UIImage *)image:(UIImage *)image rotation:(UIImageOrientation)orientation;

//是否全身数字的判断
- (BOOL)isPureNumandCharacters:(NSString *)string;

//无网络提示刷新
- (void)showNetworkRefreshViewWithController:(UIViewController *)viewController;

//图片转二进制
+(NSArray*)imageFormat:(NSArray*)ImageArray;

//判断iphone机型
+ (NSString *)getCurrentDeviceModel;

//传身份证返回生日字符串
- (NSString *)birthdayStrFromIdentityCard:(NSString *)numberStr;

//传身份证返回性别字符串
- (NSString *)getIdentityCardSex:(NSString *)numberStr;

//通过穿进去的NSDate类型的日期得到周几
- (NSString*)weekdayStringFromDate:(NSDate*)inputDate;

//得到图片的一部分
+ (UIImage *)getSubImage:(CGRect)rect inImage:(UIImage*)image;

//得到现在日期是周几
+ (NSString *)getWeekDayString:(NSDate *)date;

// 当前时间是否在特定时间段内
+ (NSString *)isPeriodOfTime:(NSString *)currentTime;

/// 获取省略号字符串
+ (NSString *)getEllipsisStr:(NSString *)originalStr length:(NSInteger)length;

/// 获取区间字符串
+ (NSString *)getRegionStr:(NSString *)originalStr length:(NSInteger)length;

/**
 * 判断相隔几天
 */
+ (long)intervalFromLastDate: (NSString *) dateString1 toTheDate:(NSString *) dateString2;

// 根据日期获取月份和日期
+ (NSString *)getMonthAndDay:(NSString *)day;
// 根据日期获取月份和日期 并拼接周几
+ (NSString *)getMonthAndDayAndweek:(NSString *)day;
// 计算当前日期之后多少天的日期
+ (NSString *)foo:(NSString *)nowDay afterDay:(NSInteger)afterDay;

//今天日期
+ (NSString *)isToday;

// 格林威治时间转换为北京时间
+ (NSDate *)getLocalDate:(NSDate *)date;

// 获取两个日期之间的日期数组
+ (NSArray *)getDateArrayBetweenTwoDate:(NSString *)checkIn andCheckOut:(NSString *)checkOut;

//获取月份第一天和追后一天的
+ (NSArray *)getMonthFirstAndLastDayWith:(NSString *)dateStr;

//字典排序
+ (NSArray *)sortedDictionarybyLowercaseString:(NSDictionary *)dict;

// 通过静态json返回对应城市的三字码或三字码对应的城市（两参数只能同时一个有值，另一个传空串即可）
+ (NSString *)getCityNameOrCityCodeWith:(NSString *)cityCode orCityName:(NSString *)cityName;

//数组按key进行多组重排
+ (NSArray *)getTheArrForKey:(NSArray *)array;

//获取网络时间
+ (NSDate *)getInternetDate;

//计算年龄
+ (NSString *)dateToOld:(NSDate *)bornDate withCurrentDate:(NSDate *)currentDate;

//计算年龄(精确到天)
+ (NSString *)dateToDetailOld:(NSDate *)bornDate;

//图片截取
+ (UIImage *)captureView:(UIView*)subView;

//通过url给算出图片大小
+ (CGSize)getImageSizeWithURL:(id)URL;
+ (void)aaaaa;

/**
 * 获取View所在的控制器
 */
+ (UIViewController *)viewControllerWithView:(UIView *)view;
/**
 * 获取当前控制器
 */
+ (UIViewController*)currentViewController;
/**
 * 判断字符串为空
 */
+ (BOOL)isBlankString:(NSString *)aStr;
/**
 * 判断字典为空
 */
+ (BOOL)checkDictIsValided:(NSDictionary *)dict;
/**
 * 判断数组为空
 */
+ (BOOL)checkArrayIsValided:(NSArray *)arr;
/**
 * 去掉html字符串标签
*/
+ (NSString *)filterHTML:(NSString *)html;
/**
 * 时间戳转时间字符串
 */
+ (NSString *)convertStrToTime:(NSString *)timeStr;
/// 当前时间戳
+ (NSString *)getNowTimeTimestamp3;
/**
 * json转字典
 */
+ (NSDictionary *)dictionaryWithJsonString:(NSString *)jsonString;
/**
 * 取两个字符之间的内容
 */
+ (NSString *)toStr:(NSString *)str startStr:(NSString *)startStr endStr:(NSString *)endStr;
/**
 * 验证是否有Key
 */
+ (BOOL)majorDic:(NSMutableDictionary *)majorDic comparisonKey:(NSString *)comparisonKey;
/**
 * 根据传入数组计算设定每行几个后返回的行数
 */
+ (CGFloat)getLineCountWithArray:(NSArray *)array andWCount:(int)Wcount;
/**
 * 字典转json
 */
+ (NSString*)idToJson:(id )objc;
/**
 * 字符串转时间
 */
+ (NSDate *)dateToString:(NSString *)dateStr;


- (NSString *)expressPriceDoubleAndInt:(double)price;

//出游人类型和数组转换
- (NSString *)getIDKindsWithCategory:(NSString *)category;

- (NSString *)getIDCategoryWithkinds:(NSString *)kinds;

- (NSInteger )getCommonContactTypeVCKinds:(NSString *)kinds;

- (NSString *)idType:(NSString *)type;
/**
 * 提示窗样式
 */
- (void)baseAlertWithView:(UIView *)view title:(NSString *)title message:(NSString *)message okStr:(NSString *)okStr noStr:(NSString *)noStr ok:(void(^)(void))ok no:(void (^)(void))no;
/**
 * 透视宝默认用户信息
 */
- (void)setAddTouShiBaoUser;

/// 传递字符串获取 NSDate
+ (NSDate *)x_GetDateWithFormate:(NSString *)formate andString:(NSString *)str;



/// 计算相差时间
+ (NSInteger)x_GetDisFromDate:(NSDate *)fromDate toDate:(NSDate *)toDate withFormate:(NSString *)formate;
//判断版本
+ (BOOL )isFirstLauch;


/// 验证身份证
+ (BOOL)checkIDCard:(NSString *)identityCard;

/// 获取本地历史记录
+ (NSMutableArray *)getSelectHistoryFromLocal;

@end
