//
//  YkTool.m
//  Ykly
//
//  Created by zhaoyanqing on 16/6/6.
//  Copyright © 2016年 yonyou. All rights reserved.


#import "YkTool.h"
#include <sys/types.h>
#include <sys/sysctl.h>

@interface YkTool()

@property (copy, nonatomic) success succeed;
@property (copy,nonatomic) faild fail;

@property (nonatomic, strong) UIImage *image;

@property (nonatomic, strong) UIViewController *viewController;

@property (nonatomic, strong) NSDateFormatter * dateFormatter;
@end

@implementation YkTool

+ (YkTool *)defultYKTool{

    static YkTool *manager = nil;
    static dispatch_once_t onceToken;
    dispatch_once(&onceToken, ^{
        
        manager = [[YkTool alloc] init];
    });
    return manager;
}

+ (void)maskLayerView:(UIView *)maskView byRoundingCorners:(UIRectCorner)corners maskcornerRadii:(CGSize)size {
    
    [maskView layoutIfNeeded];
    
    UIBezierPath *maskPath = [UIBezierPath bezierPathWithRoundedRect:maskView.bounds byRoundingCorners:corners cornerRadii:CGSizeMake(size.width, size.height)];
    CAShapeLayer *maskLayer = [[CAShapeLayer alloc] init];
    maskLayer.frame = maskView.bounds;
    maskLayer.path = maskPath.CGPath;
    maskView.layer.mask = maskLayer;
}

#pragma mark - 修剪图片

- ( UIImage *)imageWithImageSimple:( UIImage *)image scaledToSize:( CGSize )newSize {
    // Create a graphics image context
//    UIGraphicsBeginImageContext (newSize);
    UIGraphicsBeginImageContextWithOptions(newSize, NO, 2.0);
    // Tell the old image to draw in this new context, with the desired
    // new size
    [image drawInRect : CGRectMake ( 0 , 0 ,newSize. width ,newSize. height )];
    // Get the new image from the context
    UIImage * newImage = UIGraphicsGetImageFromCurrentImageContext ();
    // End the context
    UIGraphicsEndImageContext ();
    // Return the new image.
    return newImage;
}

- (UIImage *)imageFromImage:(UIImage *)image inRect:(CGRect)rect{
    
    //将UIImage转换成CGImageRef
    CGImageRef sourceImageRef = [image CGImage];
    
    //按照给定的矩形区域进行剪裁
    CGImageRef newImageRef = CGImageCreateWithImageInRect(sourceImageRef, rect);
    
    //将CGImageRef转换成UIImage
    UIImage *newImage = [UIImage imageWithCGImage:newImageRef];
    
    //返回剪裁后的图片
    return newImage;
}

- (UIImage *)image:(UIImage *)image rotation:(UIImageOrientation)orientation{
    
    long double rotate = 0.0;
    CGRect rect;
    float translateX = 0;
    float translateY = 0;
    float scaleX = 1.0;
    float scaleY = 1.0;
    
    switch (orientation) {
        case UIImageOrientationLeft:
            rotate = M_PI_2;
            rect = CGRectMake(0, 0, image.size.height, image.size.width);
            translateX = 0;
            translateY = -rect.size.width;
            scaleY = rect.size.width/rect.size.height;
            scaleX = rect.size.height/rect.size.width;
            break;
        case UIImageOrientationRight:
            rotate = 33 * M_PI_2;
            rect = CGRectMake(0, 0, image.size.height, image.size.width);
            translateX = -rect.size.height;
            translateY = 0;
            scaleY = rect.size.width/rect.size.height;
            scaleX = rect.size.height/rect.size.width;
            break;
        case UIImageOrientationDown:
            rotate = M_PI;
            rect = CGRectMake(0, 0, image.size.width, image.size.height);
            translateX = -rect.size.width;
            translateY = -rect.size.height;
            break;
        default:
            rotate = 0.0;
            rect = CGRectMake(0, 0, image.size.width, image.size.height);
            translateX = 0;
            translateY = 0;
            break;
    }
    
    UIGraphicsBeginImageContext(rect.size);
    CGContextRef context = UIGraphicsGetCurrentContext();
    //做CTM变换
    CGContextTranslateCTM(context, 0.0, rect.size.height);
    CGContextScaleCTM(context, 1.0, -1.0);
    CGContextRotateCTM(context, rotate);
    CGContextTranslateCTM(context, translateX, translateY);
    
    CGContextScaleCTM(context, scaleX, scaleY);
    //绘制图片
    CGContextDrawImage(context, CGRectMake(0, 0, rect.size.width, rect.size.height), image.CGImage);
    
    UIImage *newPic = UIGraphicsGetImageFromCurrentImageContext();
    
    return newPic;
}

- (NSString *)changeToNSstringWith:(id)dict{
    
    NSData *jsonData = [NSJSONSerialization dataWithJSONObject:dict options:NSJSONWritingPrettyPrinted error:nil];
    NSString *jsonString = [[NSString alloc] initWithData:jsonData encoding:NSUTF8StringEncoding];
    return jsonString;
}

#pragma mark - 计算字符串宽高度
+ (CGSize)getStringWidthWithString:(NSString *)string WithFont:(CGFloat)font
{
    UIFont *LYFont = [UIFont systemFontOfSize:font];
    NSDictionary *strAtt = @{NSFontAttributeName : LYFont};
    CGSize strSize = [string sizeWithAttributes:strAtt];
    
    return strSize;
}

#pragma mark - 计算label的高度
- (CGRect)getTotalHeightWithString:(NSString *)string withFontSize:(NSInteger)fontSize{
    CGRect rect = [string boundingRectWithSize:CGSizeMake(kScreenWidth - 20 - 100, CGFLOAT_MAX) options:NSStringDrawingUsesLineFragmentOrigin attributes:@{NSFontAttributeName:[UIFont systemFontOfSize:fontSize]} context:nil];
    return rect;
}

+ (CGRect)getTotalHeightWithString:(NSString *)string WithWidth:(NSInteger)width WithFont:(NSInteger)font{
    
    CGRect rect = [string boundingRectWithSize:CGSizeMake(width, CGFLOAT_MAX) options:NSStringDrawingUsesLineFragmentOrigin attributes:@{NSFontAttributeName:[UIFont systemFontOfSize:font]} context:nil];
    return rect;
}


#pragma mark - 计算label的行数
+(CGFloat)getLineNum:(NSString*)str  font:(UIFont*)font labelWidth:(CGFloat)width
{
    if (str.length<1)
    {
        return 0;
    }
    
    CGFloat oneRowHeight = [@"占位" sizeWithAttributes:@{NSFontAttributeName:font}].height;
    CGSize textSize = [str boundingRectWithSize:CGSizeMake(width, CGFLOAT_MAX) options:NSStringDrawingUsesLineFragmentOrigin attributes:@{NSFontAttributeName:font} context:nil].size;
    CGFloat rows = textSize.height / oneRowHeight;
    
    return rows;
}


+ (NSAttributedString *)setAttributeStrWithStr:(NSString *)str fontSize:(NSInteger)fontSize color:(UIColor *)color specialFontSize:(NSInteger)specialFontSize specialColor:(UIColor *)specialColor range:(NSRange)range {
    
    NSMutableAttributedString *muStr = [[NSMutableAttributedString alloc] initWithString:str attributes:@{NSFontAttributeName:[UIFont systemFontOfSize:fontSize], NSForegroundColorAttributeName:color}];
    [muStr setAttributes:@{NSForegroundColorAttributeName:specialColor, NSFontAttributeName:[UIFont systemFontOfSize:specialFontSize]} range:range];
    return muStr;
}

+ (NSAttributedString *)setAttributeStrWithStr:(NSString *)str specialFontSize:(NSInteger)specialFontSize specialColor:(UIColor *)specialColor range:(NSRange)range {
    
    NSMutableAttributedString * muStr = [[NSMutableAttributedString alloc] initWithString:str];
    [muStr setAttributes:@{NSForegroundColorAttributeName:specialColor, NSFontAttributeName:[UIFont systemFontOfSize:specialFontSize]} range:range];
    return muStr;
}

/*邮箱验证 MODIFIED BY HELENSONG*/
+ (BOOL)tf_isValidateEmail:(NSString *)email
{
    NSString *emailRegex = @"[A-Z0-9a-z._%+-]+@[A-Za-z0-9.-]+\\.[A-Za-z]{1,4}";
    NSPredicate *emailTest = [NSPredicate predicateWithFormat:@"SELF MATCHES %@", emailRegex];
    return [emailTest evaluateWithObject:email];
}

+ (BOOL)validateIdentifyName:(NSString *)string {
    
    NSString *name = @"[a-zA-Z\u4e00-\u9fa5]{1,30}$";
    NSPredicate *nameTest = [NSPredicate predicateWithFormat:@"SELF MATCHES %@", name];
    return [nameTest evaluateWithObject:string];
}

+ (BOOL)validateUserNickName:(NSString *)string {
    NSString *name = @"[\u4e00-\u9fa5_a-zA-Z0-9]+$";
    NSPredicate *nameTest = [NSPredicate predicateWithFormat:@"SELF MATCHES %@", name];
    return [nameTest evaluateWithObject:string];
}

+ (BOOL)validateUserCNName:(NSString *)string {
    NSString *name = @"^[\u4e00-\u9fa5\\s·]+$";
    NSPredicate *nameTest = [NSPredicate predicateWithFormat:@"SELF MATCHES %@", name];
    return [nameTest evaluateWithObject:string];
}

+(BOOL)validateUserENName:(NSString *)string {
    NSString *name = @"^([a-zA-Z\\s]+)$";
    NSPredicate *nameTest = [NSPredicate predicateWithFormat:@"SELF MATCHES %@", name];
    return [nameTest evaluateWithObject:string];
}

//判断验证码全是数字
+ (BOOL)inputShouldNumber:(NSString *)inputString {
    if (inputString.length == 0) return NO;
    NSString *regex =@"[0-9]*";
    NSPredicate *pred = [NSPredicate predicateWithFormat:@"SELF MATCHES %@",regex];
    return [pred evaluateWithObject:inputString];
}

#pragma 正则匹配用户密码数字和字母组合
+ (BOOL)checkTaxCode:(NSString *) taxCode
{
    NSString *pattern = @"[a-zA-Z0-9]+$";
    NSPredicate *pred = [NSPredicate predicateWithFormat:@"SELF MATCHES %@", pattern];
    BOOL isMatch = [pred evaluateWithObject:taxCode];
    return isMatch;
    
}

/*手机号码验证 MODIFIED BY HELENSONG*/
//产品不要号段验证了 说号段现在太多 不管号段对不对了 12345678910也可以拿接口
+ (BOOL)validateMobile:(NSString *)mobileNum {
//    NSString *regex = @"^[1][3-9]\\d{9}$";
//    NSString *regex = @"^1(3[0-9]|4[56789]|5[0-9]|6[6]|7[0-9]|8[0-9]|9[89])\\d{8}$";
    NSString *regex =@"[0-9]*";
    NSPredicate *pred = [NSPredicate predicateWithFormat:@"SELF MATCHES %@", regex];
    if ([pred evaluateWithObject:mobileNum] && mobileNum.length == 11) {
        return YES;
    }else{
        return NO;
    }
}

+(BOOL)validateIdentifyCard:(NSString *)identityCard{

    BOOL flag;
    if (identityCard.length <= 0)
    {
        flag = NO;
        return flag;
    }
    
    NSString *regex2 = @"^(^[1-9]\\d{7}((0\\d)|(1[0-2]))(([0|1|2]\\d)|3[0-1])\\d{3}$)|(^[1-9]\\d{5}[1-9]\\d{3}((0\\d)|(1[0-2]))(([0|1|2]\\d)|3[0-1])((\\d{4})|\\d{3}[Xx])$)$";
    NSPredicate *identityCardPredicate = [NSPredicate predicateWithFormat:@"SELF MATCHES %@",regex2];
    flag = [identityCardPredicate evaluateWithObject:identityCard];
    
    
    //如果通过该验证，说明身份证格式正确，但准确性还需计算
    if(flag)
    {
        if(identityCard.length==18)
        {
            //将前17位加权因子保存在数组里
            NSArray * idCardWiArray = @[@"7", @"9", @"10", @"5", @"8", @"4", @"2", @"1", @"6", @"3", @"7", @"9", @"10", @"5", @"8", @"4", @"2"];
            
            //这是除以11后，可能产生的11位余数、验证码，也保存成数组
            NSArray * idCardYArray = @[@"1", @"0", @"10", @"9", @"8", @"7", @"6", @"5", @"4", @"3", @"2"];
            
            //用来保存前17位各自乖以加权因子后的总和
            
            NSInteger idCardWiSum = 0;
            for(int i = 0;i < 17;i++)
            {
                NSInteger subStrIndex = [[identityCard substringWithRange:NSMakeRange(i, 1)] integerValue];
                NSInteger idCardWiIndex = [[idCardWiArray objectAtIndex:i] integerValue];
                
                idCardWiSum+= subStrIndex * idCardWiIndex;
                
            }
            
            //计算出校验码所在数组的位置
            NSInteger idCardMod=idCardWiSum%11;
            
            //得到最后一位身份证号码
            NSString * idCardLast= [identityCard substringWithRange:NSMakeRange(17, 1)];
            
            //如果等于2，则说明校验码是10，身份证号码最后一位应该是X
            if(idCardMod==2)
            {
                if([idCardLast isEqualToString:@"X"]||[idCardLast isEqualToString:@"x"])
                {
                    return flag;
                }else
                {
                    flag =  NO;
                    return flag;
                }
            }else
            {
                //用计算出的验证码与最后一位身份证号码匹配，如果一致，说明通过，否则是无效的身份证号码
                if([idCardLast isEqualToString: [idCardYArray objectAtIndex:idCardMod]])
                {
                    return flag;
                }
                else
                {
                    flag =  NO;
                    return flag;
                }
            }
        }
        else
        {
            flag =  NO;
            return flag;
        }
    }
    else
    {
        return flag;
    }
}

+(BOOL)IsChinese:(NSString *)str{

    for(int i=0; i< [str length];i++){
        int a = [str characterAtIndex:i];
        if( a > 0x4e00 && a < 0x9fff)
        {
            //这时候是包含的
            return YES;
        }
        
    }
    return NO;
}

- (BOOL)isPureNumandCharacters:(NSString *)string
{
    string = [string stringByTrimmingCharactersInSet:[NSCharacterSet decimalDigitCharacterSet]];
    if(string.length > 0)
    {
        return NO;
    }
    return YES;  
}


#pragma mark - 添加跟mbprogress一样的提示框  可以提示多行  并且可以改变提示框的位置
-(void)updataWindowsWithString:(NSString *)string succes:(success)success {
    
    self.succeed = success;
    UIWindow *windows = [UIApplication sharedApplication].keyWindow;
    
    UIView *view = [[UIView alloc]initWithFrame:CGRectMake(40, SCREEN_HEIGHT/2 - 40, SCREEN_WIDTH - 80, 40)];
    
    view.backgroundColor = [UIColor blackColor];
    
    view.alpha = 0.5f;
    
    view.layer.masksToBounds = YES;
    
    view.layer.cornerRadius = 8.0f;
    
    UILabel *label = [[UILabel alloc]initWithFrame:CGRectMake(0, 0, view.bounds.size.width, 40)];
    
    label.numberOfLines = 3;
    
    label.text = string;
    
    label.textColor = [UIColor whiteColor];
    
    label.textAlignment = NSTextAlignmentCenter;
    
    [windows addSubview:view];
    
    [view addSubview:label];
    self.succeed(nil, view);
    
}

-(void)downloadImageWithUrl:(NSString *)imageDownloadURLStr success:(success)success faild:(faild)faild{

    //成功或失败的block回调
    self.succeed = success;
    self.fail = faild;
    __block UIImage *image = [[UIImage alloc] init];
    //图片下载链接
    NSURL *imageDownloadURL = [NSURL URLWithString:imageDownloadURLStr];
    
    //将图片下载在异步线程进行
    //创建异步线程执行队列
    dispatch_queue_t asynchronousQueue = dispatch_queue_create("imageDownloadQueue", NULL);
    //创建异步线程
    dispatch_async(asynchronousQueue, ^{
        //网络下载图片  NSData格式
        NSError *error;
        NSData *imageData = [NSData dataWithContentsOfURL:imageDownloadURL options:NSDataReadingMappedIfSafe error:&error];
        image = [UIImage imageWithData:imageData];
        //回到主线程更新UI
        dispatch_async(dispatch_get_main_queue(), ^{
            if (image) {
                
                self.succeed(image,nil);
            }else{
            
                self.fail();
            }
        });
    });
}


- (void)showNetworkRefreshViewWithController:(UIViewController *)viewController{
    UIView *noNetWorkView = [[UIView alloc] initWithFrame:CGRectMake(0, 0, SCREEN_WIDTH, SCREEN_HEIGHT-SafeAreaTopHeight)];
    noNetWorkView.backgroundColor = [UIColor blueColor];
    
    UILabel *label = [UILabel new];
    [noNetWorkView addSubview:label];
    [label mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerX.equalTo(noNetWorkView.mas_centerX);
        make.top.equalTo(noNetWorkView).offset(50*KWidth_Scale);
        make.height.mas_equalTo(18);
    }];
    label.text = @"网络状况不佳";
    label.textAlignment = NSTextAlignmentCenter;
    
    UIButton *btn = [UIButton new];
    [noNetWorkView addSubview:btn];
    [btn mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.equalTo(label.mas_bottom).offset(10*KWidth_Scale);
        make.centerX.equalTo(noNetWorkView.mas_centerX);
        make.width.mas_equalTo(80*KWidth_Scale);
        make.height.mas_equalTo(35*KWidth_Scale);
    }];
    [btn setTitle:@"刷新" forState:UIControlStateNormal];
}


//图片转二进制
+(NSArray*)imageFormat:(NSArray*)ImageArray{
    
    NSMutableArray *ImageData = [NSMutableArray array];
    for(int j = 0;j<ImageArray.count;j++){
        
        NSData *mydata = UIImageJPEGRepresentation([ImageArray objectAtIndex:j], 0.3);
        NSUInteger length = [mydata length];
        Byte *dataByte = (Byte*)[mydata bytes];
        NSMutableString *imageData = [[NSMutableString alloc] init];
        for (int i=0; i<length; i++) {
            
            [imageData appendFormat:@"%d,",dataByte[i]];
        }
        NSString *Data = [imageData substringToIndex:imageData.length-1];
        
        [ImageData addObject:Data];
    }
    return ImageData;
}

//自定义字体
+(UIFont*)customFontWithPath:(NSString*)path size:(CGFloat)size {
    NSURL *fontUrl = [NSURL fileURLWithPath:path];
    CGDataProviderRef fontDataProvider = CGDataProviderCreateWithURL((__bridge CFURLRef)fontUrl);
    CGFontRef fontRef = CGFontCreateWithDataProvider(fontDataProvider);
    CGDataProviderRelease(fontDataProvider);
    CTFontManagerRegisterGraphicsFont(fontRef, NULL);
    NSString *fontName = CFBridgingRelease(CGFontCopyPostScriptName(fontRef));
    UIFont *font = [UIFont fontWithName:fontName size:size];
    CGFontRelease(fontRef);
    return font;
}

+ (NSString *)getCurrentDeviceModel
{
    int mib[2];
    size_t len;
    char *machine;

    mib[0] = CTL_HW;
    mib[1] = HW_MACHINE;
    sysctl(mib, 2, NULL, &len, NULL, 0);
    machine = malloc(len);
    sysctl(mib, 2, machine, &len, NULL, 0);

    NSString *platform = [NSString stringWithCString:machine encoding:NSASCIIStringEncoding];
    free(machine);
    // iPhone
    if ([platform isEqualToString:@"iPhone1,1"]) return @"iPhone2G";
    if ([platform isEqualToString:@"iPhone1,2"]) return @"iPhone3G";
    if ([platform isEqualToString:@"iPhone2,1"]) return @"iPhone3GS";
    if ([platform isEqualToString:@"iPhone3,1"]) return @"iPhone4";
    if ([platform isEqualToString:@"iPhone3,2"]) return @"iPhone4";
    if ([platform isEqualToString:@"iPhone3,3"]) return @"iPhone4";
    if ([platform isEqualToString:@"iPhone4,1"]) return @"iPhone4S";
    if ([platform isEqualToString:@"iPhone5,1"]) return @"iPhone5";
    if ([platform isEqualToString:@"iPhone5,2"]) return @"iPhone5";
    if ([platform isEqualToString:@"iPhone5,3"]) return @"iPhone5c";
    if ([platform isEqualToString:@"iPhone5,4"]) return @"iPhone5c";
    if ([platform isEqualToString:@"iPhone6,1"]) return @"iPhone5s";
    if ([platform isEqualToString:@"iPhone6,2"]) return @"iPhone5s";
    if ([platform isEqualToString:@"iPhone7,2"]) return @"iPhone6";
    if ([platform isEqualToString:@"iPhone7,1"]) return @"iPhone6Plus";
    if ([platform isEqualToString:@"iPhone8,1"]) return @"iPhone6s";
    if ([platform isEqualToString:@"iPhone8,2"]) return @"iPhone6sPlus";
    if ([platform isEqualToString:@"iPhone8,3"]) return @"iPhoneSE";
    if ([platform isEqualToString:@"iPhone8,4"]) return @"iPhoneSE";
    if ([platform isEqualToString:@"iPhone9,1"]) return @"iPhone7";
    if ([platform isEqualToString:@"iPhone9,2"]) return @"iPhone7Plus";

    //iPod Touch
    if ([platform isEqualToString:@"iPod1,1"])   return @"iPodTouch";
    if ([platform isEqualToString:@"iPod2,1"])   return @"iPodTouch2G";
    if ([platform isEqualToString:@"iPod3,1"])   return @"iPodTouch3G";
    if ([platform isEqualToString:@"iPod4,1"])   return @"iPodTouch4G";
    if ([platform isEqualToString:@"iPod5,1"])   return @"iPodTouch5G";
    if ([platform isEqualToString:@"iPod7,1"])   return @"iPodTouch6G";

    //iPad
    if ([platform isEqualToString:@"iPad1,1"])   return @"iPad";
    if ([platform isEqualToString:@"iPad2,1"])   return @"iPad2";
    if ([platform isEqualToString:@"iPad2,2"])   return @"iPad2";
    if ([platform isEqualToString:@"iPad2,3"])   return @"iPad2";
    if ([platform isEqualToString:@"iPad2,4"])   return @"iPad2";
    if ([platform isEqualToString:@"iPad3,1"])   return @"iPad3";
    if ([platform isEqualToString:@"iPad3,2"])   return @"iPad3";
    if ([platform isEqualToString:@"iPad3,3"])   return @"iPad3";
    if ([platform isEqualToString:@"iPad3,4"])   return @"iPad4";
    if ([platform isEqualToString:@"iPad3,5"])   return @"iPad4";
    if ([platform isEqualToString:@"iPad3,6"])   return @"iPad4";

    //iPad Air
    if ([platform isEqualToString:@"iPad4,1"])   return @"iPadAir";
    if ([platform isEqualToString:@"iPad4,2"])   return @"iPadAir";
    if ([platform isEqualToString:@"iPad4,3"])   return @"iPadAir";
    if ([platform isEqualToString:@"iPad5,3"])   return @"iPadAir2";
    if ([platform isEqualToString:@"iPad5,4"])   return @"iPadAir2";

    //iPad mini
    if ([platform isEqualToString:@"iPad2,5"])   return @"iPadmini1G";
    if ([platform isEqualToString:@"iPad2,6"])   return @"iPadmini1G";
    if ([platform isEqualToString:@"iPad2,7"])   return @"iPadmini1G";
    if ([platform isEqualToString:@"iPad4,4"])   return @"iPadmini2";
    if ([platform isEqualToString:@"iPad4,5"])   return @"iPadmini2";
    if ([platform isEqualToString:@"iPad4,6"])   return @"iPadmini2";
    if ([platform isEqualToString:@"iPad4,7"])   return @"iPadmini3";
    if ([platform isEqualToString:@"iPad4,8"])   return @"iPadmini3";
    if ([platform isEqualToString:@"iPad4,9"])   return @"iPadmini3";
    if ([platform isEqualToString:@"iPad5,1"])   return @"iPadmini4";
    if ([platform isEqualToString:@"iPad5,2"])   return @"iPadmini4";

    if ([platform isEqualToString:@"i386"])      return @"iPhoneSimulator";
    if ([platform isEqualToString:@"x86_64"])    return @"iPhoneSimulator";
    return platform;
}
//得到图片的一部分
+ (UIImage *)getSubImage:(CGRect)rect inImage:(UIImage*)image {
    CGImageRef subImageRef = CGImageCreateWithImageInRect(image.CGImage, rect);

    CGRect smallBounds = CGRectMake(0, 0, CGImageGetWidth(subImageRef), CGImageGetHeight(subImageRef));

    UIGraphicsBeginImageContext(smallBounds.size);

    CGContextRef context = UIGraphicsGetCurrentContext();

    CGContextDrawImage(context, smallBounds, subImageRef);

    UIImage* smallImage = [UIImage imageWithCGImage:subImageRef];
    CFRelease(subImageRef);

    UIGraphicsEndImageContext();

    return smallImage;
}

//传身份证返回生日字符串
- (NSString *)birthdayStrFromIdentityCard:(NSString *)numberStr {

    NSMutableString *result = [NSMutableString stringWithCapacity:0];
    NSString *year = nil;
    NSString *month = nil;

    BOOL isAllNumber = YES;
    NSString *day = nil;
    if([numberStr length]<14)
        return result;

    //**截取前14位
    NSString *fontNumer = [numberStr substringWithRange:NSMakeRange(0, 13)];

    //**检测前14位否全都是数字;
    const char *str = [fontNumer UTF8String];
    const char *p = str;
    while (*p!='\0') {
        if(!(*p>='0'&&*p<='9'))
            isAllNumber = NO;
        p++;
    }

    if(!isAllNumber)
        return result;

    year = [numberStr substringWithRange:NSMakeRange(6, 4)];
    month = [numberStr substringWithRange:NSMakeRange(10, 2)];
    day = [numberStr substringWithRange:NSMakeRange(12,2)];

    [result appendString:year];
    [result appendString:@"-"];
    [result appendString:month];
    [result appendString:@"-"];
    [result appendString:day];
    return result;
}
//根据身份证号性别
- (NSString *)getIdentityCardSex:(NSString *)numberStr {
    int sexInt=[[numberStr substringWithRange:NSMakeRange(16,1)] intValue];

    if(sexInt%2!=0)
    {
        return @"男";
    }
    else
    {
        return @"女";
    }
}

- (NSString*)weekdayStringFromDate:(NSDate*)inputDate {
    
    NSArray *weekdays = [NSArray arrayWithObjects: [NSNull null], @"周日", @"周一", @"周二", @"周三", @"周四", @"周五", @"周六", nil];
    NSCalendar *calendar = [[NSCalendar alloc] initWithCalendarIdentifier:NSCalendarIdentifierGregorian];
    NSTimeZone *timeZone = [[NSTimeZone alloc] initWithName:@"Asia/Shanghai"];
    [calendar setTimeZone: timeZone];
    NSCalendarUnit calendarUnit = NSCalendarUnitWeekday;
    NSDateComponents *theComponents = [calendar components:calendarUnit fromDate:inputDate];
    return [weekdays objectAtIndex:theComponents.weekday];
}

+ (NSString *)isToday {
    
    NSDateFormatter *formatter = [[NSDateFormatter alloc] init];
    [formatter setDateFormat:@"yyyy-MM-dd"];
    NSDate* date = [NSDate dateWithTimeIntervalSinceNow:0];
    NSString *today = [formatter stringFromDate:date];
    return today;
}

+ (NSString *)foo:(NSString *)nowDay afterDay:(NSInteger)afterDay
{
    NSDateFormatter * dateFormatter = [NSDateFormatter new];
    [dateFormatter setDateFormat: @"yyyy-MM-dd"];
    NSDate *date = [dateFormatter dateFromString:nowDay];
    NSDate * newDate =  [date dateByAddingTimeInterval:(60 * 60 * 24 * afterDay)];
    NSString *lastDay = [dateFormatter stringFromDate:newDate];
    NSLog(@"%@ 天之后是 %@",nowDay,lastDay);
    return lastDay;
}

+ (NSString *)getWeekDayString:(NSDate *)date {
    NSCalendar *calendar = [[NSCalendar alloc] initWithCalendarIdentifier:NSCalendarIdentifierGregorian];
    NSDateComponents *comps = [[NSDateComponents alloc] init];
    NSInteger unitFlags = NSCalendarUnitYear | NSCalendarUnitMonth | NSCalendarUnitDay | NSCalendarUnitWeekday |
    NSCalendarUnitHour | NSCalendarUnitMinute | NSCalendarUnitSecond;
    comps = [calendar components:unitFlags fromDate:date];

    if ([comps weekday] == 1) {
        return @"周日";
        
    } else if ([comps weekday] == 2) {
        return @"周一";

    } else if ([comps weekday] == 3) {
         return @"周二";

    } else if ([comps weekday] == 4) {
         return @"周三";

    } else if ([comps weekday] == 5) {
         return @"周四";

    } else if ([comps weekday] == 6) {
         return @"周五";

    } else if ([comps weekday] == 7) {
        return @"周六";
    }
    return @"";
}

+ (NSString *)isPeriodOfTime:(NSString *)currentTime{
    NSDateFormatter* formatter = [[NSDateFormatter alloc] init];
    [formatter setDateFormat:@"HH:mm"];
    NSString *timeString = currentTime;
    NSDate *date = [formatter dateFromString:timeString];
    
    NSString *timeString1 = @"00:00";
    NSString *timeString2 = @"05:59";
    NSDate *date1 = [formatter dateFromString:timeString1];
    NSDate *date2 = [formatter dateFromString:timeString2];
    if (([date compare:date2] == NSOrderedAscending && [date compare:date1] == NSOrderedDescending) || [date compare:date2] == NSOrderedSame || [date compare:date1] == NSOrderedSame) {
        return @"1";
    }
    
    NSString *timeString3 = @"06:00";
    NSString *timeString4 = @"11:59";
    NSDate *date3 = [formatter dateFromString:timeString3];
    NSDate *date4 = [formatter dateFromString:timeString4];
    if (([date compare:date4] == NSOrderedAscending  && [date compare:date3] == NSOrderedDescending) || [date compare:date4] == NSOrderedSame || [date compare:date3] == NSOrderedSame) {
        return @"2";
    }
    
    NSString *timeString5 = @"12:00";
    NSString *timeString6 = @"17:59";
    NSDate *date5 = [formatter dateFromString:timeString5];
    NSDate *date6 = [formatter dateFromString:timeString6];
    if (([date compare:date6] == NSOrderedAscending && [date compare:date5] == NSOrderedDescending) || [date compare:date6] == NSOrderedSame || [date compare:date5] == NSOrderedSame) {
        return @"3";
    }
    
    NSString *timeString7 = @"18:00";
    NSString *timeString8 = @"23:59";
    NSDate *date7 = [formatter dateFromString:timeString7];
    NSDate *date8 = [formatter dateFromString:timeString8];
    if (([date compare:date8] == NSOrderedAscending && [date compare:date7] == NSOrderedDescending) || [date compare:date8] == NSOrderedSame || [date compare:date7] == NSOrderedSame) {
        return @"4";
    }
    
    return @"0";
}

+ (NSString *)getMonthAndDay:(NSString *)day {
    NSArray *comeDateArr = [day componentsSeparatedByString:@"-"];
    NSString *comeStr = [NSString stringWithFormat:@"%@月%@日",comeDateArr[1],comeDateArr[2]];
    return comeStr;
}

+ (NSString *)getMonthAndDayAndweek:(NSString *)day {
    
    NSDateFormatter *formatter = [[NSDateFormatter alloc] init];
    [formatter setDateStyle:NSDateFormatterMediumStyle];
    [formatter setTimeStyle:NSDateFormatterShortStyle];
    [formatter setDateFormat:@"yyyy-MM-dd"];
    NSDate* date = [formatter dateFromString:day];
    
    NSArray *comeDateArr = [day componentsSeparatedByString:@"-"];
    NSString *comeStr = [NSString stringWithFormat:@"%@月%@日",comeDateArr[1],comeDateArr[2]];
    NSString *weekStr = [self getWeekDayString:date];
    NSString * DateStrAndWeek = [NSString stringWithFormat:@"%@%@",comeStr,weekStr];
    return DateStrAndWeek;
}

/// 获取省略号字符串
+ (NSString *)getEllipsisStr:(NSString *)originalStr length:(NSInteger)length {
    if (originalStr.length < length + 2) {
        return originalStr;
    } else {
        NSString *ellipsisStr = [originalStr substringToIndex:length];
        return [NSString stringWithFormat:@"%@…", ellipsisStr];
    }
}

/// 获取区间字符串
+ (NSString *)getRegionStr:(NSString *)originalStr length:(NSInteger)length {
    NSString *origion = checkNull(originalStr);
    if (origion.length < length + 1) {
        return origion;
    } else {
        NSString *regionStr = [origion substringFromIndex:origion.length - length];
        return regionStr;
    }
}

+ (long)intervalFromLastDate: (NSString *) dateString1 toTheDate:(NSString *) dateString2{
    
    //创建两个日期
    NSDateFormatter *dateFormatter = [[NSDateFormatter alloc] init];
    [dateFormatter setDateFormat:@"yyyy-MM-dd"];
    NSDate *startDate = [dateFormatter dateFromString:dateString1];
    NSDate *endDate = [dateFormatter dateFromString:dateString2];

    //利用NSCalendar比较日期的差异
    NSCalendar *calendar = [NSCalendar currentCalendar];
    /**
     * 要比较的时间单位,常用如下,可以同时传：
     *    NSCalendarUnitDay : 天
     *    NSCalendarUnitYear : 年
     *    NSCalendarUnitMonth : 月
     *    NSCalendarUnitHour : 时
     *    NSCalendarUnitMinute : 分
     *    NSCalendarUnitSecond : 秒
     */
    NSCalendarUnit unit = NSCalendarUnitYear | NSCalendarUnitMonth | NSCalendarUnitDay;//只比较天数差异
    //比较的结果是NSDateComponents类对象
    NSDateComponents *delta = [calendar components:unit fromDate:startDate toDate:endDate options:0];
    
    return delta.day;
}

// 格林威治时间转换为北京时间
+ (NSDate *)getLocalDate:(NSDate *)date{
    
    NSTimeZone *zone = [NSTimeZone systemTimeZone];
    NSInteger interval = [zone secondsFromGMTForDate: date];
    NSDate *localeDate = [date  dateByAddingTimeInterval: interval];
    return localeDate;
}

// 获取两个日期之间的日期数组
+ (NSArray *)getDateArrayBetweenTwoDate:(NSString *)checkIn andCheckOut:(NSString *)checkOut{
    NSDateFormatter *formatter = [[NSDateFormatter alloc] init];
    [formatter setDateFormat:@"yyyy-MM-dd"];
    [formatter setTimeZone:[NSTimeZone timeZoneWithName:@"Asia/Beijing"]];
    NSDate *checkInDate = [formatter dateFromString:checkIn];
    NSDate *checkOutDate = [formatter dateFromString:checkOut];
    NSDate *startDate = [YkTool getLocalDate:checkInDate];
    NSDate *endDate = [YkTool getLocalDate:checkOutDate];
    long long start = [startDate timeIntervalSince1970];
    long long end = [endDate timeIntervalSince1970];
    long long daytime = 24*60*60;
    long long time = start - start%daytime;
    NSMutableArray *dateArr = [NSMutableArray array];
    while (time <= end) {
        
        NSString *showOldDate = [formatter stringFromDate:[NSDate dateWithTimeIntervalSince1970:time]];
        [dateArr addObject:showOldDate];
        time += daytime;
    }
    
    return dateArr;
}

+ (NSArray *)getMonthFirstAndLastDayWith:(NSString *)dateStr{
    
    NSDateFormatter *format=[[NSDateFormatter alloc] init];
    [format setDateFormat:@"yyyy-MM-dd"];
    NSDate *newDate=[format dateFromString:dateStr];
    double interval = 0;
    NSDate *firstDate = nil;
    NSDate *lastDate = nil;
    NSCalendar *calendar = [NSCalendar currentCalendar];
    
    BOOL OK = [calendar rangeOfUnit:NSCalendarUnitMonth startDate:& firstDate interval:&interval forDate:newDate];
    
    if (OK) {
        lastDate = [firstDate dateByAddingTimeInterval:interval - 1];
    }else {
        return @[@"",@""];
    }
    
    NSDateFormatter *myDateFormatter = [[NSDateFormatter alloc] init];
    [myDateFormatter setDateFormat:@"yyyy-MM-dd"];
    NSString *firstString = [myDateFormatter stringFromDate: firstDate];
    NSString *lastString = [myDateFormatter stringFromDate: lastDate];
    return @[firstString, lastString];
}

+ (NSArray *)sortedDictionarybyLowercaseString:(NSDictionary *)dict{
    
    //将所有的key放进数组
    NSArray *allKeyArray = [dict allKeys];
    
    //序列化器对数组进行排序的block 返回值为排序后的数组
    NSArray *afterSortKeyArray = [allKeyArray sortedArrayUsingComparator:^NSComparisonResult(id  _Nonnull obj1, id  _Nonnull obj2) {
        
        //小写转化
        obj1 = [obj1 lowercaseString];
        obj2 = [obj2 lowercaseString];
        //排序操作
        NSComparisonResult resuest = [obj1 compare:obj2];
        return resuest;
    }];
    
    NSLog(@"afterSortKeyArray:%@",afterSortKeyArray);
    
    //通过排列的key值获取value
    NSMutableArray *valueArray = [NSMutableArray array];
    for (NSString *sortsing in afterSortKeyArray) {
        NSString *valueString = [dict objectForKey:sortsing];
        [valueArray addObject:valueString];
    }
    NSLog(@"valueArray:%@",valueArray);
    return valueArray;
}

+ (NSString *)getCityNameOrCityCodeWith:(NSString *)cityCode orCityName:(NSString *)cityName{
    NSData *JSONData = [NSData dataWithContentsOfFile:[[NSBundle mainBundle] pathForResource:@"airTicketCitys_data" ofType:@"json"]];
    NSDictionary *dataDic = [NSJSONSerialization JSONObjectWithData:JSONData options:NSJSONReadingAllowFragments error:nil];
    NSArray *dataArray = dataDic[@"inlandCities"];
    NSArray *data2Array = dataDic[@"overseasCities"];
    if ([checkNull(cityCode) isEqualToString:@""] && ![checkNull(cityName) isEqualToString:@""]) {
        for (NSDictionary *dict in dataArray) {
            if ([dict[@"city_name"] isEqualToString:cityName]) {
                return dict[@"city_code"];
            }
        }
        for (NSDictionary *dict in data2Array) {
            if ([dict[@"city_name"] isEqualToString:cityName]) {
                return dict[@"city_code"];
            }
        }
    }else if (![checkNull(cityCode) isEqualToString:@""] && [checkNull(cityName) isEqualToString:@""]){
        for (NSDictionary *dict in dataArray) {
            if ([dict[@"city_code"] isEqualToString:cityCode]) {
                return dict[@"city_name"];
            }
        }
        for (NSDictionary *dict in data2Array) {
            if ([dict[@"city_code"] isEqualToString:cityCode]) {
                return dict[@"city_name"];
            }
        }
    }else{
        return @"";
    }
    
    return @"";
}

// 数组按key进行多组重排
+ (NSArray *)getTheArrForKey:(NSArray *)array
{
    NSMutableArray *dictArr = [NSMutableArray array];
    for (int i = 0; i < array.count; i++) {
        NSDictionary *dict = array[i];
        [dictArr addObject:dict];
    }
    
    [dictArr sortUsingComparator:^NSComparisonResult(id obj1, id obj2) {
        
        NSDictionary *myDic1 = obj1;
        NSDictionary *myDic2 = obj2;
        
        
        NSString * aStr = [myDic1 objectForKey:@"key"];
        NSString * bStr = [myDic2 objectForKey:@"key"];
        
        if ([aStr compare:bStr options:NSCaseInsensitiveSearch] == NSOrderedDescending) {
            return NSOrderedDescending;
        }
        else if ([aStr compare:bStr options:NSCaseInsensitiveSearch] == NSOrderedAscending){
            return NSOrderedAscending;
        }
        else {
            return NSOrderedSame;
        }
    }];
    // 2、对数组进行分组
    // 遍历,创建组数组,组数组中的每一个元素是一个模型数组
    NSMutableArray *_groupArr = [NSMutableArray array];
    NSMutableArray *currentArr = [NSMutableArray array];
    [currentArr addObject:dictArr[0]];
    [_groupArr addObject:currentArr];
    // 如果不止一个,才要动画添加
    if(dictArr.count > 1){
        for (int i = 1; i < dictArr.count; i++) {
            // 先取出组数组中  上一个模型数组的第一个字典模型的groupID
            NSMutableArray *preModelArr = [_groupArr objectAtIndex:_groupArr.count-1];
            NSString * preGroupID = [[preModelArr objectAtIndex:0] objectForKey:@"key"];
            // 取出当前字典,根据groupID比较,如果相同则添加到同一个模型数组;如果不相同,说明不是同一个组的
            NSDictionary *currentDict = dictArr[i];
            NSString * groupID = [currentDict objectForKey:@"key"];
            if (groupID == preGroupID) {
                [currentArr addObject:currentDict];
            }else{
                // 如果不相同,说明 有新的一组,那么创建一个模型数组,并添加到组数组_groupArr
                currentArr = [NSMutableArray array];
                [currentArr addObject:currentDict];
                [_groupArr addObject:currentArr];
            }
        }
    }
    return _groupArr;
}

+ (NSDate *)getInternetDate {
    NSString *urlString = @"http://m.baidu.com";
    // 实例化NSMutableURLRequest，并进行参数配置
    NSMutableURLRequest *request = [[NSMutableURLRequest alloc] init];
    [request setURL:[NSURL URLWithString: urlString]];
    [request setCachePolicy:NSURLRequestReloadIgnoringCacheData];
    [request setTimeoutInterval: 2];
    [request setHTTPShouldHandleCookies:FALSE];
    [request setHTTPMethod:@"GET"];
    NSHTTPURLResponse *response;
    [[NSURLSession sharedSession] dataTaskWithRequest:request];
    NSString *date = [[response allHeaderFields] objectForKey:@"Date"];
    date = [date substringFromIndex:5];
    date = [date substringToIndex:[date length]-4];
    NSDateFormatter *dMatter = [[NSDateFormatter alloc] init];
    dMatter.locale = [[NSLocale alloc] initWithLocaleIdentifier:@"en_US_POSIX"];
    [dMatter setDateFormat:@"ddMMMyyyyHH:mm:ss"];
    NSDate *netDate = [[dMatter dateFromString:date] dateByAddingTimeInterval:60*60*8];
    return netDate;
}


+ (NSString *)dateToOld:(NSDate *)bornDate withCurrentDate:(NSDate *)currentDate{
    //创建日历(格里高利历)
    NSCalendar *calendar = [NSCalendar currentCalendar];
    //设置component的组成部分
    NSUInteger unitFlags = NSCalendarUnitYear | NSCalendarUnitMonth | NSCalendarUnitDay | NSCalendarUnitHour | NSCalendarUnitMinute | NSCalendarUnitSecond;
    //按照组成部分格式计算出生日期与现在时间的时间间隔
    NSDateComponents *date = [calendar components:unitFlags fromDate:bornDate
                                           toDate:currentDate options:0];
    //判断年龄大小,以确定返回格式
    if ([date year] > 0) {
        return [NSString stringWithFormat:(@"%ld"),(long)[date year]];
    } else {
        return @"0";
    }
}


+ (NSString *)dateToDetailOld:(NSDate *)bornDate {
    //获得上面的网络时间
    NSDate *currentDate = [self getInternetDate];
    //创建日历(格里高利历)
    NSCalendar *calendar = [NSCalendar currentCalendar];
    //设置component的组成部分
    NSUInteger unitFlags = NSCalendarUnitYear | NSCalendarUnitMonth | NSCalendarUnitDay | NSCalendarUnitHour | NSCalendarUnitMinute | NSCalendarUnitSecond ;
    //按照组成部分格式计算出生日期与现在时间的时间间隔
    NSDateComponents *date = [calendar components:unitFlags fromDate:bornDate toDate:currentDate options:0];
    //判断年龄大小,以确定返回格式
    if( [date year] > 0){
        return [NSString stringWithFormat:(@"%ld岁%ld月%ld天"),(long)[date year],(long)[date month],(long)[date day]];
        
    }
    else if([date month] >0){
        return [NSString stringWithFormat:(@"%ld月%ld天"),(long)[date month],(long)[date day]];
        
    }
    else if([date day]>0){
        return [NSString stringWithFormat:(@"%ld天"),(long)[date day]];
        
    }
    else {
        return @"0天";
    }
}
#pragma mark - 图像截取
+ (UIImage *)captureView:(UIView*)subView {

    CGSize pixelSizeOfImage = subView.bounds.size;

    UIGraphicsBeginImageContextWithOptions(pixelSizeOfImage, NO, 0.0);

    // 画图
    [subView.layer renderInContext:UIGraphicsGetCurrentContext()];

    // 获取图像
    UIImage *image = UIGraphicsGetImageFromCurrentImageContext();
    UIGraphicsEndImageContext();

    return image;
}

+ (CGSize)getImageSizeWithURL:(id)URL {
    NSURL * url = nil;
    if ([URL isKindOfClass:[NSURL class]]) {
        url = URL;
    }
    if ([URL isKindOfClass:[NSString class]]) {
        url = [NSURL URLWithString:URL];
    }
    if (!URL) {
        return CGSizeZero;
    }
    CGImageSourceRef imageSourceRef = CGImageSourceCreateWithURL((CFURLRef)url, NULL);
    CGFloat width = 0, height = 0;
    if (imageSourceRef) {
        CFDictionaryRef imageProperties = CGImageSourceCopyPropertiesAtIndex(imageSourceRef, 0, NULL);
        //以下是对手机32位、64位的处理
        if (imageProperties != NULL) {
            CFNumberRef widthNumberRef = CFDictionaryGetValue(imageProperties, kCGImagePropertyPixelWidth);
#if defined(__LP64__) && __LP64__
            if (widthNumberRef != NULL) {
                CFNumberGetValue(widthNumberRef, kCFNumberFloat64Type, &width);
            }
            CFNumberRef heightNumberRef = CFDictionaryGetValue(imageProperties, kCGImagePropertyPixelHeight);
            if (heightNumberRef != NULL) {
                CFNumberGetValue(heightNumberRef, kCFNumberFloat64Type, &height);
            }
#else
            if (widthNumberRef != NULL) {
                CFNumberGetValue(widthNumberRef, kCFNumberFloat32Type, &width);
            }
            CFNumberRef heightNumberRef = CFDictionaryGetValue(imageProperties, kCGImagePropertyPixelHeight);
            if (heightNumberRef != NULL) {
                CFNumberGetValue(heightNumberRef, kCFNumberFloat32Type, &height);
            }
#endif
            CFRelease(imageProperties);
        }

        CFRelease(imageSourceRef);
    }
    return CGSizeMake(width, height);
}

+ (void)aaaaa{
    NSDictionary *proxySettings = (__bridge NSDictionary *)(CFNetworkCopySystemProxySettings());
    NSArray *proxies = (__bridge NSArray *)(CFNetworkCopyProxiesForURL((__bridge CFURLRef _Nonnull)([NSURL URLWithString:BASE_URL]), (__bridge CFDictionaryRef _Nonnull)(proxySettings)));
    NSLog(@"\n%@",proxies);
    NSDictionary *settings = proxies[0];
    NSLog(@"%@",[settings objectForKey:(NSString *)kCFProxyHostNameKey]);
    NSLog(@"%@",[settings objectForKey:(NSString *)kCFProxyPortNumberKey]);
    NSLog(@"%@",[settings objectForKey:(NSString *)kCFProxyTypeKey]);
    if ([[settings objectForKey:(NSString *)kCFProxyTypeKey] isEqualToString:@"kCFProxyTypeNone"]){
        NSLog(@"没代理");
    }else{
        NSLog(@"设置了代理");
    }
}
+ (UIViewController *)viewControllerWithView:(UIView *)view
{
    for (UIView* next = [view superview]; next; next = next.superview) {
        UIResponder *nextResponder = [next nextResponder];
        if ([nextResponder isKindOfClass:[UIViewController class]]) {
            return (UIViewController *)nextResponder;
        }
    }
    return nil;
}
+ (BOOL)isBlankString:(NSString *)aStr {
    if (!aStr) {
        return NO;
    }
    if ([aStr isKindOfClass:[NSNull class]]) {
        return NO;
    }
    if (!aStr.length) {
        return NO;
    }
    if (([aStr isEqualToString:@"<null>"])) {
        return NO;
    }
    if (([aStr isEqualToString:@"(null)"])) {
        return NO;
    }
    NSCharacterSet *set = [NSCharacterSet whitespaceAndNewlineCharacterSet];
    NSString *trimmedStr = [aStr stringByTrimmingCharactersInSet:set];
    if (!trimmedStr.length) {
        return NO;
    }
    return YES;
}
+ (BOOL)checkDictIsValided:(NSDictionary *)dict{
    
    if ([dict isKindOfClass:[NSNull class]] || dict.allValues.count == 0 || dict.allKeys.count == 0 ) {
        return NO;
    }else{
        return YES;
    }
}
+ (BOOL)checkArrayIsValided:(NSArray *)arr{
    
    if ([arr isKindOfClass:[NSNull class]] || arr.count == 0 || arr == nil) {
        return NO;
    }else{
        return YES;
    }
}
+ (NSString *)filterHTML:(NSString *)html
{
    NSScanner * scanner = [NSScanner scannerWithString:html];
    NSString * text = nil;
    while([scanner isAtEnd]==NO)
    {
        [scanner scanUpToString:@"<" intoString:nil];
        [scanner scanUpToString:@">" intoString:&text];
        html = [html stringByReplacingOccurrencesOfString:[NSString stringWithFormat:@"%@>",text] withString:@""];
    }
    return html;
}

+ (NSString *)convertStrToTime:(NSString *)timeStr
{
    long long time=[timeStr longLongValue];
    //    如果服务器返回的是13位字符串，需要除以1000，否则显示不正确(13位其实代表的是毫秒，需要除以1000)
    //    long long time=[timeStr longLongValue] / 1000;
    NSDate *date = [[NSDate alloc]initWithTimeIntervalSince1970:time];
    NSDateFormatter *formatter = [[NSDateFormatter alloc]init];
    [formatter setDateFormat:@"yyyy-MM-dd HH:mm:ss"];
    NSString*timeString=[formatter stringFromDate:date];
    return timeString;
}
+(NSString *)getNowTimeTimestamp3{
    
    NSDateFormatter *formatter = [[NSDateFormatter alloc] init] ;
    
    [formatter setDateStyle:NSDateFormatterMediumStyle];
    
    [formatter setTimeStyle:NSDateFormatterShortStyle];
    
    [formatter setDateFormat:@"YYYY-MM-dd HH:mm:ss SSS"]; // ----------设置你想要的格式,hh与HH的区别:分别表示12小时制,24小时制
    
    //设置时区,这个对于时间的处理有时很重要
    
    NSTimeZone* timeZone = [NSTimeZone timeZoneWithName:@"Asia/Shanghai"];
    
    [formatter setTimeZone:timeZone];
    
    NSDate *datenow = [NSDate date];//现在时间,你可以输出来看下是什么格式
    
    NSString *timeSp = [NSString stringWithFormat:@"%ld", (long)[datenow timeIntervalSince1970]*1000];
    
    return timeSp;
}

+ (NSString *)toStr:(NSString *)str startStr:(NSString *)startStr endStr:(NSString *)endStr
{
    NSRange startRange = [str rangeOfString:startStr];
    NSRange endRange = [str rangeOfString:endStr];
    NSRange range = NSMakeRange(startRange.location + startRange.length, endRange.location - startRange.location - startRange.length);
    NSString *result = [str substringWithRange:range];
    return result;
}
+ (BOOL)majorDic:(NSMutableDictionary *)majorDic comparisonKey:(NSString *)comparisonKey{
    NSString * value = @"";
    if([[majorDic allKeys] containsObject:comparisonKey]){
        value = [majorDic valueForKey:comparisonKey];
        NSLog(@"value === %@",value);
        return YES;
    }else{
        NSLog(@"没有key === %@",comparisonKey);
        return NO;
    }
}

+ (CGFloat)getLineCountWithArray:(NSArray *)array andWCount:(int)Wcount{
    CGFloat lineCount = 0;
    if (array.count > 0) {
        CGFloat actCount = array.count%Wcount;
        if (actCount == 0) {
            lineCount = array.count/Wcount-1;
        }else{
            lineCount = array.count/Wcount;
        }
    }
    
    return lineCount;
}
+ (NSString*)idToJson:(id )objc
{
    if (objc == nil) {
        return nil;
    }
    NSError *parseError = nil;
    NSData *jsonData    = [NSJSONSerialization dataWithJSONObject:objc options:NSJSONWritingPrettyPrinted error:&parseError];
    //    NSLog(@"%@", parseError);
    return [[NSString alloc] initWithData:jsonData encoding:NSUTF8StringEncoding];
}

+ (NSDate *)dateToString:(NSString *)dateStr
{
    // 实例化NSDateFormatter
    NSDateFormatter *formatter = [[NSDateFormatter alloc] init];
    // 设置日期格式
    [formatter setDateFormat:@"yyyy-MM-dd HH:mm:ss"];
    // 设置为UTC时区
    // 这里如果不设置为UTC时区，会把要转换的时间字符串定为当前时区的时间（东八区）转换为UTC时区的时间
    [formatter setTimeZone:[NSTimeZone timeZoneWithAbbreviation:@"UTC"]];
    // 要转换的日期字符串
    NSString *dateString = dateStr;
    NSDate *someDay = [formatter dateFromString:dateString];
    return someDay;
}

+ (UIViewController*)currentViewController{
    UIViewController* vc = [UIApplication sharedApplication].keyWindow.rootViewController;
    while (1) {
        if ([vc isKindOfClass:[UITabBarController class]]) {
            vc = ((UITabBarController*)vc).selectedViewController;
        }
        if ([vc isKindOfClass:[UINavigationController class]]) {
            vc = ((UINavigationController*)vc).visibleViewController;
        }
        if (vc.presentedViewController) {
            vc = vc.presentedViewController;
        }else{
            break;
        }
    }
    return vc;
}

- (NSString *)expressPriceDoubleAndInt:(double)price {
    
    NSString *strPrice = @"";
    
    if (price - (int)price >0) {
        //有小数点
        strPrice = [NSString stringWithFormat:@"%.2f",price];
    }else
    {
        strPrice = [NSString stringWithFormat:@"%d",(int)price];
    }
    return strPrice;
}

- (NSString *)getIDKindsWithCategory:(NSString *)category {
    
    NSString *kinds = @"";
    NSInteger integer = [category integerValue];
    
    switch (integer) {
        case 1:
            kinds = @"身份证";
            break;
        case 2:
            kinds = @"护照";
            break;
        case 3:
            kinds = @"军官证";
            break;
        case 4:
            kinds = @"港澳通行证";
            break;
        case 5:
            kinds = @"台胞证";
            break;
        case 6:
            kinds = @"回乡证";
            break;
        case 7:
            kinds = @"户口簿";
            break;
        case 8:
            kinds = @"台湾通行证";
            break;
        case 9:
            kinds = @"士兵证";
            break;
            
        default:
            break;
    }
    return kinds;
}

- (NSString *)getIDCategoryWithkinds:(NSString *)kinds {
    
    NSString *category = @"";
    if ([kinds isEqualToString:@"身份证"]) {
        category = @"1";
    }else if ([kinds isEqualToString:@"护照"]) {
        category = @"2";
    }else if ([kinds isEqualToString:@"军官证"]) {
        category = @"3";
    }else if ([kinds isEqualToString:@"港澳通行证"]) {
        category = @"4";
    }else if ([kinds isEqualToString:@"台胞证"]) {
        category = @"5";
    }else if ([kinds isEqualToString:@"回乡证"]) {
        category = @"6";
    }else if ([kinds isEqualToString:@"户口簿"]) {
        category = @"7";
    }else if ([kinds isEqualToString:@"台湾通行证"]) {
        category = @"8";
    }else if ([kinds isEqualToString:@"士兵证"]) {
        category = @"9";
    }
    return category;
    
}

- (NSInteger )getCommonContactTypeVCKinds:(NSString *)kinds {
    /*
     0签证 1火车票  2国内机票 3国际机票 4国内线路 5国际线路
     */
    NSInteger CommonContactType = [kinds integerValue];
    switch (CommonContactType) {
        case 0: //国际
            CommonContactType = 5;
            break;
        case 5: //邮轮
            CommonContactType = 5;
            break;
        case 1: //国内
            CommonContactType = 4;
            break;
        case 2: //周边
            CommonContactType = 4;
            break;
        case 11: //短途游
            CommonContactType = 4;
            break;
        case 80: //国际机票
            CommonContactType = 3;
            break;
        case 8: //国内机票
            CommonContactType = 2;
            break;
        case 100: //火车票
            CommonContactType = 1;
            break;
        case 6: //签证
            CommonContactType = 0;
            break;
        default:
            break;
    }
    return CommonContactType;
}


- (NSString *)idType:(NSString *)type
{
    NSString * idType = @"在职人员";
    if ([type isEqualToString:@"1"]) {
        idType = @"在职人员";
    }
    if ([type isEqualToString:@"2"]) {
        idType = @"自由职业";
    }
    if ([type isEqualToString:@"3"]) {
        idType = @"在校学生";
    }
    if ([type isEqualToString:@"4"]) {
        idType = @"退休人员";
    }
    if ([type isEqualToString:@"5"]) {
        idType = @"学龄前儿童";
    }
    return idType;
}
- (void)baseAlertWithView:(UIView *)view title:(NSString *)title message:(NSString *)message okStr:(NSString *)okStr noStr:(NSString *)noStr ok:(void(^)(void))ok no:(void (^)(void))no
{
    UIAlertController * alertController = [UIAlertController alertControllerWithTitle:title message:message preferredStyle:UIAlertControllerStyleAlert];
    
    if (noStr.length != 0) {
        UIAlertAction * cancelAction = [UIAlertAction actionWithTitle:noStr style:UIAlertActionStyleDefault handler:^(UIAlertAction * _Nonnull action) {
            no();
        }];
        [alertController addAction:cancelAction];
        [cancelAction setValue:[UIColor colorWithHexString:@"#4C4C4C"] forKey:@"_titleTextColor"];
    }
    
    //确定
    UIAlertAction * okAction = [UIAlertAction actionWithTitle:okStr style:UIAlertActionStyleDefault handler:^(UIAlertAction * _Nonnull action) {
        ok();
    }];
    [alertController addAction:okAction];
    [okAction setValue:[UIColor colorWithHexString:PurpleColorHex] forKey:@"_titleTextColor"];
    
    //标题
    NSMutableAttributedString *alertControllerStr = [[NSMutableAttributedString alloc] initWithString:title];
    [alertControllerStr addAttribute:NSForegroundColorAttributeName value:[UIColor colorWithHexString:@"#4C4C4C"] range:NSMakeRange(0, alertControllerStr.length)];
    [alertControllerStr addAttribute:NSFontAttributeName value:[UIFont fontWithName:@"PingFangSC-Regular" size: 15] range:NSMakeRange(0, alertControllerStr.length)];
    [alertController setValue:alertControllerStr forKey:@"attributedTitle"];
    
    //详情
    NSMutableAttributedString * alertControllerMessageStr = [[NSMutableAttributedString alloc] initWithString:message];
    [alertControllerMessageStr addAttribute:NSForegroundColorAttributeName value:[UIColor colorWithHexString:@"#999999"] range:NSMakeRange(0, alertControllerMessageStr.length)];
    [alertControllerMessageStr addAttribute:NSFontAttributeName value:[UIFont fontWithName:@"PingFangSC-Regular" size: 13] range:NSMakeRange(0, alertControllerMessageStr.length)];
    [alertController setValue:alertControllerMessageStr forKey:@"attributedMessage"];
    
    
    [[YkTool viewControllerWithView:view] presentViewController:alertController animated:YES completion:nil];

}
- (void)setAddTouShiBaoUser
{
    NSMutableDictionary * dic = [NSMutableDictionary dictionary];
    dic[@"CWSA_USER_NAME"] = [UserLoginTool getPhoneNum];
    dic[@"CWSA_USER_TOKEN"] = [UserLoginTool getToken];
//    [[SmartAgent sharedInstance] setupUserIdentificationWithProperties:dic];
}

/// 获取nsdate
+ (NSDate *)x_GetDateWithFormate:(NSString *)formate andString:(NSString *)str {
    
    NSDateFormatter *formatter = [[NSDateFormatter alloc] init] ;
    [formatter setDateFormat:formate];
    // 由字符串转换成时间
    NSDate *date2 = [formatter dateFromString:str];
    // 获取系统的时区，
    NSTimeZone * zone = [NSTimeZone systemTimeZone];
    // 获取时间的时区与指定时区zone之间相差的秒数
    NSInteger interval = [zone secondsFromGMTForDate:date2];
    NSDate *systemZoneDate = [date2 dateByAddingTimeInterval:interval];

    
    return systemZoneDate;
}

+ (NSInteger)x_GetDisFromDate:(NSDate *)fromDate toDate:(NSDate *)toDate withFormate:(NSString *)formate {
    
    //创建日期格式化对象
    NSDateFormatter *dateFormatter=[[NSDateFormatter alloc] init];
    [dateFormatter setDateFormat:formate];
    //取两个日期对象的时间间隔：
    //这里的NSTimeInterval 并不是对象，是基本型，其实是double类型，是由c定义的:typedef double NSTimeInterval;
    NSTimeInterval time=[toDate timeIntervalSinceDate:fromDate];
    int days=((int)time)/(3600*24);
    //int hours=((int)time)%(3600*24)/3600;
    //NSString *dateContent=[[NSString alloc] initWithFormat:@"%i天%i小时",days,hours];
    return days;
}
+ (BOOL )isFirstLauch{
    //获取当前版本号
    NSDictionary *infoDic = [[NSBundle mainBundle] infoDictionary];
    NSString *currentAppVersion = infoDic[@"CFBundleShortVersionString"];
    //获取上次启动应用保存的appVersion
    NSString *version = [[NSUserDefaults standardUserDefaults] objectForKey:@"appVersion"];
    //版本升级或首次登录
    if (![version isEqualToString:currentAppVersion]) {
        [[NSUserDefaults standardUserDefaults] setObject:currentAppVersion forKey:@"appVersion"];
        [[NSUserDefaults standardUserDefaults] synchronize];
        return YES;
    }else{
        return NO;
    }
}

/// 验证身份证
+ (BOOL)checkIDCard:(NSString *)identityCard {
    //判断是否为空
    if (identityCard==nil||identityCard.length <= 0) {
        return NO;
    }
    //判断是否是18位，末尾是否是x
    NSString *regex2 = @"^(\\d{14}|\\d{17})(\\d|[xX])$";
    NSPredicate *identityCardPredicate = [NSPredicate predicateWithFormat:@"SELF MATCHES %@",regex2];
    if(![identityCardPredicate evaluateWithObject:identityCard]){
        return NO;
    }
    //判断生日是否合法
    NSRange range = NSMakeRange(6,8);
    NSString *datestr = [identityCard substringWithRange:range];
    NSDateFormatter *formatter = [[NSDateFormatter alloc] init];
    [formatter setDateFormat : @"yyyyMMdd"];
    if([formatter dateFromString:datestr]==nil){
        return NO;
    }
    
    //判断校验位
    if(identityCard.length==18)
    {
        NSArray *idCardWi= @[ @"7", @"9", @"10", @"5", @"8", @"4", @"2", @"1", @"6", @"3", @"7", @"9", @"10", @"5", @"8", @"4", @"2" ]; //将前17位加权因子保存在数组里
        NSArray * idCardY=@[ @"1", @"0", @"10", @"9", @"8", @"7", @"6", @"5", @"4", @"3", @"2" ]; //这是除以11后，可能产生的11位余数、验证码，也保存成数组
        int idCardWiSum=0; //用来保存前17位各自乖以加权因子后的总和
        for(int i=0;i<17;i++){
            idCardWiSum+=[[identityCard substringWithRange:NSMakeRange(i,1)] intValue]*[idCardWi[i] intValue];
        }
        
        int idCardMod=idCardWiSum%11;//计算出校验码所在数组的位置
        NSString *idCardLast=[identityCard substringWithRange:NSMakeRange(17,1)];//得到最后一位身份证号码
        
        //如果等于2，则说明校验码是10，身份证号码最后一位应该是X
        if(idCardMod==2){
            if([idCardLast isEqualToString:@"X"]||[idCardLast isEqualToString:@"x"]){
                return YES;
            }else{
                return NO;
            }
        }else{
            //用计算出的验证码与最后一位身份证号码匹配，如果一致，说明通过，否则是无效的身份证号码
            if([idCardLast intValue]==[idCardY[idCardMod] intValue]){
                return YES;
            }else{
                return NO;
            }
        }
    }
    return NO;
}
+ (NSDictionary *)dictionaryWithJsonString:(NSString *)jsonString {
    if (jsonString == nil) {
        return nil;
    }
    
    NSData *jsonData = [jsonString dataUsingEncoding:NSUTF8StringEncoding];
    NSError *err;
    NSDictionary *dic = [NSJSONSerialization JSONObjectWithData:jsonData
                                                        options:NSJSONReadingMutableContainers
                                                          error:&err];
    if(err) {
        return nil;
    }
    return dic;
}

/// 获取本地历史记录
+ (NSMutableArray *)getSelectHistoryFromLocal {
    
    NSUserDefaults * userDef = [NSUserDefaults standardUserDefaults];
    NSMutableArray * arrHis = [userDef objectForKey:kHomeSelectedHistory_APPHome];
    NSArray * arr =  [arrHis copy];
    if (arr.count > KMaxSaveHistoryCount) {
        arr = [arr subarrayWithRange:NSMakeRange(0, KMaxSaveHistoryCount)];
        arrHis = [arr mutableCopy];
    }
    [userDef setObject:arrHis forKey:kHomeSelectedHistory_APPHome];
    [userDef synchronize];
    return arrHis;
}

@end
